// chrome/browser/ui/webui/app_management/app_management.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'chrome/browser/ui/webui/app_management/app_management.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('appManagement.mojom');
  var types$ =
      mojo.internal.exposeNamespace('apps.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'chrome/services/app_service/public/mojom/types.mojom', '../../../../services/app_service/public/mojom/types.mojom.js');
  }


  var ArcPermissionType = {};
  ArcPermissionType.CAMERA = 0;
  ArcPermissionType.LOCATION = 1;
  ArcPermissionType.MICROPHONE = 2;
  ArcPermissionType.NOTIFICATIONS = 3;
  ArcPermissionType.CONTACTS = 4;
  ArcPermissionType.STORAGE = 5;
  ArcPermissionType.MIN_VALUE = 0,
  ArcPermissionType.MAX_VALUE = 5,

  ArcPermissionType.isKnownEnumValue = function(value) {
    switch (value) {
    case 0:
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
      return true;
    }
    return false;
  };

  ArcPermissionType.validate = function(enumValue) {
    var isExtensible = false;
    if (isExtensible || this.isKnownEnumValue(enumValue))
      return validator.validationError.NONE;

    return validator.validationError.UNKNOWN_ENUM_VALUE;
  };
  var PwaPermissionType = {};
  PwaPermissionType.GEOLOCATION = 5;
  PwaPermissionType.NOTIFICATIONS = 6;
  PwaPermissionType.MEDIASTREAM_MIC = 9;
  PwaPermissionType.MEDIASTREAM_CAMERA = 10;
  PwaPermissionType.MIN_VALUE = 5,
  PwaPermissionType.MAX_VALUE = 10,

  PwaPermissionType.isKnownEnumValue = function(value) {
    switch (value) {
    case 5:
    case 6:
    case 9:
    case 10:
      return true;
    }
    return false;
  };

  PwaPermissionType.validate = function(enumValue) {
    var isExtensible = false;
    if (isExtensible || this.isKnownEnumValue(enumValue))
      return validator.validationError.NONE;

    return validator.validationError.UNKNOWN_ENUM_VALUE;
  };

  function App(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  App.prototype.initDefaults_ = function() {
    this.id = null;
    this.type = 0;
    this.isPinned = 0;
    this.title = null;
    this.description = null;
    this.isPolicyPinned = 0;
    this.installSource = 0;
    this.version = null;
    this.size = null;
    this.permissions = null;
    this.hideMoreSettings = false;
    this.hidePinToShelf = false;
  };
  App.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  App.generate = function(generator_) {
    var generated = new App;
    generated.id = generator_.generateString(false);
    generated.type = generator_.generateEnum(0, 7);
    generated.title = generator_.generateString(true);
    generated.description = generator_.generateString(true);
    generated.isPinned = generator_.generateEnum(0, 2);
    generated.isPolicyPinned = generator_.generateEnum(0, 2);
    generated.version = generator_.generateString(true);
    generated.size = generator_.generateString(true);
    generated.permissions = generator_.generateMap(
      function() {
        return generator_.generateUint32();
      },
      function() {
        return generator_.generateStruct(apps.mojom.Permission, false);
      });
    generated.installSource = generator_.generateEnum(0, 6);
    generated.hideMoreSettings = generator_.generateBool();
    generated.hidePinToShelf = generator_.generateBool();
    return generated;
  };

  App.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.id = mutator_.mutateString(this.id, false);
    }
    if (mutator_.chooseMutateField()) {
      this.type = mutator_.mutateEnum(this.type, 0, 7);
    }
    if (mutator_.chooseMutateField()) {
      this.title = mutator_.mutateString(this.title, true);
    }
    if (mutator_.chooseMutateField()) {
      this.description = mutator_.mutateString(this.description, true);
    }
    if (mutator_.chooseMutateField()) {
      this.isPinned = mutator_.mutateEnum(this.isPinned, 0, 2);
    }
    if (mutator_.chooseMutateField()) {
      this.isPolicyPinned = mutator_.mutateEnum(this.isPolicyPinned, 0, 2);
    }
    if (mutator_.chooseMutateField()) {
      this.version = mutator_.mutateString(this.version, true);
    }
    if (mutator_.chooseMutateField()) {
      this.size = mutator_.mutateString(this.size, true);
    }
    if (mutator_.chooseMutateField()) {
      this.permissions = mutator_.mutateMap(this.permissions,
        function(val) {
          return mutator_.mutateUint32(val);
        },
        function(val) {
          return mutator_.mutateStruct(val, apps.mojom.Permission, false);
        });
    }
    if (mutator_.chooseMutateField()) {
      this.installSource = mutator_.mutateEnum(this.installSource, 0, 6);
    }
    if (mutator_.chooseMutateField()) {
      this.hideMoreSettings = mutator_.mutateBool(this.hideMoreSettings);
    }
    if (mutator_.chooseMutateField()) {
      this.hidePinToShelf = mutator_.mutateBool(this.hidePinToShelf);
    }
    return this;
  };
  App.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  App.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  App.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  App.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 80}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate App.id
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate App.type
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 8, types$.AppType);
    if (err !== validator.validationError.NONE)
        return err;


    // validate App.title
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 16, true)
    if (err !== validator.validationError.NONE)
        return err;


    // validate App.description
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 24, true)
    if (err !== validator.validationError.NONE)
        return err;


    // validate App.isPinned
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 12, types$.OptionalBool);
    if (err !== validator.validationError.NONE)
        return err;


    // validate App.isPolicyPinned
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 32, types$.OptionalBool);
    if (err !== validator.validationError.NONE)
        return err;


    // validate App.version
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 40, true)
    if (err !== validator.validationError.NONE)
        return err;


    // validate App.size
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 48, true)
    if (err !== validator.validationError.NONE)
        return err;


    // validate App.permissions
    err = messageValidator.validateMapPointer(offset + codec.kStructHeaderSize + 56, false, codec.Uint32, new codec.PointerTo(types$.Permission), false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate App.installSource
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 36, types$.InstallSource);
    if (err !== validator.validationError.NONE)
        return err;



    return validator.validationError.NONE;
  };

  App.encodedSize = codec.kStructHeaderSize + 72;

  App.decode = function(decoder) {
    var packed;
    var val = new App();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.id =
        decoder.decodeStruct(codec.String);
    val.type =
        decoder.decodeStruct(codec.Int32);
    val.isPinned =
        decoder.decodeStruct(codec.Int32);
    val.title =
        decoder.decodeStruct(codec.NullableString);
    val.description =
        decoder.decodeStruct(codec.NullableString);
    val.isPolicyPinned =
        decoder.decodeStruct(codec.Int32);
    val.installSource =
        decoder.decodeStruct(codec.Int32);
    val.version =
        decoder.decodeStruct(codec.NullableString);
    val.size =
        decoder.decodeStruct(codec.NullableString);
    val.permissions =
        decoder.decodeMapPointer(codec.Uint32, new codec.PointerTo(types$.Permission));
    packed = decoder.readUint8();
    val.hideMoreSettings = (packed >> 0) & 1 ? true : false;
    val.hidePinToShelf = (packed >> 1) & 1 ? true : false;
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  App.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(App.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.id);
    encoder.encodeStruct(codec.Int32, val.type);
    encoder.encodeStruct(codec.Int32, val.isPinned);
    encoder.encodeStruct(codec.NullableString, val.title);
    encoder.encodeStruct(codec.NullableString, val.description);
    encoder.encodeStruct(codec.Int32, val.isPolicyPinned);
    encoder.encodeStruct(codec.Int32, val.installSource);
    encoder.encodeStruct(codec.NullableString, val.version);
    encoder.encodeStruct(codec.NullableString, val.size);
    encoder.encodeMapPointer(codec.Uint32, new codec.PointerTo(types$.Permission), val.permissions);
    packed = 0;
    packed |= (val.hideMoreSettings & 1) << 0
    packed |= (val.hidePinToShelf & 1) << 1
    encoder.writeUint8(packed);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  function ExtensionAppPermissionMessage(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  ExtensionAppPermissionMessage.prototype.initDefaults_ = function() {
    this.message = null;
    this.submessages = null;
  };
  ExtensionAppPermissionMessage.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  ExtensionAppPermissionMessage.generate = function(generator_) {
    var generated = new ExtensionAppPermissionMessage;
    generated.message = generator_.generateString(false);
    generated.submessages = generator_.generateArray(function() {
      return generator_.generateString(false);
    });
    return generated;
  };

  ExtensionAppPermissionMessage.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.message = mutator_.mutateString(this.message, false);
    }
    if (mutator_.chooseMutateField()) {
      this.submessages = mutator_.mutateArray(this.submessages, function(val) {
        return mutator_.mutateString(val, false);
      });
    }
    return this;
  };
  ExtensionAppPermissionMessage.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  ExtensionAppPermissionMessage.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  ExtensionAppPermissionMessage.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  ExtensionAppPermissionMessage.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 24}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate ExtensionAppPermissionMessage.message
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate ExtensionAppPermissionMessage.submessages
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 8, 8, codec.String, false, [0, 0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  ExtensionAppPermissionMessage.encodedSize = codec.kStructHeaderSize + 16;

  ExtensionAppPermissionMessage.decode = function(decoder) {
    var packed;
    var val = new ExtensionAppPermissionMessage();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.message =
        decoder.decodeStruct(codec.String);
    val.submessages =
        decoder.decodeArrayPointer(codec.String);
    return val;
  };

  ExtensionAppPermissionMessage.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(ExtensionAppPermissionMessage.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.message);
    encoder.encodeArrayPointer(codec.String, val.submessages);
  };
  function PageHandlerFactory_CreatePageHandler_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  PageHandlerFactory_CreatePageHandler_Params.prototype.initDefaults_ = function() {
    this.page = new PagePtr();
    this.handler = new bindings.InterfaceRequest();
  };
  PageHandlerFactory_CreatePageHandler_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  PageHandlerFactory_CreatePageHandler_Params.generate = function(generator_) {
    var generated = new PageHandlerFactory_CreatePageHandler_Params;
    generated.page = generator_.generateInterface("appManagement.mojom.Page", false);
    generated.handler = generator_.generateInterfaceRequest("appManagement.mojom.PageHandler", false);
    return generated;
  };

  PageHandlerFactory_CreatePageHandler_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.page = mutator_.mutateInterface(this.page, "appManagement.mojom.Page", false);
    }
    if (mutator_.chooseMutateField()) {
      this.handler = mutator_.mutateInterfaceRequest(this.handler, "appManagement.mojom.PageHandler", false);
    }
    return this;
  };
  PageHandlerFactory_CreatePageHandler_Params.prototype.getHandleDeps = function() {
    var handles = [];
    if (this.page !== null) {
      Array.prototype.push.apply(handles, ["appManagement.mojom.PagePtr"]);
    }
    if (this.handler !== null) {
      Array.prototype.push.apply(handles, ["appManagement.mojom.PageHandlerRequest"]);
    }
    return handles;
  };

  PageHandlerFactory_CreatePageHandler_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  PageHandlerFactory_CreatePageHandler_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    this.page = handles[idx++];;
    this.handler = handles[idx++];;
    return idx;
  };

  PageHandlerFactory_CreatePageHandler_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 24}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate PageHandlerFactory_CreatePageHandler_Params.page
    err = messageValidator.validateInterface(offset + codec.kStructHeaderSize + 0, false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate PageHandlerFactory_CreatePageHandler_Params.handler
    err = messageValidator.validateInterfaceRequest(offset + codec.kStructHeaderSize + 8, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  PageHandlerFactory_CreatePageHandler_Params.encodedSize = codec.kStructHeaderSize + 16;

  PageHandlerFactory_CreatePageHandler_Params.decode = function(decoder) {
    var packed;
    var val = new PageHandlerFactory_CreatePageHandler_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.page =
        decoder.decodeStruct(new codec.Interface(PagePtr));
    val.handler =
        decoder.decodeStruct(codec.InterfaceRequest);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  PageHandlerFactory_CreatePageHandler_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(PageHandlerFactory_CreatePageHandler_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(new codec.Interface(PagePtr), val.page);
    encoder.encodeStruct(codec.InterfaceRequest, val.handler);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  function PageHandler_GetApps_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  PageHandler_GetApps_Params.prototype.initDefaults_ = function() {
  };
  PageHandler_GetApps_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  PageHandler_GetApps_Params.generate = function(generator_) {
    var generated = new PageHandler_GetApps_Params;
    return generated;
  };

  PageHandler_GetApps_Params.prototype.mutate = function(mutator_) {
    return this;
  };
  PageHandler_GetApps_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  PageHandler_GetApps_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  PageHandler_GetApps_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  PageHandler_GetApps_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 8}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  PageHandler_GetApps_Params.encodedSize = codec.kStructHeaderSize + 0;

  PageHandler_GetApps_Params.decode = function(decoder) {
    var packed;
    var val = new PageHandler_GetApps_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    return val;
  };

  PageHandler_GetApps_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(PageHandler_GetApps_Params.encodedSize);
    encoder.writeUint32(0);
  };
  function PageHandler_GetApps_ResponseParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  PageHandler_GetApps_ResponseParams.prototype.initDefaults_ = function() {
    this.apps = null;
  };
  PageHandler_GetApps_ResponseParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  PageHandler_GetApps_ResponseParams.generate = function(generator_) {
    var generated = new PageHandler_GetApps_ResponseParams;
    generated.apps = generator_.generateArray(function() {
      return generator_.generateStruct(appManagement.mojom.App, false);
    });
    return generated;
  };

  PageHandler_GetApps_ResponseParams.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.apps = mutator_.mutateArray(this.apps, function(val) {
        return mutator_.mutateStruct(val, appManagement.mojom.App, false);
      });
    }
    return this;
  };
  PageHandler_GetApps_ResponseParams.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  PageHandler_GetApps_ResponseParams.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  PageHandler_GetApps_ResponseParams.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  PageHandler_GetApps_ResponseParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate PageHandler_GetApps_ResponseParams.apps
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 0, 8, new codec.PointerTo(App), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  PageHandler_GetApps_ResponseParams.encodedSize = codec.kStructHeaderSize + 8;

  PageHandler_GetApps_ResponseParams.decode = function(decoder) {
    var packed;
    var val = new PageHandler_GetApps_ResponseParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.apps =
        decoder.decodeArrayPointer(new codec.PointerTo(App));
    return val;
  };

  PageHandler_GetApps_ResponseParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(PageHandler_GetApps_ResponseParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeArrayPointer(new codec.PointerTo(App), val.apps);
  };
  function PageHandler_GetExtensionAppPermissionMessages_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  PageHandler_GetExtensionAppPermissionMessages_Params.prototype.initDefaults_ = function() {
    this.appId = null;
  };
  PageHandler_GetExtensionAppPermissionMessages_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  PageHandler_GetExtensionAppPermissionMessages_Params.generate = function(generator_) {
    var generated = new PageHandler_GetExtensionAppPermissionMessages_Params;
    generated.appId = generator_.generateString(false);
    return generated;
  };

  PageHandler_GetExtensionAppPermissionMessages_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.appId = mutator_.mutateString(this.appId, false);
    }
    return this;
  };
  PageHandler_GetExtensionAppPermissionMessages_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  PageHandler_GetExtensionAppPermissionMessages_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  PageHandler_GetExtensionAppPermissionMessages_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  PageHandler_GetExtensionAppPermissionMessages_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate PageHandler_GetExtensionAppPermissionMessages_Params.appId
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  PageHandler_GetExtensionAppPermissionMessages_Params.encodedSize = codec.kStructHeaderSize + 8;

  PageHandler_GetExtensionAppPermissionMessages_Params.decode = function(decoder) {
    var packed;
    var val = new PageHandler_GetExtensionAppPermissionMessages_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.appId =
        decoder.decodeStruct(codec.String);
    return val;
  };

  PageHandler_GetExtensionAppPermissionMessages_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(PageHandler_GetExtensionAppPermissionMessages_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.appId);
  };
  function PageHandler_GetExtensionAppPermissionMessages_ResponseParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  PageHandler_GetExtensionAppPermissionMessages_ResponseParams.prototype.initDefaults_ = function() {
    this.messages = null;
  };
  PageHandler_GetExtensionAppPermissionMessages_ResponseParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  PageHandler_GetExtensionAppPermissionMessages_ResponseParams.generate = function(generator_) {
    var generated = new PageHandler_GetExtensionAppPermissionMessages_ResponseParams;
    generated.messages = generator_.generateArray(function() {
      return generator_.generateStruct(appManagement.mojom.ExtensionAppPermissionMessage, false);
    });
    return generated;
  };

  PageHandler_GetExtensionAppPermissionMessages_ResponseParams.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.messages = mutator_.mutateArray(this.messages, function(val) {
        return mutator_.mutateStruct(val, appManagement.mojom.ExtensionAppPermissionMessage, false);
      });
    }
    return this;
  };
  PageHandler_GetExtensionAppPermissionMessages_ResponseParams.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  PageHandler_GetExtensionAppPermissionMessages_ResponseParams.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  PageHandler_GetExtensionAppPermissionMessages_ResponseParams.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  PageHandler_GetExtensionAppPermissionMessages_ResponseParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate PageHandler_GetExtensionAppPermissionMessages_ResponseParams.messages
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 0, 8, new codec.PointerTo(ExtensionAppPermissionMessage), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  PageHandler_GetExtensionAppPermissionMessages_ResponseParams.encodedSize = codec.kStructHeaderSize + 8;

  PageHandler_GetExtensionAppPermissionMessages_ResponseParams.decode = function(decoder) {
    var packed;
    var val = new PageHandler_GetExtensionAppPermissionMessages_ResponseParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.messages =
        decoder.decodeArrayPointer(new codec.PointerTo(ExtensionAppPermissionMessage));
    return val;
  };

  PageHandler_GetExtensionAppPermissionMessages_ResponseParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(PageHandler_GetExtensionAppPermissionMessages_ResponseParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeArrayPointer(new codec.PointerTo(ExtensionAppPermissionMessage), val.messages);
  };
  function PageHandler_SetPinned_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  PageHandler_SetPinned_Params.prototype.initDefaults_ = function() {
    this.appId = null;
    this.pinned = 0;
  };
  PageHandler_SetPinned_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  PageHandler_SetPinned_Params.generate = function(generator_) {
    var generated = new PageHandler_SetPinned_Params;
    generated.appId = generator_.generateString(false);
    generated.pinned = generator_.generateEnum(0, 2);
    return generated;
  };

  PageHandler_SetPinned_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.appId = mutator_.mutateString(this.appId, false);
    }
    if (mutator_.chooseMutateField()) {
      this.pinned = mutator_.mutateEnum(this.pinned, 0, 2);
    }
    return this;
  };
  PageHandler_SetPinned_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  PageHandler_SetPinned_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  PageHandler_SetPinned_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  PageHandler_SetPinned_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 24}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate PageHandler_SetPinned_Params.appId
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate PageHandler_SetPinned_Params.pinned
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 8, types$.OptionalBool);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  PageHandler_SetPinned_Params.encodedSize = codec.kStructHeaderSize + 16;

  PageHandler_SetPinned_Params.decode = function(decoder) {
    var packed;
    var val = new PageHandler_SetPinned_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.appId =
        decoder.decodeStruct(codec.String);
    val.pinned =
        decoder.decodeStruct(codec.Int32);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  PageHandler_SetPinned_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(PageHandler_SetPinned_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.appId);
    encoder.encodeStruct(codec.Int32, val.pinned);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  function PageHandler_SetPermission_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  PageHandler_SetPermission_Params.prototype.initDefaults_ = function() {
    this.appId = null;
    this.permission = null;
  };
  PageHandler_SetPermission_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  PageHandler_SetPermission_Params.generate = function(generator_) {
    var generated = new PageHandler_SetPermission_Params;
    generated.appId = generator_.generateString(false);
    generated.permission = generator_.generateStruct(apps.mojom.Permission, false);
    return generated;
  };

  PageHandler_SetPermission_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.appId = mutator_.mutateString(this.appId, false);
    }
    if (mutator_.chooseMutateField()) {
      this.permission = mutator_.mutateStruct(this.permission, apps.mojom.Permission, false);
    }
    return this;
  };
  PageHandler_SetPermission_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  PageHandler_SetPermission_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  PageHandler_SetPermission_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  PageHandler_SetPermission_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 24}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate PageHandler_SetPermission_Params.appId
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate PageHandler_SetPermission_Params.permission
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 8, types$.Permission, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  PageHandler_SetPermission_Params.encodedSize = codec.kStructHeaderSize + 16;

  PageHandler_SetPermission_Params.decode = function(decoder) {
    var packed;
    var val = new PageHandler_SetPermission_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.appId =
        decoder.decodeStruct(codec.String);
    val.permission =
        decoder.decodeStructPointer(types$.Permission);
    return val;
  };

  PageHandler_SetPermission_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(PageHandler_SetPermission_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.appId);
    encoder.encodeStructPointer(types$.Permission, val.permission);
  };
  function PageHandler_Uninstall_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  PageHandler_Uninstall_Params.prototype.initDefaults_ = function() {
    this.appId = null;
  };
  PageHandler_Uninstall_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  PageHandler_Uninstall_Params.generate = function(generator_) {
    var generated = new PageHandler_Uninstall_Params;
    generated.appId = generator_.generateString(false);
    return generated;
  };

  PageHandler_Uninstall_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.appId = mutator_.mutateString(this.appId, false);
    }
    return this;
  };
  PageHandler_Uninstall_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  PageHandler_Uninstall_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  PageHandler_Uninstall_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  PageHandler_Uninstall_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate PageHandler_Uninstall_Params.appId
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  PageHandler_Uninstall_Params.encodedSize = codec.kStructHeaderSize + 8;

  PageHandler_Uninstall_Params.decode = function(decoder) {
    var packed;
    var val = new PageHandler_Uninstall_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.appId =
        decoder.decodeStruct(codec.String);
    return val;
  };

  PageHandler_Uninstall_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(PageHandler_Uninstall_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.appId);
  };
  function PageHandler_OpenNativeSettings_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  PageHandler_OpenNativeSettings_Params.prototype.initDefaults_ = function() {
    this.appId = null;
  };
  PageHandler_OpenNativeSettings_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  PageHandler_OpenNativeSettings_Params.generate = function(generator_) {
    var generated = new PageHandler_OpenNativeSettings_Params;
    generated.appId = generator_.generateString(false);
    return generated;
  };

  PageHandler_OpenNativeSettings_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.appId = mutator_.mutateString(this.appId, false);
    }
    return this;
  };
  PageHandler_OpenNativeSettings_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  PageHandler_OpenNativeSettings_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  PageHandler_OpenNativeSettings_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  PageHandler_OpenNativeSettings_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate PageHandler_OpenNativeSettings_Params.appId
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  PageHandler_OpenNativeSettings_Params.encodedSize = codec.kStructHeaderSize + 8;

  PageHandler_OpenNativeSettings_Params.decode = function(decoder) {
    var packed;
    var val = new PageHandler_OpenNativeSettings_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.appId =
        decoder.decodeStruct(codec.String);
    return val;
  };

  PageHandler_OpenNativeSettings_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(PageHandler_OpenNativeSettings_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.appId);
  };
  function Page_OnAppAdded_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  Page_OnAppAdded_Params.prototype.initDefaults_ = function() {
    this.app = null;
  };
  Page_OnAppAdded_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  Page_OnAppAdded_Params.generate = function(generator_) {
    var generated = new Page_OnAppAdded_Params;
    generated.app = generator_.generateStruct(appManagement.mojom.App, false);
    return generated;
  };

  Page_OnAppAdded_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.app = mutator_.mutateStruct(this.app, appManagement.mojom.App, false);
    }
    return this;
  };
  Page_OnAppAdded_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  Page_OnAppAdded_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  Page_OnAppAdded_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  Page_OnAppAdded_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate Page_OnAppAdded_Params.app
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 0, App, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  Page_OnAppAdded_Params.encodedSize = codec.kStructHeaderSize + 8;

  Page_OnAppAdded_Params.decode = function(decoder) {
    var packed;
    var val = new Page_OnAppAdded_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.app =
        decoder.decodeStructPointer(App);
    return val;
  };

  Page_OnAppAdded_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(Page_OnAppAdded_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStructPointer(App, val.app);
  };
  function Page_OnAppChanged_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  Page_OnAppChanged_Params.prototype.initDefaults_ = function() {
    this.update = null;
  };
  Page_OnAppChanged_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  Page_OnAppChanged_Params.generate = function(generator_) {
    var generated = new Page_OnAppChanged_Params;
    generated.update = generator_.generateStruct(appManagement.mojom.App, false);
    return generated;
  };

  Page_OnAppChanged_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.update = mutator_.mutateStruct(this.update, appManagement.mojom.App, false);
    }
    return this;
  };
  Page_OnAppChanged_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  Page_OnAppChanged_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  Page_OnAppChanged_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  Page_OnAppChanged_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate Page_OnAppChanged_Params.update
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 0, App, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  Page_OnAppChanged_Params.encodedSize = codec.kStructHeaderSize + 8;

  Page_OnAppChanged_Params.decode = function(decoder) {
    var packed;
    var val = new Page_OnAppChanged_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.update =
        decoder.decodeStructPointer(App);
    return val;
  };

  Page_OnAppChanged_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(Page_OnAppChanged_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStructPointer(App, val.update);
  };
  function Page_OnAppRemoved_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  Page_OnAppRemoved_Params.prototype.initDefaults_ = function() {
    this.appId = null;
  };
  Page_OnAppRemoved_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  Page_OnAppRemoved_Params.generate = function(generator_) {
    var generated = new Page_OnAppRemoved_Params;
    generated.appId = generator_.generateString(false);
    return generated;
  };

  Page_OnAppRemoved_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.appId = mutator_.mutateString(this.appId, false);
    }
    return this;
  };
  Page_OnAppRemoved_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  Page_OnAppRemoved_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  Page_OnAppRemoved_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  Page_OnAppRemoved_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate Page_OnAppRemoved_Params.appId
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  Page_OnAppRemoved_Params.encodedSize = codec.kStructHeaderSize + 8;

  Page_OnAppRemoved_Params.decode = function(decoder) {
    var packed;
    var val = new Page_OnAppRemoved_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.appId =
        decoder.decodeStruct(codec.String);
    return val;
  };

  Page_OnAppRemoved_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(Page_OnAppRemoved_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.appId);
  };
  function Page_OnArcSupportChanged_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  Page_OnArcSupportChanged_Params.prototype.initDefaults_ = function() {
    this.supported = false;
  };
  Page_OnArcSupportChanged_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  Page_OnArcSupportChanged_Params.generate = function(generator_) {
    var generated = new Page_OnArcSupportChanged_Params;
    generated.supported = generator_.generateBool();
    return generated;
  };

  Page_OnArcSupportChanged_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.supported = mutator_.mutateBool(this.supported);
    }
    return this;
  };
  Page_OnArcSupportChanged_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  Page_OnArcSupportChanged_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  Page_OnArcSupportChanged_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  Page_OnArcSupportChanged_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    return validator.validationError.NONE;
  };

  Page_OnArcSupportChanged_Params.encodedSize = codec.kStructHeaderSize + 8;

  Page_OnArcSupportChanged_Params.decode = function(decoder) {
    var packed;
    var val = new Page_OnArcSupportChanged_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    packed = decoder.readUint8();
    val.supported = (packed >> 0) & 1 ? true : false;
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  Page_OnArcSupportChanged_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(Page_OnArcSupportChanged_Params.encodedSize);
    encoder.writeUint32(0);
    packed = 0;
    packed |= (val.supported & 1) << 0
    encoder.writeUint8(packed);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  var kPageHandlerFactory_CreatePageHandler_Name = 589562878;

  function PageHandlerFactoryPtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(PageHandlerFactory,
                                                   handleOrPtrInfo);
  }

  function PageHandlerFactoryAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        PageHandlerFactory, associatedInterfacePtrInfo);
  }

  PageHandlerFactoryAssociatedPtr.prototype =
      Object.create(PageHandlerFactoryPtr.prototype);
  PageHandlerFactoryAssociatedPtr.prototype.constructor =
      PageHandlerFactoryAssociatedPtr;

  function PageHandlerFactoryProxy(receiver) {
    this.receiver_ = receiver;
  }
  PageHandlerFactoryPtr.prototype.createPageHandler = function() {
    return PageHandlerFactoryProxy.prototype.createPageHandler
        .apply(this.ptr.getProxy(), arguments);
  };

  PageHandlerFactoryProxy.prototype.createPageHandler = function(page, handler) {
    var params_ = new PageHandlerFactory_CreatePageHandler_Params();
    params_.page = page;
    params_.handler = handler;
    var builder = new codec.MessageV0Builder(
        kPageHandlerFactory_CreatePageHandler_Name,
        codec.align(PageHandlerFactory_CreatePageHandler_Params.encodedSize));
    builder.encodeStruct(PageHandlerFactory_CreatePageHandler_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };

  function PageHandlerFactoryStub(delegate) {
    this.delegate_ = delegate;
  }
  PageHandlerFactoryStub.prototype.createPageHandler = function(page, handler) {
    return this.delegate_ && this.delegate_.createPageHandler && this.delegate_.createPageHandler(page, handler);
  }

  PageHandlerFactoryStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kPageHandlerFactory_CreatePageHandler_Name:
      var params = reader.decodeStruct(PageHandlerFactory_CreatePageHandler_Params);
      this.createPageHandler(params.page, params.handler);
      return true;
    default:
      return false;
    }
  };

  PageHandlerFactoryStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    default:
      return false;
    }
  };

  function validatePageHandlerFactoryRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kPageHandlerFactory_CreatePageHandler_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = PageHandlerFactory_CreatePageHandler_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validatePageHandlerFactoryResponse(messageValidator) {
    return validator.validationError.NONE;
  }

  var PageHandlerFactory = {
    name: 'app_management.mojom.PageHandlerFactory',
    kVersion: 0,
    ptrClass: PageHandlerFactoryPtr,
    proxyClass: PageHandlerFactoryProxy,
    stubClass: PageHandlerFactoryStub,
    validateRequest: validatePageHandlerFactoryRequest,
    validateResponse: null,
    mojomId: 'chrome/browser/ui/webui/app_management/app_management.mojom',
    fuzzMethods: {
      createPageHandler: {
        params: PageHandlerFactory_CreatePageHandler_Params,
      },
    },
  };
  PageHandlerFactoryStub.prototype.validator = validatePageHandlerFactoryRequest;
  PageHandlerFactoryProxy.prototype.validator = null;
  var kPageHandler_GetApps_Name = 1661854201;
  var kPageHandler_GetExtensionAppPermissionMessages_Name = 1358740505;
  var kPageHandler_SetPinned_Name = 1751707917;
  var kPageHandler_SetPermission_Name = 1395622676;
  var kPageHandler_Uninstall_Name = 71580353;
  var kPageHandler_OpenNativeSettings_Name = 1068319372;

  function PageHandlerPtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(PageHandler,
                                                   handleOrPtrInfo);
  }

  function PageHandlerAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        PageHandler, associatedInterfacePtrInfo);
  }

  PageHandlerAssociatedPtr.prototype =
      Object.create(PageHandlerPtr.prototype);
  PageHandlerAssociatedPtr.prototype.constructor =
      PageHandlerAssociatedPtr;

  function PageHandlerProxy(receiver) {
    this.receiver_ = receiver;
  }
  PageHandlerPtr.prototype.getApps = function() {
    return PageHandlerProxy.prototype.getApps
        .apply(this.ptr.getProxy(), arguments);
  };

  PageHandlerProxy.prototype.getApps = function() {
    var params_ = new PageHandler_GetApps_Params();
    return new Promise(function(resolve, reject) {
      var builder = new codec.MessageV1Builder(
          kPageHandler_GetApps_Name,
          codec.align(PageHandler_GetApps_Params.encodedSize),
          codec.kMessageExpectsResponse, 0);
      builder.encodeStruct(PageHandler_GetApps_Params, params_);
      var message = builder.finish();
      this.receiver_.acceptAndExpectResponse(message).then(function(message) {
        var reader = new codec.MessageReader(message);
        var responseParams =
            reader.decodeStruct(PageHandler_GetApps_ResponseParams);
        resolve(responseParams);
      }).catch(function(result) {
        reject(Error("Connection error: " + result));
      });
    }.bind(this));
  };
  PageHandlerPtr.prototype.getExtensionAppPermissionMessages = function() {
    return PageHandlerProxy.prototype.getExtensionAppPermissionMessages
        .apply(this.ptr.getProxy(), arguments);
  };

  PageHandlerProxy.prototype.getExtensionAppPermissionMessages = function(appId) {
    var params_ = new PageHandler_GetExtensionAppPermissionMessages_Params();
    params_.appId = appId;
    return new Promise(function(resolve, reject) {
      var builder = new codec.MessageV1Builder(
          kPageHandler_GetExtensionAppPermissionMessages_Name,
          codec.align(PageHandler_GetExtensionAppPermissionMessages_Params.encodedSize),
          codec.kMessageExpectsResponse, 0);
      builder.encodeStruct(PageHandler_GetExtensionAppPermissionMessages_Params, params_);
      var message = builder.finish();
      this.receiver_.acceptAndExpectResponse(message).then(function(message) {
        var reader = new codec.MessageReader(message);
        var responseParams =
            reader.decodeStruct(PageHandler_GetExtensionAppPermissionMessages_ResponseParams);
        resolve(responseParams);
      }).catch(function(result) {
        reject(Error("Connection error: " + result));
      });
    }.bind(this));
  };
  PageHandlerPtr.prototype.setPinned = function() {
    return PageHandlerProxy.prototype.setPinned
        .apply(this.ptr.getProxy(), arguments);
  };

  PageHandlerProxy.prototype.setPinned = function(appId, pinned) {
    var params_ = new PageHandler_SetPinned_Params();
    params_.appId = appId;
    params_.pinned = pinned;
    var builder = new codec.MessageV0Builder(
        kPageHandler_SetPinned_Name,
        codec.align(PageHandler_SetPinned_Params.encodedSize));
    builder.encodeStruct(PageHandler_SetPinned_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  PageHandlerPtr.prototype.setPermission = function() {
    return PageHandlerProxy.prototype.setPermission
        .apply(this.ptr.getProxy(), arguments);
  };

  PageHandlerProxy.prototype.setPermission = function(appId, permission) {
    var params_ = new PageHandler_SetPermission_Params();
    params_.appId = appId;
    params_.permission = permission;
    var builder = new codec.MessageV0Builder(
        kPageHandler_SetPermission_Name,
        codec.align(PageHandler_SetPermission_Params.encodedSize));
    builder.encodeStruct(PageHandler_SetPermission_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  PageHandlerPtr.prototype.uninstall = function() {
    return PageHandlerProxy.prototype.uninstall
        .apply(this.ptr.getProxy(), arguments);
  };

  PageHandlerProxy.prototype.uninstall = function(appId) {
    var params_ = new PageHandler_Uninstall_Params();
    params_.appId = appId;
    var builder = new codec.MessageV0Builder(
        kPageHandler_Uninstall_Name,
        codec.align(PageHandler_Uninstall_Params.encodedSize));
    builder.encodeStruct(PageHandler_Uninstall_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  PageHandlerPtr.prototype.openNativeSettings = function() {
    return PageHandlerProxy.prototype.openNativeSettings
        .apply(this.ptr.getProxy(), arguments);
  };

  PageHandlerProxy.prototype.openNativeSettings = function(appId) {
    var params_ = new PageHandler_OpenNativeSettings_Params();
    params_.appId = appId;
    var builder = new codec.MessageV0Builder(
        kPageHandler_OpenNativeSettings_Name,
        codec.align(PageHandler_OpenNativeSettings_Params.encodedSize));
    builder.encodeStruct(PageHandler_OpenNativeSettings_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };

  function PageHandlerStub(delegate) {
    this.delegate_ = delegate;
  }
  PageHandlerStub.prototype.getApps = function() {
    return this.delegate_ && this.delegate_.getApps && this.delegate_.getApps();
  }
  PageHandlerStub.prototype.getExtensionAppPermissionMessages = function(appId) {
    return this.delegate_ && this.delegate_.getExtensionAppPermissionMessages && this.delegate_.getExtensionAppPermissionMessages(appId);
  }
  PageHandlerStub.prototype.setPinned = function(appId, pinned) {
    return this.delegate_ && this.delegate_.setPinned && this.delegate_.setPinned(appId, pinned);
  }
  PageHandlerStub.prototype.setPermission = function(appId, permission) {
    return this.delegate_ && this.delegate_.setPermission && this.delegate_.setPermission(appId, permission);
  }
  PageHandlerStub.prototype.uninstall = function(appId) {
    return this.delegate_ && this.delegate_.uninstall && this.delegate_.uninstall(appId);
  }
  PageHandlerStub.prototype.openNativeSettings = function(appId) {
    return this.delegate_ && this.delegate_.openNativeSettings && this.delegate_.openNativeSettings(appId);
  }

  PageHandlerStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kPageHandler_SetPinned_Name:
      var params = reader.decodeStruct(PageHandler_SetPinned_Params);
      this.setPinned(params.appId, params.pinned);
      return true;
    case kPageHandler_SetPermission_Name:
      var params = reader.decodeStruct(PageHandler_SetPermission_Params);
      this.setPermission(params.appId, params.permission);
      return true;
    case kPageHandler_Uninstall_Name:
      var params = reader.decodeStruct(PageHandler_Uninstall_Params);
      this.uninstall(params.appId);
      return true;
    case kPageHandler_OpenNativeSettings_Name:
      var params = reader.decodeStruct(PageHandler_OpenNativeSettings_Params);
      this.openNativeSettings(params.appId);
      return true;
    default:
      return false;
    }
  };

  PageHandlerStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kPageHandler_GetApps_Name:
      var params = reader.decodeStruct(PageHandler_GetApps_Params);
      this.getApps().then(function(response) {
        var responseParams =
            new PageHandler_GetApps_ResponseParams();
        responseParams.apps = response.apps;
        var builder = new codec.MessageV1Builder(
            kPageHandler_GetApps_Name,
            codec.align(PageHandler_GetApps_ResponseParams.encodedSize),
            codec.kMessageIsResponse, reader.requestID);
        builder.encodeStruct(PageHandler_GetApps_ResponseParams,
                             responseParams);
        var message = builder.finish();
        responder.accept(message);
      });
      return true;
    case kPageHandler_GetExtensionAppPermissionMessages_Name:
      var params = reader.decodeStruct(PageHandler_GetExtensionAppPermissionMessages_Params);
      this.getExtensionAppPermissionMessages(params.appId).then(function(response) {
        var responseParams =
            new PageHandler_GetExtensionAppPermissionMessages_ResponseParams();
        responseParams.messages = response.messages;
        var builder = new codec.MessageV1Builder(
            kPageHandler_GetExtensionAppPermissionMessages_Name,
            codec.align(PageHandler_GetExtensionAppPermissionMessages_ResponseParams.encodedSize),
            codec.kMessageIsResponse, reader.requestID);
        builder.encodeStruct(PageHandler_GetExtensionAppPermissionMessages_ResponseParams,
                             responseParams);
        var message = builder.finish();
        responder.accept(message);
      });
      return true;
    default:
      return false;
    }
  };

  function validatePageHandlerRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kPageHandler_GetApps_Name:
        if (message.expectsResponse())
          paramsClass = PageHandler_GetApps_Params;
      break;
      case kPageHandler_GetExtensionAppPermissionMessages_Name:
        if (message.expectsResponse())
          paramsClass = PageHandler_GetExtensionAppPermissionMessages_Params;
      break;
      case kPageHandler_SetPinned_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = PageHandler_SetPinned_Params;
      break;
      case kPageHandler_SetPermission_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = PageHandler_SetPermission_Params;
      break;
      case kPageHandler_Uninstall_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = PageHandler_Uninstall_Params;
      break;
      case kPageHandler_OpenNativeSettings_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = PageHandler_OpenNativeSettings_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validatePageHandlerResponse(messageValidator) {
   var message = messageValidator.message;
   var paramsClass = null;
   switch (message.getName()) {
      case kPageHandler_GetApps_Name:
        if (message.isResponse())
          paramsClass = PageHandler_GetApps_ResponseParams;
        break;
      case kPageHandler_GetExtensionAppPermissionMessages_Name:
        if (message.isResponse())
          paramsClass = PageHandler_GetExtensionAppPermissionMessages_ResponseParams;
        break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  var PageHandler = {
    name: 'app_management.mojom.PageHandler',
    kVersion: 0,
    ptrClass: PageHandlerPtr,
    proxyClass: PageHandlerProxy,
    stubClass: PageHandlerStub,
    validateRequest: validatePageHandlerRequest,
    validateResponse: validatePageHandlerResponse,
    mojomId: 'chrome/browser/ui/webui/app_management/app_management.mojom',
    fuzzMethods: {
      getApps: {
        params: PageHandler_GetApps_Params,
      },
      getExtensionAppPermissionMessages: {
        params: PageHandler_GetExtensionAppPermissionMessages_Params,
      },
      setPinned: {
        params: PageHandler_SetPinned_Params,
      },
      setPermission: {
        params: PageHandler_SetPermission_Params,
      },
      uninstall: {
        params: PageHandler_Uninstall_Params,
      },
      openNativeSettings: {
        params: PageHandler_OpenNativeSettings_Params,
      },
    },
  };
  PageHandlerStub.prototype.validator = validatePageHandlerRequest;
  PageHandlerProxy.prototype.validator = validatePageHandlerResponse;
  var kPage_OnAppAdded_Name = 363048287;
  var kPage_OnAppChanged_Name = 32583815;
  var kPage_OnAppRemoved_Name = 1070212397;
  var kPage_OnArcSupportChanged_Name = 1389117032;

  function PagePtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(Page,
                                                   handleOrPtrInfo);
  }

  function PageAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        Page, associatedInterfacePtrInfo);
  }

  PageAssociatedPtr.prototype =
      Object.create(PagePtr.prototype);
  PageAssociatedPtr.prototype.constructor =
      PageAssociatedPtr;

  function PageProxy(receiver) {
    this.receiver_ = receiver;
  }
  PagePtr.prototype.onAppAdded = function() {
    return PageProxy.prototype.onAppAdded
        .apply(this.ptr.getProxy(), arguments);
  };

  PageProxy.prototype.onAppAdded = function(app) {
    var params_ = new Page_OnAppAdded_Params();
    params_.app = app;
    var builder = new codec.MessageV0Builder(
        kPage_OnAppAdded_Name,
        codec.align(Page_OnAppAdded_Params.encodedSize));
    builder.encodeStruct(Page_OnAppAdded_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  PagePtr.prototype.onAppChanged = function() {
    return PageProxy.prototype.onAppChanged
        .apply(this.ptr.getProxy(), arguments);
  };

  PageProxy.prototype.onAppChanged = function(update) {
    var params_ = new Page_OnAppChanged_Params();
    params_.update = update;
    var builder = new codec.MessageV0Builder(
        kPage_OnAppChanged_Name,
        codec.align(Page_OnAppChanged_Params.encodedSize));
    builder.encodeStruct(Page_OnAppChanged_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  PagePtr.prototype.onAppRemoved = function() {
    return PageProxy.prototype.onAppRemoved
        .apply(this.ptr.getProxy(), arguments);
  };

  PageProxy.prototype.onAppRemoved = function(appId) {
    var params_ = new Page_OnAppRemoved_Params();
    params_.appId = appId;
    var builder = new codec.MessageV0Builder(
        kPage_OnAppRemoved_Name,
        codec.align(Page_OnAppRemoved_Params.encodedSize));
    builder.encodeStruct(Page_OnAppRemoved_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  PagePtr.prototype.onArcSupportChanged = function() {
    return PageProxy.prototype.onArcSupportChanged
        .apply(this.ptr.getProxy(), arguments);
  };

  PageProxy.prototype.onArcSupportChanged = function(supported) {
    var params_ = new Page_OnArcSupportChanged_Params();
    params_.supported = supported;
    var builder = new codec.MessageV0Builder(
        kPage_OnArcSupportChanged_Name,
        codec.align(Page_OnArcSupportChanged_Params.encodedSize));
    builder.encodeStruct(Page_OnArcSupportChanged_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };

  function PageStub(delegate) {
    this.delegate_ = delegate;
  }
  PageStub.prototype.onAppAdded = function(app) {
    return this.delegate_ && this.delegate_.onAppAdded && this.delegate_.onAppAdded(app);
  }
  PageStub.prototype.onAppChanged = function(update) {
    return this.delegate_ && this.delegate_.onAppChanged && this.delegate_.onAppChanged(update);
  }
  PageStub.prototype.onAppRemoved = function(appId) {
    return this.delegate_ && this.delegate_.onAppRemoved && this.delegate_.onAppRemoved(appId);
  }
  PageStub.prototype.onArcSupportChanged = function(supported) {
    return this.delegate_ && this.delegate_.onArcSupportChanged && this.delegate_.onArcSupportChanged(supported);
  }

  PageStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kPage_OnAppAdded_Name:
      var params = reader.decodeStruct(Page_OnAppAdded_Params);
      this.onAppAdded(params.app);
      return true;
    case kPage_OnAppChanged_Name:
      var params = reader.decodeStruct(Page_OnAppChanged_Params);
      this.onAppChanged(params.update);
      return true;
    case kPage_OnAppRemoved_Name:
      var params = reader.decodeStruct(Page_OnAppRemoved_Params);
      this.onAppRemoved(params.appId);
      return true;
    case kPage_OnArcSupportChanged_Name:
      var params = reader.decodeStruct(Page_OnArcSupportChanged_Params);
      this.onArcSupportChanged(params.supported);
      return true;
    default:
      return false;
    }
  };

  PageStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    default:
      return false;
    }
  };

  function validatePageRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kPage_OnAppAdded_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = Page_OnAppAdded_Params;
      break;
      case kPage_OnAppChanged_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = Page_OnAppChanged_Params;
      break;
      case kPage_OnAppRemoved_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = Page_OnAppRemoved_Params;
      break;
      case kPage_OnArcSupportChanged_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = Page_OnArcSupportChanged_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validatePageResponse(messageValidator) {
    return validator.validationError.NONE;
  }

  var Page = {
    name: 'app_management.mojom.Page',
    kVersion: 0,
    ptrClass: PagePtr,
    proxyClass: PageProxy,
    stubClass: PageStub,
    validateRequest: validatePageRequest,
    validateResponse: null,
    mojomId: 'chrome/browser/ui/webui/app_management/app_management.mojom',
    fuzzMethods: {
      onAppAdded: {
        params: Page_OnAppAdded_Params,
      },
      onAppChanged: {
        params: Page_OnAppChanged_Params,
      },
      onAppRemoved: {
        params: Page_OnAppRemoved_Params,
      },
      onArcSupportChanged: {
        params: Page_OnArcSupportChanged_Params,
      },
    },
  };
  PageStub.prototype.validator = validatePageRequest;
  PageProxy.prototype.validator = null;
  exports.ArcPermissionType = ArcPermissionType;
  exports.PwaPermissionType = PwaPermissionType;
  exports.App = App;
  exports.ExtensionAppPermissionMessage = ExtensionAppPermissionMessage;
  exports.PageHandlerFactory = PageHandlerFactory;
  exports.PageHandlerFactoryPtr = PageHandlerFactoryPtr;
  exports.PageHandlerFactoryAssociatedPtr = PageHandlerFactoryAssociatedPtr;
  exports.PageHandler = PageHandler;
  exports.PageHandlerPtr = PageHandlerPtr;
  exports.PageHandlerAssociatedPtr = PageHandlerAssociatedPtr;
  exports.Page = Page;
  exports.PagePtr = PagePtr;
  exports.PageAssociatedPtr = PageAssociatedPtr;
})();