// chrome/services/sharing/public/mojom/webrtc.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'chrome/services/sharing/public/mojom/webrtc.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('sharing.mojom');
  var url$ =
      mojo.internal.exposeNamespace('url.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'url/mojom/url.mojom', '../../../../../url/mojom/url.mojom.js');
  }


  var SendMessageResult = {};
  SendMessageResult.kSuccess = 0;
  SendMessageResult.kError = SendMessageResult.kSuccess + 1;
  SendMessageResult.MIN_VALUE = 0,
  SendMessageResult.MAX_VALUE = 1,

  SendMessageResult.isKnownEnumValue = function(value) {
    switch (value) {
    case 0:
    case 1:
      return true;
    }
    return false;
  };

  SendMessageResult.validate = function(enumValue) {
    var isExtensible = false;
    if (isExtensible || this.isKnownEnumValue(enumValue))
      return validator.validationError.NONE;

    return validator.validationError.UNKNOWN_ENUM_VALUE;
  };

  function IceCandidate(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  IceCandidate.prototype.initDefaults_ = function() {
    this.candidate = null;
    this.sdpMid = null;
    this.sdpMlineIndex = 0;
  };
  IceCandidate.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  IceCandidate.generate = function(generator_) {
    var generated = new IceCandidate;
    generated.candidate = generator_.generateString(false);
    generated.sdpMid = generator_.generateString(false);
    generated.sdpMlineIndex = generator_.generateInt32();
    return generated;
  };

  IceCandidate.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.candidate = mutator_.mutateString(this.candidate, false);
    }
    if (mutator_.chooseMutateField()) {
      this.sdpMid = mutator_.mutateString(this.sdpMid, false);
    }
    if (mutator_.chooseMutateField()) {
      this.sdpMlineIndex = mutator_.mutateInt32(this.sdpMlineIndex);
    }
    return this;
  };
  IceCandidate.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  IceCandidate.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  IceCandidate.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  IceCandidate.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 32}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate IceCandidate.candidate
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate IceCandidate.sdpMid
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 8, false)
    if (err !== validator.validationError.NONE)
        return err;


    return validator.validationError.NONE;
  };

  IceCandidate.encodedSize = codec.kStructHeaderSize + 24;

  IceCandidate.decode = function(decoder) {
    var packed;
    var val = new IceCandidate();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.candidate =
        decoder.decodeStruct(codec.String);
    val.sdpMid =
        decoder.decodeStruct(codec.String);
    val.sdpMlineIndex =
        decoder.decodeStruct(codec.Int32);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  IceCandidate.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(IceCandidate.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.candidate);
    encoder.encodeStruct(codec.String, val.sdpMid);
    encoder.encodeStruct(codec.Int32, val.sdpMlineIndex);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  function IceServer(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  IceServer.prototype.initDefaults_ = function() {
    this.urls = null;
    this.username = null;
    this.credential = null;
  };
  IceServer.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  IceServer.generate = function(generator_) {
    var generated = new IceServer;
    generated.urls = generator_.generateArray(function() {
      return generator_.generateStruct(url.mojom.Url, false);
    });
    generated.username = generator_.generateString(true);
    generated.credential = generator_.generateString(true);
    return generated;
  };

  IceServer.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.urls = mutator_.mutateArray(this.urls, function(val) {
        return mutator_.mutateStruct(val, url.mojom.Url, false);
      });
    }
    if (mutator_.chooseMutateField()) {
      this.username = mutator_.mutateString(this.username, true);
    }
    if (mutator_.chooseMutateField()) {
      this.credential = mutator_.mutateString(this.credential, true);
    }
    return this;
  };
  IceServer.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  IceServer.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  IceServer.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  IceServer.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 32}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate IceServer.urls
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 0, 8, new codec.PointerTo(url$.Url), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;


    // validate IceServer.username
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 8, true)
    if (err !== validator.validationError.NONE)
        return err;


    // validate IceServer.credential
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 16, true)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  IceServer.encodedSize = codec.kStructHeaderSize + 24;

  IceServer.decode = function(decoder) {
    var packed;
    var val = new IceServer();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.urls =
        decoder.decodeArrayPointer(new codec.PointerTo(url$.Url));
    val.username =
        decoder.decodeStruct(codec.NullableString);
    val.credential =
        decoder.decodeStruct(codec.NullableString);
    return val;
  };

  IceServer.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(IceServer.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeArrayPointer(new codec.PointerTo(url$.Url), val.urls);
    encoder.encodeStruct(codec.NullableString, val.username);
    encoder.encodeStruct(codec.NullableString, val.credential);
  };
  function SignallingSender_SendOffer_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  SignallingSender_SendOffer_Params.prototype.initDefaults_ = function() {
    this.offer = null;
  };
  SignallingSender_SendOffer_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  SignallingSender_SendOffer_Params.generate = function(generator_) {
    var generated = new SignallingSender_SendOffer_Params;
    generated.offer = generator_.generateString(false);
    return generated;
  };

  SignallingSender_SendOffer_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.offer = mutator_.mutateString(this.offer, false);
    }
    return this;
  };
  SignallingSender_SendOffer_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  SignallingSender_SendOffer_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  SignallingSender_SendOffer_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  SignallingSender_SendOffer_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate SignallingSender_SendOffer_Params.offer
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  SignallingSender_SendOffer_Params.encodedSize = codec.kStructHeaderSize + 8;

  SignallingSender_SendOffer_Params.decode = function(decoder) {
    var packed;
    var val = new SignallingSender_SendOffer_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.offer =
        decoder.decodeStruct(codec.String);
    return val;
  };

  SignallingSender_SendOffer_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(SignallingSender_SendOffer_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.offer);
  };
  function SignallingSender_SendOffer_ResponseParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  SignallingSender_SendOffer_ResponseParams.prototype.initDefaults_ = function() {
    this.answer = null;
  };
  SignallingSender_SendOffer_ResponseParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  SignallingSender_SendOffer_ResponseParams.generate = function(generator_) {
    var generated = new SignallingSender_SendOffer_ResponseParams;
    generated.answer = generator_.generateString(false);
    return generated;
  };

  SignallingSender_SendOffer_ResponseParams.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.answer = mutator_.mutateString(this.answer, false);
    }
    return this;
  };
  SignallingSender_SendOffer_ResponseParams.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  SignallingSender_SendOffer_ResponseParams.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  SignallingSender_SendOffer_ResponseParams.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  SignallingSender_SendOffer_ResponseParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate SignallingSender_SendOffer_ResponseParams.answer
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  SignallingSender_SendOffer_ResponseParams.encodedSize = codec.kStructHeaderSize + 8;

  SignallingSender_SendOffer_ResponseParams.decode = function(decoder) {
    var packed;
    var val = new SignallingSender_SendOffer_ResponseParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.answer =
        decoder.decodeStruct(codec.String);
    return val;
  };

  SignallingSender_SendOffer_ResponseParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(SignallingSender_SendOffer_ResponseParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.answer);
  };
  function SignallingSender_SendIceCandidates_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  SignallingSender_SendIceCandidates_Params.prototype.initDefaults_ = function() {
    this.iceCandidates = null;
  };
  SignallingSender_SendIceCandidates_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  SignallingSender_SendIceCandidates_Params.generate = function(generator_) {
    var generated = new SignallingSender_SendIceCandidates_Params;
    generated.iceCandidates = generator_.generateArray(function() {
      return generator_.generateStruct(sharing.mojom.IceCandidate, false);
    });
    return generated;
  };

  SignallingSender_SendIceCandidates_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.iceCandidates = mutator_.mutateArray(this.iceCandidates, function(val) {
        return mutator_.mutateStruct(val, sharing.mojom.IceCandidate, false);
      });
    }
    return this;
  };
  SignallingSender_SendIceCandidates_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  SignallingSender_SendIceCandidates_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  SignallingSender_SendIceCandidates_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  SignallingSender_SendIceCandidates_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate SignallingSender_SendIceCandidates_Params.iceCandidates
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 0, 8, new codec.PointerTo(IceCandidate), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  SignallingSender_SendIceCandidates_Params.encodedSize = codec.kStructHeaderSize + 8;

  SignallingSender_SendIceCandidates_Params.decode = function(decoder) {
    var packed;
    var val = new SignallingSender_SendIceCandidates_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.iceCandidates =
        decoder.decodeArrayPointer(new codec.PointerTo(IceCandidate));
    return val;
  };

  SignallingSender_SendIceCandidates_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(SignallingSender_SendIceCandidates_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeArrayPointer(new codec.PointerTo(IceCandidate), val.iceCandidates);
  };
  function SignallingReceiver_OnOfferReceived_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  SignallingReceiver_OnOfferReceived_Params.prototype.initDefaults_ = function() {
    this.offer = null;
  };
  SignallingReceiver_OnOfferReceived_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  SignallingReceiver_OnOfferReceived_Params.generate = function(generator_) {
    var generated = new SignallingReceiver_OnOfferReceived_Params;
    generated.offer = generator_.generateString(false);
    return generated;
  };

  SignallingReceiver_OnOfferReceived_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.offer = mutator_.mutateString(this.offer, false);
    }
    return this;
  };
  SignallingReceiver_OnOfferReceived_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  SignallingReceiver_OnOfferReceived_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  SignallingReceiver_OnOfferReceived_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  SignallingReceiver_OnOfferReceived_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate SignallingReceiver_OnOfferReceived_Params.offer
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  SignallingReceiver_OnOfferReceived_Params.encodedSize = codec.kStructHeaderSize + 8;

  SignallingReceiver_OnOfferReceived_Params.decode = function(decoder) {
    var packed;
    var val = new SignallingReceiver_OnOfferReceived_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.offer =
        decoder.decodeStruct(codec.String);
    return val;
  };

  SignallingReceiver_OnOfferReceived_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(SignallingReceiver_OnOfferReceived_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.offer);
  };
  function SignallingReceiver_OnOfferReceived_ResponseParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  SignallingReceiver_OnOfferReceived_ResponseParams.prototype.initDefaults_ = function() {
    this.answer = null;
  };
  SignallingReceiver_OnOfferReceived_ResponseParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  SignallingReceiver_OnOfferReceived_ResponseParams.generate = function(generator_) {
    var generated = new SignallingReceiver_OnOfferReceived_ResponseParams;
    generated.answer = generator_.generateString(false);
    return generated;
  };

  SignallingReceiver_OnOfferReceived_ResponseParams.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.answer = mutator_.mutateString(this.answer, false);
    }
    return this;
  };
  SignallingReceiver_OnOfferReceived_ResponseParams.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  SignallingReceiver_OnOfferReceived_ResponseParams.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  SignallingReceiver_OnOfferReceived_ResponseParams.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  SignallingReceiver_OnOfferReceived_ResponseParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate SignallingReceiver_OnOfferReceived_ResponseParams.answer
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  SignallingReceiver_OnOfferReceived_ResponseParams.encodedSize = codec.kStructHeaderSize + 8;

  SignallingReceiver_OnOfferReceived_ResponseParams.decode = function(decoder) {
    var packed;
    var val = new SignallingReceiver_OnOfferReceived_ResponseParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.answer =
        decoder.decodeStruct(codec.String);
    return val;
  };

  SignallingReceiver_OnOfferReceived_ResponseParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(SignallingReceiver_OnOfferReceived_ResponseParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.answer);
  };
  function SignallingReceiver_OnIceCandidatesReceived_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  SignallingReceiver_OnIceCandidatesReceived_Params.prototype.initDefaults_ = function() {
    this.iceCandidates = null;
  };
  SignallingReceiver_OnIceCandidatesReceived_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  SignallingReceiver_OnIceCandidatesReceived_Params.generate = function(generator_) {
    var generated = new SignallingReceiver_OnIceCandidatesReceived_Params;
    generated.iceCandidates = generator_.generateArray(function() {
      return generator_.generateStruct(sharing.mojom.IceCandidate, false);
    });
    return generated;
  };

  SignallingReceiver_OnIceCandidatesReceived_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.iceCandidates = mutator_.mutateArray(this.iceCandidates, function(val) {
        return mutator_.mutateStruct(val, sharing.mojom.IceCandidate, false);
      });
    }
    return this;
  };
  SignallingReceiver_OnIceCandidatesReceived_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  SignallingReceiver_OnIceCandidatesReceived_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  SignallingReceiver_OnIceCandidatesReceived_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  SignallingReceiver_OnIceCandidatesReceived_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate SignallingReceiver_OnIceCandidatesReceived_Params.iceCandidates
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 0, 8, new codec.PointerTo(IceCandidate), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  SignallingReceiver_OnIceCandidatesReceived_Params.encodedSize = codec.kStructHeaderSize + 8;

  SignallingReceiver_OnIceCandidatesReceived_Params.decode = function(decoder) {
    var packed;
    var val = new SignallingReceiver_OnIceCandidatesReceived_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.iceCandidates =
        decoder.decodeArrayPointer(new codec.PointerTo(IceCandidate));
    return val;
  };

  SignallingReceiver_OnIceCandidatesReceived_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(SignallingReceiver_OnIceCandidatesReceived_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeArrayPointer(new codec.PointerTo(IceCandidate), val.iceCandidates);
  };
  function SharingWebRtcConnectionDelegate_OnMessageReceived_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  SharingWebRtcConnectionDelegate_OnMessageReceived_Params.prototype.initDefaults_ = function() {
    this.message = null;
  };
  SharingWebRtcConnectionDelegate_OnMessageReceived_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  SharingWebRtcConnectionDelegate_OnMessageReceived_Params.generate = function(generator_) {
    var generated = new SharingWebRtcConnectionDelegate_OnMessageReceived_Params;
    generated.message = generator_.generateArray(function() {
      return generator_.generateUint8();
    });
    return generated;
  };

  SharingWebRtcConnectionDelegate_OnMessageReceived_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.message = mutator_.mutateArray(this.message, function(val) {
        return mutator_.mutateUint8(val);
      });
    }
    return this;
  };
  SharingWebRtcConnectionDelegate_OnMessageReceived_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  SharingWebRtcConnectionDelegate_OnMessageReceived_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  SharingWebRtcConnectionDelegate_OnMessageReceived_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  SharingWebRtcConnectionDelegate_OnMessageReceived_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate SharingWebRtcConnectionDelegate_OnMessageReceived_Params.message
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 0, 1, codec.Uint8, false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  SharingWebRtcConnectionDelegate_OnMessageReceived_Params.encodedSize = codec.kStructHeaderSize + 8;

  SharingWebRtcConnectionDelegate_OnMessageReceived_Params.decode = function(decoder) {
    var packed;
    var val = new SharingWebRtcConnectionDelegate_OnMessageReceived_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.message =
        decoder.decodeArrayPointer(codec.Uint8);
    return val;
  };

  SharingWebRtcConnectionDelegate_OnMessageReceived_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(SharingWebRtcConnectionDelegate_OnMessageReceived_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeArrayPointer(codec.Uint8, val.message);
  };
  function SharingWebRtcConnection_SendMessage_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  SharingWebRtcConnection_SendMessage_Params.prototype.initDefaults_ = function() {
    this.message = null;
  };
  SharingWebRtcConnection_SendMessage_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  SharingWebRtcConnection_SendMessage_Params.generate = function(generator_) {
    var generated = new SharingWebRtcConnection_SendMessage_Params;
    generated.message = generator_.generateArray(function() {
      return generator_.generateUint8();
    });
    return generated;
  };

  SharingWebRtcConnection_SendMessage_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.message = mutator_.mutateArray(this.message, function(val) {
        return mutator_.mutateUint8(val);
      });
    }
    return this;
  };
  SharingWebRtcConnection_SendMessage_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  SharingWebRtcConnection_SendMessage_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  SharingWebRtcConnection_SendMessage_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  SharingWebRtcConnection_SendMessage_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate SharingWebRtcConnection_SendMessage_Params.message
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 0, 1, codec.Uint8, false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  SharingWebRtcConnection_SendMessage_Params.encodedSize = codec.kStructHeaderSize + 8;

  SharingWebRtcConnection_SendMessage_Params.decode = function(decoder) {
    var packed;
    var val = new SharingWebRtcConnection_SendMessage_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.message =
        decoder.decodeArrayPointer(codec.Uint8);
    return val;
  };

  SharingWebRtcConnection_SendMessage_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(SharingWebRtcConnection_SendMessage_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeArrayPointer(codec.Uint8, val.message);
  };
  function SharingWebRtcConnection_SendMessage_ResponseParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  SharingWebRtcConnection_SendMessage_ResponseParams.prototype.initDefaults_ = function() {
    this.result = 0;
  };
  SharingWebRtcConnection_SendMessage_ResponseParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  SharingWebRtcConnection_SendMessage_ResponseParams.generate = function(generator_) {
    var generated = new SharingWebRtcConnection_SendMessage_ResponseParams;
    generated.result = generator_.generateEnum(0, 1);
    return generated;
  };

  SharingWebRtcConnection_SendMessage_ResponseParams.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.result = mutator_.mutateEnum(this.result, 0, 1);
    }
    return this;
  };
  SharingWebRtcConnection_SendMessage_ResponseParams.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  SharingWebRtcConnection_SendMessage_ResponseParams.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  SharingWebRtcConnection_SendMessage_ResponseParams.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  SharingWebRtcConnection_SendMessage_ResponseParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate SharingWebRtcConnection_SendMessage_ResponseParams.result
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 0, SendMessageResult);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  SharingWebRtcConnection_SendMessage_ResponseParams.encodedSize = codec.kStructHeaderSize + 8;

  SharingWebRtcConnection_SendMessage_ResponseParams.decode = function(decoder) {
    var packed;
    var val = new SharingWebRtcConnection_SendMessage_ResponseParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.result =
        decoder.decodeStruct(codec.Int32);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  SharingWebRtcConnection_SendMessage_ResponseParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(SharingWebRtcConnection_SendMessage_ResponseParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.result);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  var kSignallingSender_SendOffer_Name = 1038943054;
  var kSignallingSender_SendIceCandidates_Name = 1698190991;

  function SignallingSenderPtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(SignallingSender,
                                                   handleOrPtrInfo);
  }

  function SignallingSenderAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        SignallingSender, associatedInterfacePtrInfo);
  }

  SignallingSenderAssociatedPtr.prototype =
      Object.create(SignallingSenderPtr.prototype);
  SignallingSenderAssociatedPtr.prototype.constructor =
      SignallingSenderAssociatedPtr;

  function SignallingSenderProxy(receiver) {
    this.receiver_ = receiver;
  }
  SignallingSenderPtr.prototype.sendOffer = function() {
    return SignallingSenderProxy.prototype.sendOffer
        .apply(this.ptr.getProxy(), arguments);
  };

  SignallingSenderProxy.prototype.sendOffer = function(offer) {
    var params_ = new SignallingSender_SendOffer_Params();
    params_.offer = offer;
    return new Promise(function(resolve, reject) {
      var builder = new codec.MessageV1Builder(
          kSignallingSender_SendOffer_Name,
          codec.align(SignallingSender_SendOffer_Params.encodedSize),
          codec.kMessageExpectsResponse, 0);
      builder.encodeStruct(SignallingSender_SendOffer_Params, params_);
      var message = builder.finish();
      this.receiver_.acceptAndExpectResponse(message).then(function(message) {
        var reader = new codec.MessageReader(message);
        var responseParams =
            reader.decodeStruct(SignallingSender_SendOffer_ResponseParams);
        resolve(responseParams);
      }).catch(function(result) {
        reject(Error("Connection error: " + result));
      });
    }.bind(this));
  };
  SignallingSenderPtr.prototype.sendIceCandidates = function() {
    return SignallingSenderProxy.prototype.sendIceCandidates
        .apply(this.ptr.getProxy(), arguments);
  };

  SignallingSenderProxy.prototype.sendIceCandidates = function(iceCandidates) {
    var params_ = new SignallingSender_SendIceCandidates_Params();
    params_.iceCandidates = iceCandidates;
    var builder = new codec.MessageV0Builder(
        kSignallingSender_SendIceCandidates_Name,
        codec.align(SignallingSender_SendIceCandidates_Params.encodedSize));
    builder.encodeStruct(SignallingSender_SendIceCandidates_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };

  function SignallingSenderStub(delegate) {
    this.delegate_ = delegate;
  }
  SignallingSenderStub.prototype.sendOffer = function(offer) {
    return this.delegate_ && this.delegate_.sendOffer && this.delegate_.sendOffer(offer);
  }
  SignallingSenderStub.prototype.sendIceCandidates = function(iceCandidates) {
    return this.delegate_ && this.delegate_.sendIceCandidates && this.delegate_.sendIceCandidates(iceCandidates);
  }

  SignallingSenderStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kSignallingSender_SendIceCandidates_Name:
      var params = reader.decodeStruct(SignallingSender_SendIceCandidates_Params);
      this.sendIceCandidates(params.iceCandidates);
      return true;
    default:
      return false;
    }
  };

  SignallingSenderStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kSignallingSender_SendOffer_Name:
      var params = reader.decodeStruct(SignallingSender_SendOffer_Params);
      this.sendOffer(params.offer).then(function(response) {
        var responseParams =
            new SignallingSender_SendOffer_ResponseParams();
        responseParams.answer = response.answer;
        var builder = new codec.MessageV1Builder(
            kSignallingSender_SendOffer_Name,
            codec.align(SignallingSender_SendOffer_ResponseParams.encodedSize),
            codec.kMessageIsResponse, reader.requestID);
        builder.encodeStruct(SignallingSender_SendOffer_ResponseParams,
                             responseParams);
        var message = builder.finish();
        responder.accept(message);
      });
      return true;
    default:
      return false;
    }
  };

  function validateSignallingSenderRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kSignallingSender_SendOffer_Name:
        if (message.expectsResponse())
          paramsClass = SignallingSender_SendOffer_Params;
      break;
      case kSignallingSender_SendIceCandidates_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = SignallingSender_SendIceCandidates_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validateSignallingSenderResponse(messageValidator) {
   var message = messageValidator.message;
   var paramsClass = null;
   switch (message.getName()) {
      case kSignallingSender_SendOffer_Name:
        if (message.isResponse())
          paramsClass = SignallingSender_SendOffer_ResponseParams;
        break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  var SignallingSender = {
    name: 'sharing.mojom.SignallingSender',
    kVersion: 0,
    ptrClass: SignallingSenderPtr,
    proxyClass: SignallingSenderProxy,
    stubClass: SignallingSenderStub,
    validateRequest: validateSignallingSenderRequest,
    validateResponse: validateSignallingSenderResponse,
    mojomId: 'chrome/services/sharing/public/mojom/webrtc.mojom',
    fuzzMethods: {
      sendOffer: {
        params: SignallingSender_SendOffer_Params,
      },
      sendIceCandidates: {
        params: SignallingSender_SendIceCandidates_Params,
      },
    },
  };
  SignallingSenderStub.prototype.validator = validateSignallingSenderRequest;
  SignallingSenderProxy.prototype.validator = validateSignallingSenderResponse;
  var kSignallingReceiver_OnOfferReceived_Name = 1714833625;
  var kSignallingReceiver_OnIceCandidatesReceived_Name = 128259729;

  function SignallingReceiverPtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(SignallingReceiver,
                                                   handleOrPtrInfo);
  }

  function SignallingReceiverAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        SignallingReceiver, associatedInterfacePtrInfo);
  }

  SignallingReceiverAssociatedPtr.prototype =
      Object.create(SignallingReceiverPtr.prototype);
  SignallingReceiverAssociatedPtr.prototype.constructor =
      SignallingReceiverAssociatedPtr;

  function SignallingReceiverProxy(receiver) {
    this.receiver_ = receiver;
  }
  SignallingReceiverPtr.prototype.onOfferReceived = function() {
    return SignallingReceiverProxy.prototype.onOfferReceived
        .apply(this.ptr.getProxy(), arguments);
  };

  SignallingReceiverProxy.prototype.onOfferReceived = function(offer) {
    var params_ = new SignallingReceiver_OnOfferReceived_Params();
    params_.offer = offer;
    return new Promise(function(resolve, reject) {
      var builder = new codec.MessageV1Builder(
          kSignallingReceiver_OnOfferReceived_Name,
          codec.align(SignallingReceiver_OnOfferReceived_Params.encodedSize),
          codec.kMessageExpectsResponse, 0);
      builder.encodeStruct(SignallingReceiver_OnOfferReceived_Params, params_);
      var message = builder.finish();
      this.receiver_.acceptAndExpectResponse(message).then(function(message) {
        var reader = new codec.MessageReader(message);
        var responseParams =
            reader.decodeStruct(SignallingReceiver_OnOfferReceived_ResponseParams);
        resolve(responseParams);
      }).catch(function(result) {
        reject(Error("Connection error: " + result));
      });
    }.bind(this));
  };
  SignallingReceiverPtr.prototype.onIceCandidatesReceived = function() {
    return SignallingReceiverProxy.prototype.onIceCandidatesReceived
        .apply(this.ptr.getProxy(), arguments);
  };

  SignallingReceiverProxy.prototype.onIceCandidatesReceived = function(iceCandidates) {
    var params_ = new SignallingReceiver_OnIceCandidatesReceived_Params();
    params_.iceCandidates = iceCandidates;
    var builder = new codec.MessageV0Builder(
        kSignallingReceiver_OnIceCandidatesReceived_Name,
        codec.align(SignallingReceiver_OnIceCandidatesReceived_Params.encodedSize));
    builder.encodeStruct(SignallingReceiver_OnIceCandidatesReceived_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };

  function SignallingReceiverStub(delegate) {
    this.delegate_ = delegate;
  }
  SignallingReceiverStub.prototype.onOfferReceived = function(offer) {
    return this.delegate_ && this.delegate_.onOfferReceived && this.delegate_.onOfferReceived(offer);
  }
  SignallingReceiverStub.prototype.onIceCandidatesReceived = function(iceCandidates) {
    return this.delegate_ && this.delegate_.onIceCandidatesReceived && this.delegate_.onIceCandidatesReceived(iceCandidates);
  }

  SignallingReceiverStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kSignallingReceiver_OnIceCandidatesReceived_Name:
      var params = reader.decodeStruct(SignallingReceiver_OnIceCandidatesReceived_Params);
      this.onIceCandidatesReceived(params.iceCandidates);
      return true;
    default:
      return false;
    }
  };

  SignallingReceiverStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kSignallingReceiver_OnOfferReceived_Name:
      var params = reader.decodeStruct(SignallingReceiver_OnOfferReceived_Params);
      this.onOfferReceived(params.offer).then(function(response) {
        var responseParams =
            new SignallingReceiver_OnOfferReceived_ResponseParams();
        responseParams.answer = response.answer;
        var builder = new codec.MessageV1Builder(
            kSignallingReceiver_OnOfferReceived_Name,
            codec.align(SignallingReceiver_OnOfferReceived_ResponseParams.encodedSize),
            codec.kMessageIsResponse, reader.requestID);
        builder.encodeStruct(SignallingReceiver_OnOfferReceived_ResponseParams,
                             responseParams);
        var message = builder.finish();
        responder.accept(message);
      });
      return true;
    default:
      return false;
    }
  };

  function validateSignallingReceiverRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kSignallingReceiver_OnOfferReceived_Name:
        if (message.expectsResponse())
          paramsClass = SignallingReceiver_OnOfferReceived_Params;
      break;
      case kSignallingReceiver_OnIceCandidatesReceived_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = SignallingReceiver_OnIceCandidatesReceived_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validateSignallingReceiverResponse(messageValidator) {
   var message = messageValidator.message;
   var paramsClass = null;
   switch (message.getName()) {
      case kSignallingReceiver_OnOfferReceived_Name:
        if (message.isResponse())
          paramsClass = SignallingReceiver_OnOfferReceived_ResponseParams;
        break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  var SignallingReceiver = {
    name: 'sharing.mojom.SignallingReceiver',
    kVersion: 0,
    ptrClass: SignallingReceiverPtr,
    proxyClass: SignallingReceiverProxy,
    stubClass: SignallingReceiverStub,
    validateRequest: validateSignallingReceiverRequest,
    validateResponse: validateSignallingReceiverResponse,
    mojomId: 'chrome/services/sharing/public/mojom/webrtc.mojom',
    fuzzMethods: {
      onOfferReceived: {
        params: SignallingReceiver_OnOfferReceived_Params,
      },
      onIceCandidatesReceived: {
        params: SignallingReceiver_OnIceCandidatesReceived_Params,
      },
    },
  };
  SignallingReceiverStub.prototype.validator = validateSignallingReceiverRequest;
  SignallingReceiverProxy.prototype.validator = validateSignallingReceiverResponse;
  var kSharingWebRtcConnectionDelegate_OnMessageReceived_Name = 2043170702;

  function SharingWebRtcConnectionDelegatePtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(SharingWebRtcConnectionDelegate,
                                                   handleOrPtrInfo);
  }

  function SharingWebRtcConnectionDelegateAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        SharingWebRtcConnectionDelegate, associatedInterfacePtrInfo);
  }

  SharingWebRtcConnectionDelegateAssociatedPtr.prototype =
      Object.create(SharingWebRtcConnectionDelegatePtr.prototype);
  SharingWebRtcConnectionDelegateAssociatedPtr.prototype.constructor =
      SharingWebRtcConnectionDelegateAssociatedPtr;

  function SharingWebRtcConnectionDelegateProxy(receiver) {
    this.receiver_ = receiver;
  }
  SharingWebRtcConnectionDelegatePtr.prototype.onMessageReceived = function() {
    return SharingWebRtcConnectionDelegateProxy.prototype.onMessageReceived
        .apply(this.ptr.getProxy(), arguments);
  };

  SharingWebRtcConnectionDelegateProxy.prototype.onMessageReceived = function(message) {
    var params_ = new SharingWebRtcConnectionDelegate_OnMessageReceived_Params();
    params_.message = message;
    var builder = new codec.MessageV0Builder(
        kSharingWebRtcConnectionDelegate_OnMessageReceived_Name,
        codec.align(SharingWebRtcConnectionDelegate_OnMessageReceived_Params.encodedSize));
    builder.encodeStruct(SharingWebRtcConnectionDelegate_OnMessageReceived_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };

  function SharingWebRtcConnectionDelegateStub(delegate) {
    this.delegate_ = delegate;
  }
  SharingWebRtcConnectionDelegateStub.prototype.onMessageReceived = function(message) {
    return this.delegate_ && this.delegate_.onMessageReceived && this.delegate_.onMessageReceived(message);
  }

  SharingWebRtcConnectionDelegateStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kSharingWebRtcConnectionDelegate_OnMessageReceived_Name:
      var params = reader.decodeStruct(SharingWebRtcConnectionDelegate_OnMessageReceived_Params);
      this.onMessageReceived(params.message);
      return true;
    default:
      return false;
    }
  };

  SharingWebRtcConnectionDelegateStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    default:
      return false;
    }
  };

  function validateSharingWebRtcConnectionDelegateRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kSharingWebRtcConnectionDelegate_OnMessageReceived_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = SharingWebRtcConnectionDelegate_OnMessageReceived_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validateSharingWebRtcConnectionDelegateResponse(messageValidator) {
    return validator.validationError.NONE;
  }

  var SharingWebRtcConnectionDelegate = {
    name: 'sharing.mojom.SharingWebRtcConnectionDelegate',
    kVersion: 0,
    ptrClass: SharingWebRtcConnectionDelegatePtr,
    proxyClass: SharingWebRtcConnectionDelegateProxy,
    stubClass: SharingWebRtcConnectionDelegateStub,
    validateRequest: validateSharingWebRtcConnectionDelegateRequest,
    validateResponse: null,
    mojomId: 'chrome/services/sharing/public/mojom/webrtc.mojom',
    fuzzMethods: {
      onMessageReceived: {
        params: SharingWebRtcConnectionDelegate_OnMessageReceived_Params,
      },
    },
  };
  SharingWebRtcConnectionDelegateStub.prototype.validator = validateSharingWebRtcConnectionDelegateRequest;
  SharingWebRtcConnectionDelegateProxy.prototype.validator = null;
  var kSharingWebRtcConnection_SendMessage_Name = 264797595;

  function SharingWebRtcConnectionPtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(SharingWebRtcConnection,
                                                   handleOrPtrInfo);
  }

  function SharingWebRtcConnectionAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        SharingWebRtcConnection, associatedInterfacePtrInfo);
  }

  SharingWebRtcConnectionAssociatedPtr.prototype =
      Object.create(SharingWebRtcConnectionPtr.prototype);
  SharingWebRtcConnectionAssociatedPtr.prototype.constructor =
      SharingWebRtcConnectionAssociatedPtr;

  function SharingWebRtcConnectionProxy(receiver) {
    this.receiver_ = receiver;
  }
  SharingWebRtcConnectionPtr.prototype.sendMessage = function() {
    return SharingWebRtcConnectionProxy.prototype.sendMessage
        .apply(this.ptr.getProxy(), arguments);
  };

  SharingWebRtcConnectionProxy.prototype.sendMessage = function(message) {
    var params_ = new SharingWebRtcConnection_SendMessage_Params();
    params_.message = message;
    return new Promise(function(resolve, reject) {
      var builder = new codec.MessageV1Builder(
          kSharingWebRtcConnection_SendMessage_Name,
          codec.align(SharingWebRtcConnection_SendMessage_Params.encodedSize),
          codec.kMessageExpectsResponse, 0);
      builder.encodeStruct(SharingWebRtcConnection_SendMessage_Params, params_);
      var message = builder.finish();
      this.receiver_.acceptAndExpectResponse(message).then(function(message) {
        var reader = new codec.MessageReader(message);
        var responseParams =
            reader.decodeStruct(SharingWebRtcConnection_SendMessage_ResponseParams);
        resolve(responseParams);
      }).catch(function(result) {
        reject(Error("Connection error: " + result));
      });
    }.bind(this));
  };

  function SharingWebRtcConnectionStub(delegate) {
    this.delegate_ = delegate;
  }
  SharingWebRtcConnectionStub.prototype.sendMessage = function(message) {
    return this.delegate_ && this.delegate_.sendMessage && this.delegate_.sendMessage(message);
  }

  SharingWebRtcConnectionStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    default:
      return false;
    }
  };

  SharingWebRtcConnectionStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kSharingWebRtcConnection_SendMessage_Name:
      var params = reader.decodeStruct(SharingWebRtcConnection_SendMessage_Params);
      this.sendMessage(params.message).then(function(response) {
        var responseParams =
            new SharingWebRtcConnection_SendMessage_ResponseParams();
        responseParams.result = response.result;
        var builder = new codec.MessageV1Builder(
            kSharingWebRtcConnection_SendMessage_Name,
            codec.align(SharingWebRtcConnection_SendMessage_ResponseParams.encodedSize),
            codec.kMessageIsResponse, reader.requestID);
        builder.encodeStruct(SharingWebRtcConnection_SendMessage_ResponseParams,
                             responseParams);
        var message = builder.finish();
        responder.accept(message);
      });
      return true;
    default:
      return false;
    }
  };

  function validateSharingWebRtcConnectionRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kSharingWebRtcConnection_SendMessage_Name:
        if (message.expectsResponse())
          paramsClass = SharingWebRtcConnection_SendMessage_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validateSharingWebRtcConnectionResponse(messageValidator) {
   var message = messageValidator.message;
   var paramsClass = null;
   switch (message.getName()) {
      case kSharingWebRtcConnection_SendMessage_Name:
        if (message.isResponse())
          paramsClass = SharingWebRtcConnection_SendMessage_ResponseParams;
        break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  var SharingWebRtcConnection = {
    name: 'sharing.mojom.SharingWebRtcConnection',
    kVersion: 0,
    ptrClass: SharingWebRtcConnectionPtr,
    proxyClass: SharingWebRtcConnectionProxy,
    stubClass: SharingWebRtcConnectionStub,
    validateRequest: validateSharingWebRtcConnectionRequest,
    validateResponse: validateSharingWebRtcConnectionResponse,
    mojomId: 'chrome/services/sharing/public/mojom/webrtc.mojom',
    fuzzMethods: {
      sendMessage: {
        params: SharingWebRtcConnection_SendMessage_Params,
      },
    },
  };
  SharingWebRtcConnectionStub.prototype.validator = validateSharingWebRtcConnectionRequest;
  SharingWebRtcConnectionProxy.prototype.validator = validateSharingWebRtcConnectionResponse;
  exports.SendMessageResult = SendMessageResult;
  exports.IceCandidate = IceCandidate;
  exports.IceServer = IceServer;
  exports.SignallingSender = SignallingSender;
  exports.SignallingSenderPtr = SignallingSenderPtr;
  exports.SignallingSenderAssociatedPtr = SignallingSenderAssociatedPtr;
  exports.SignallingReceiver = SignallingReceiver;
  exports.SignallingReceiverPtr = SignallingReceiverPtr;
  exports.SignallingReceiverAssociatedPtr = SignallingReceiverAssociatedPtr;
  exports.SharingWebRtcConnectionDelegate = SharingWebRtcConnectionDelegate;
  exports.SharingWebRtcConnectionDelegatePtr = SharingWebRtcConnectionDelegatePtr;
  exports.SharingWebRtcConnectionDelegateAssociatedPtr = SharingWebRtcConnectionDelegateAssociatedPtr;
  exports.SharingWebRtcConnection = SharingWebRtcConnection;
  exports.SharingWebRtcConnectionPtr = SharingWebRtcConnectionPtr;
  exports.SharingWebRtcConnectionAssociatedPtr = SharingWebRtcConnectionAssociatedPtr;
})();