// content/browser/process_internals/process_internals.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'content/browser/process_internals/process_internals.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('mojom');
  var url$ =
      mojo.internal.exposeNamespace('url.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'url/mojom/url.mojom', '../../../url/mojom/url.mojom.js');
  }



  function SiteInstanceInfo(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  SiteInstanceInfo.prototype.initDefaults_ = function() {
    this.id = 0;
    this.locked = false;
    this.siteUrl = null;
  };
  SiteInstanceInfo.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  SiteInstanceInfo.generate = function(generator_) {
    var generated = new SiteInstanceInfo;
    generated.id = generator_.generateInt32();
    generated.locked = generator_.generateBool();
    generated.siteUrl = generator_.generateStruct(url.mojom.Url, true);
    return generated;
  };

  SiteInstanceInfo.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.id = mutator_.mutateInt32(this.id);
    }
    if (mutator_.chooseMutateField()) {
      this.locked = mutator_.mutateBool(this.locked);
    }
    if (mutator_.chooseMutateField()) {
      this.siteUrl = mutator_.mutateStruct(this.siteUrl, url.mojom.Url, true);
    }
    return this;
  };
  SiteInstanceInfo.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  SiteInstanceInfo.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  SiteInstanceInfo.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  SiteInstanceInfo.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 24}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;




    // validate SiteInstanceInfo.siteUrl
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 8, url$.Url, true);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  SiteInstanceInfo.encodedSize = codec.kStructHeaderSize + 16;

  SiteInstanceInfo.decode = function(decoder) {
    var packed;
    var val = new SiteInstanceInfo();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.id =
        decoder.decodeStruct(codec.Int32);
    packed = decoder.readUint8();
    val.locked = (packed >> 0) & 1 ? true : false;
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    val.siteUrl =
        decoder.decodeStructPointer(url$.Url);
    return val;
  };

  SiteInstanceInfo.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(SiteInstanceInfo.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.id);
    packed = 0;
    packed |= (val.locked & 1) << 0
    encoder.writeUint8(packed);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.encodeStructPointer(url$.Url, val.siteUrl);
  };
  function FrameInfo(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  FrameInfo.prototype.initDefaults_ = function() {
    this.routingId = 0;
    this.processId = 0;
    this.siteInstance = null;
    this.lastCommittedUrl = null;
    this.subframes = null;
  };
  FrameInfo.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  FrameInfo.generate = function(generator_) {
    var generated = new FrameInfo;
    generated.routingId = generator_.generateInt32();
    generated.processId = generator_.generateInt32();
    generated.siteInstance = generator_.generateStruct(mojom.SiteInstanceInfo, false);
    generated.lastCommittedUrl = generator_.generateStruct(url.mojom.Url, true);
    generated.subframes = generator_.generateArray(function() {
      return generator_.generateStruct(mojom.FrameInfo, false);
    });
    return generated;
  };

  FrameInfo.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.routingId = mutator_.mutateInt32(this.routingId);
    }
    if (mutator_.chooseMutateField()) {
      this.processId = mutator_.mutateInt32(this.processId);
    }
    if (mutator_.chooseMutateField()) {
      this.siteInstance = mutator_.mutateStruct(this.siteInstance, mojom.SiteInstanceInfo, false);
    }
    if (mutator_.chooseMutateField()) {
      this.lastCommittedUrl = mutator_.mutateStruct(this.lastCommittedUrl, url.mojom.Url, true);
    }
    if (mutator_.chooseMutateField()) {
      this.subframes = mutator_.mutateArray(this.subframes, function(val) {
        return mutator_.mutateStruct(val, mojom.FrameInfo, false);
      });
    }
    return this;
  };
  FrameInfo.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  FrameInfo.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  FrameInfo.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  FrameInfo.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 40}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;




    // validate FrameInfo.siteInstance
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 8, SiteInstanceInfo, false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate FrameInfo.lastCommittedUrl
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 16, url$.Url, true);
    if (err !== validator.validationError.NONE)
        return err;


    // validate FrameInfo.subframes
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 24, 8, new codec.PointerTo(FrameInfo), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  FrameInfo.encodedSize = codec.kStructHeaderSize + 32;

  FrameInfo.decode = function(decoder) {
    var packed;
    var val = new FrameInfo();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.routingId =
        decoder.decodeStruct(codec.Int32);
    val.processId =
        decoder.decodeStruct(codec.Int32);
    val.siteInstance =
        decoder.decodeStructPointer(SiteInstanceInfo);
    val.lastCommittedUrl =
        decoder.decodeStructPointer(url$.Url);
    val.subframes =
        decoder.decodeArrayPointer(new codec.PointerTo(FrameInfo));
    return val;
  };

  FrameInfo.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(FrameInfo.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.routingId);
    encoder.encodeStruct(codec.Int32, val.processId);
    encoder.encodeStructPointer(SiteInstanceInfo, val.siteInstance);
    encoder.encodeStructPointer(url$.Url, val.lastCommittedUrl);
    encoder.encodeArrayPointer(new codec.PointerTo(FrameInfo), val.subframes);
  };
  function WebContentsInfo(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  WebContentsInfo.prototype.initDefaults_ = function() {
    this.title = null;
    this.rootFrame = null;
  };
  WebContentsInfo.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  WebContentsInfo.generate = function(generator_) {
    var generated = new WebContentsInfo;
    generated.title = generator_.generateString(false);
    generated.rootFrame = generator_.generateStruct(mojom.FrameInfo, false);
    return generated;
  };

  WebContentsInfo.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.title = mutator_.mutateString(this.title, false);
    }
    if (mutator_.chooseMutateField()) {
      this.rootFrame = mutator_.mutateStruct(this.rootFrame, mojom.FrameInfo, false);
    }
    return this;
  };
  WebContentsInfo.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  WebContentsInfo.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  WebContentsInfo.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  WebContentsInfo.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 24}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate WebContentsInfo.title
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate WebContentsInfo.rootFrame
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 8, FrameInfo, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  WebContentsInfo.encodedSize = codec.kStructHeaderSize + 16;

  WebContentsInfo.decode = function(decoder) {
    var packed;
    var val = new WebContentsInfo();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.title =
        decoder.decodeStruct(codec.String);
    val.rootFrame =
        decoder.decodeStructPointer(FrameInfo);
    return val;
  };

  WebContentsInfo.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(WebContentsInfo.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.title);
    encoder.encodeStructPointer(FrameInfo, val.rootFrame);
  };
  function IsolatedOriginInfo(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  IsolatedOriginInfo.prototype.initDefaults_ = function() {
    this.origin = null;
    this.source = null;
  };
  IsolatedOriginInfo.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  IsolatedOriginInfo.generate = function(generator_) {
    var generated = new IsolatedOriginInfo;
    generated.origin = generator_.generateString(false);
    generated.source = generator_.generateString(false);
    return generated;
  };

  IsolatedOriginInfo.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.origin = mutator_.mutateString(this.origin, false);
    }
    if (mutator_.chooseMutateField()) {
      this.source = mutator_.mutateString(this.source, false);
    }
    return this;
  };
  IsolatedOriginInfo.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  IsolatedOriginInfo.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  IsolatedOriginInfo.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  IsolatedOriginInfo.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 24}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate IsolatedOriginInfo.origin
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate IsolatedOriginInfo.source
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 8, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  IsolatedOriginInfo.encodedSize = codec.kStructHeaderSize + 16;

  IsolatedOriginInfo.decode = function(decoder) {
    var packed;
    var val = new IsolatedOriginInfo();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.origin =
        decoder.decodeStruct(codec.String);
    val.source =
        decoder.decodeStruct(codec.String);
    return val;
  };

  IsolatedOriginInfo.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(IsolatedOriginInfo.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.origin);
    encoder.encodeStruct(codec.String, val.source);
  };
  function ProcessInternalsHandler_GetIsolationMode_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  ProcessInternalsHandler_GetIsolationMode_Params.prototype.initDefaults_ = function() {
  };
  ProcessInternalsHandler_GetIsolationMode_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  ProcessInternalsHandler_GetIsolationMode_Params.generate = function(generator_) {
    var generated = new ProcessInternalsHandler_GetIsolationMode_Params;
    return generated;
  };

  ProcessInternalsHandler_GetIsolationMode_Params.prototype.mutate = function(mutator_) {
    return this;
  };
  ProcessInternalsHandler_GetIsolationMode_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  ProcessInternalsHandler_GetIsolationMode_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  ProcessInternalsHandler_GetIsolationMode_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  ProcessInternalsHandler_GetIsolationMode_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 8}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  ProcessInternalsHandler_GetIsolationMode_Params.encodedSize = codec.kStructHeaderSize + 0;

  ProcessInternalsHandler_GetIsolationMode_Params.decode = function(decoder) {
    var packed;
    var val = new ProcessInternalsHandler_GetIsolationMode_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    return val;
  };

  ProcessInternalsHandler_GetIsolationMode_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(ProcessInternalsHandler_GetIsolationMode_Params.encodedSize);
    encoder.writeUint32(0);
  };
  function ProcessInternalsHandler_GetIsolationMode_ResponseParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  ProcessInternalsHandler_GetIsolationMode_ResponseParams.prototype.initDefaults_ = function() {
    this.mode = null;
  };
  ProcessInternalsHandler_GetIsolationMode_ResponseParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  ProcessInternalsHandler_GetIsolationMode_ResponseParams.generate = function(generator_) {
    var generated = new ProcessInternalsHandler_GetIsolationMode_ResponseParams;
    generated.mode = generator_.generateString(false);
    return generated;
  };

  ProcessInternalsHandler_GetIsolationMode_ResponseParams.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.mode = mutator_.mutateString(this.mode, false);
    }
    return this;
  };
  ProcessInternalsHandler_GetIsolationMode_ResponseParams.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  ProcessInternalsHandler_GetIsolationMode_ResponseParams.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  ProcessInternalsHandler_GetIsolationMode_ResponseParams.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  ProcessInternalsHandler_GetIsolationMode_ResponseParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate ProcessInternalsHandler_GetIsolationMode_ResponseParams.mode
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  ProcessInternalsHandler_GetIsolationMode_ResponseParams.encodedSize = codec.kStructHeaderSize + 8;

  ProcessInternalsHandler_GetIsolationMode_ResponseParams.decode = function(decoder) {
    var packed;
    var val = new ProcessInternalsHandler_GetIsolationMode_ResponseParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.mode =
        decoder.decodeStruct(codec.String);
    return val;
  };

  ProcessInternalsHandler_GetIsolationMode_ResponseParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(ProcessInternalsHandler_GetIsolationMode_ResponseParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.mode);
  };
  function ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.prototype.initDefaults_ = function() {
  };
  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.generate = function(generator_) {
    var generated = new ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params;
    return generated;
  };

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.prototype.mutate = function(mutator_) {
    return this;
  };
  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 8}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.encodedSize = codec.kStructHeaderSize + 0;

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.decode = function(decoder) {
    var packed;
    var val = new ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    return val;
  };

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.encodedSize);
    encoder.writeUint32(0);
  };
  function ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.prototype.initDefaults_ = function() {
    this.isolatedOrigins = null;
  };
  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.generate = function(generator_) {
    var generated = new ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams;
    generated.isolatedOrigins = generator_.generateArray(function() {
      return generator_.generateString(false);
    });
    return generated;
  };

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.isolatedOrigins = mutator_.mutateArray(this.isolatedOrigins, function(val) {
        return mutator_.mutateString(val, false);
      });
    }
    return this;
  };
  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.isolatedOrigins
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 0, 8, codec.String, false, [0, 0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.encodedSize = codec.kStructHeaderSize + 8;

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.decode = function(decoder) {
    var packed;
    var val = new ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.isolatedOrigins =
        decoder.decodeArrayPointer(codec.String);
    return val;
  };

  ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeArrayPointer(codec.String, val.isolatedOrigins);
  };
  function ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.prototype.initDefaults_ = function() {
  };
  ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.generate = function(generator_) {
    var generated = new ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params;
    return generated;
  };

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.prototype.mutate = function(mutator_) {
    return this;
  };
  ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 8}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.encodedSize = codec.kStructHeaderSize + 0;

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.decode = function(decoder) {
    var packed;
    var val = new ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    return val;
  };

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.encodedSize);
    encoder.writeUint32(0);
  };
  function ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.prototype.initDefaults_ = function() {
    this.isolatedOrigins = null;
  };
  ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.generate = function(generator_) {
    var generated = new ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams;
    generated.isolatedOrigins = generator_.generateArray(function() {
      return generator_.generateStruct(mojom.IsolatedOriginInfo, false);
    });
    return generated;
  };

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.isolatedOrigins = mutator_.mutateArray(this.isolatedOrigins, function(val) {
        return mutator_.mutateStruct(val, mojom.IsolatedOriginInfo, false);
      });
    }
    return this;
  };
  ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.isolatedOrigins
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 0, 8, new codec.PointerTo(IsolatedOriginInfo), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.encodedSize = codec.kStructHeaderSize + 8;

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.decode = function(decoder) {
    var packed;
    var val = new ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.isolatedOrigins =
        decoder.decodeArrayPointer(new codec.PointerTo(IsolatedOriginInfo));
    return val;
  };

  ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeArrayPointer(new codec.PointerTo(IsolatedOriginInfo), val.isolatedOrigins);
  };
  function ProcessInternalsHandler_GetAllWebContentsInfo_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  ProcessInternalsHandler_GetAllWebContentsInfo_Params.prototype.initDefaults_ = function() {
  };
  ProcessInternalsHandler_GetAllWebContentsInfo_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  ProcessInternalsHandler_GetAllWebContentsInfo_Params.generate = function(generator_) {
    var generated = new ProcessInternalsHandler_GetAllWebContentsInfo_Params;
    return generated;
  };

  ProcessInternalsHandler_GetAllWebContentsInfo_Params.prototype.mutate = function(mutator_) {
    return this;
  };
  ProcessInternalsHandler_GetAllWebContentsInfo_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  ProcessInternalsHandler_GetAllWebContentsInfo_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  ProcessInternalsHandler_GetAllWebContentsInfo_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  ProcessInternalsHandler_GetAllWebContentsInfo_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 8}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  ProcessInternalsHandler_GetAllWebContentsInfo_Params.encodedSize = codec.kStructHeaderSize + 0;

  ProcessInternalsHandler_GetAllWebContentsInfo_Params.decode = function(decoder) {
    var packed;
    var val = new ProcessInternalsHandler_GetAllWebContentsInfo_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    return val;
  };

  ProcessInternalsHandler_GetAllWebContentsInfo_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(ProcessInternalsHandler_GetAllWebContentsInfo_Params.encodedSize);
    encoder.writeUint32(0);
  };
  function ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.prototype.initDefaults_ = function() {
    this.infos = null;
  };
  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.generate = function(generator_) {
    var generated = new ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams;
    generated.infos = generator_.generateArray(function() {
      return generator_.generateStruct(mojom.WebContentsInfo, false);
    });
    return generated;
  };

  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.infos = mutator_.mutateArray(this.infos, function(val) {
        return mutator_.mutateStruct(val, mojom.WebContentsInfo, false);
      });
    }
    return this;
  };
  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.infos
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 0, 8, new codec.PointerTo(WebContentsInfo), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.encodedSize = codec.kStructHeaderSize + 8;

  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.decode = function(decoder) {
    var packed;
    var val = new ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.infos =
        decoder.decodeArrayPointer(new codec.PointerTo(WebContentsInfo));
    return val;
  };

  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeArrayPointer(new codec.PointerTo(WebContentsInfo), val.infos);
  };
  var kProcessInternalsHandler_GetIsolationMode_Name = 1106141157;
  var kProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Name = 1125607955;
  var kProcessInternalsHandler_GetGloballyIsolatedOrigins_Name = 784828261;
  var kProcessInternalsHandler_GetAllWebContentsInfo_Name = 272299198;

  function ProcessInternalsHandlerPtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(ProcessInternalsHandler,
                                                   handleOrPtrInfo);
  }

  function ProcessInternalsHandlerAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        ProcessInternalsHandler, associatedInterfacePtrInfo);
  }

  ProcessInternalsHandlerAssociatedPtr.prototype =
      Object.create(ProcessInternalsHandlerPtr.prototype);
  ProcessInternalsHandlerAssociatedPtr.prototype.constructor =
      ProcessInternalsHandlerAssociatedPtr;

  function ProcessInternalsHandlerProxy(receiver) {
    this.receiver_ = receiver;
  }
  ProcessInternalsHandlerPtr.prototype.getIsolationMode = function() {
    return ProcessInternalsHandlerProxy.prototype.getIsolationMode
        .apply(this.ptr.getProxy(), arguments);
  };

  ProcessInternalsHandlerProxy.prototype.getIsolationMode = function() {
    var params_ = new ProcessInternalsHandler_GetIsolationMode_Params();
    return new Promise(function(resolve, reject) {
      var builder = new codec.MessageV1Builder(
          kProcessInternalsHandler_GetIsolationMode_Name,
          codec.align(ProcessInternalsHandler_GetIsolationMode_Params.encodedSize),
          codec.kMessageExpectsResponse, 0);
      builder.encodeStruct(ProcessInternalsHandler_GetIsolationMode_Params, params_);
      var message = builder.finish();
      this.receiver_.acceptAndExpectResponse(message).then(function(message) {
        var reader = new codec.MessageReader(message);
        var responseParams =
            reader.decodeStruct(ProcessInternalsHandler_GetIsolationMode_ResponseParams);
        resolve(responseParams);
      }).catch(function(result) {
        reject(Error("Connection error: " + result));
      });
    }.bind(this));
  };
  ProcessInternalsHandlerPtr.prototype.getUserTriggeredIsolatedOrigins = function() {
    return ProcessInternalsHandlerProxy.prototype.getUserTriggeredIsolatedOrigins
        .apply(this.ptr.getProxy(), arguments);
  };

  ProcessInternalsHandlerProxy.prototype.getUserTriggeredIsolatedOrigins = function() {
    var params_ = new ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params();
    return new Promise(function(resolve, reject) {
      var builder = new codec.MessageV1Builder(
          kProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Name,
          codec.align(ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params.encodedSize),
          codec.kMessageExpectsResponse, 0);
      builder.encodeStruct(ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params, params_);
      var message = builder.finish();
      this.receiver_.acceptAndExpectResponse(message).then(function(message) {
        var reader = new codec.MessageReader(message);
        var responseParams =
            reader.decodeStruct(ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams);
        resolve(responseParams);
      }).catch(function(result) {
        reject(Error("Connection error: " + result));
      });
    }.bind(this));
  };
  ProcessInternalsHandlerPtr.prototype.getGloballyIsolatedOrigins = function() {
    return ProcessInternalsHandlerProxy.prototype.getGloballyIsolatedOrigins
        .apply(this.ptr.getProxy(), arguments);
  };

  ProcessInternalsHandlerProxy.prototype.getGloballyIsolatedOrigins = function() {
    var params_ = new ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params();
    return new Promise(function(resolve, reject) {
      var builder = new codec.MessageV1Builder(
          kProcessInternalsHandler_GetGloballyIsolatedOrigins_Name,
          codec.align(ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params.encodedSize),
          codec.kMessageExpectsResponse, 0);
      builder.encodeStruct(ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params, params_);
      var message = builder.finish();
      this.receiver_.acceptAndExpectResponse(message).then(function(message) {
        var reader = new codec.MessageReader(message);
        var responseParams =
            reader.decodeStruct(ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams);
        resolve(responseParams);
      }).catch(function(result) {
        reject(Error("Connection error: " + result));
      });
    }.bind(this));
  };
  ProcessInternalsHandlerPtr.prototype.getAllWebContentsInfo = function() {
    return ProcessInternalsHandlerProxy.prototype.getAllWebContentsInfo
        .apply(this.ptr.getProxy(), arguments);
  };

  ProcessInternalsHandlerProxy.prototype.getAllWebContentsInfo = function() {
    var params_ = new ProcessInternalsHandler_GetAllWebContentsInfo_Params();
    return new Promise(function(resolve, reject) {
      var builder = new codec.MessageV1Builder(
          kProcessInternalsHandler_GetAllWebContentsInfo_Name,
          codec.align(ProcessInternalsHandler_GetAllWebContentsInfo_Params.encodedSize),
          codec.kMessageExpectsResponse, 0);
      builder.encodeStruct(ProcessInternalsHandler_GetAllWebContentsInfo_Params, params_);
      var message = builder.finish();
      this.receiver_.acceptAndExpectResponse(message).then(function(message) {
        var reader = new codec.MessageReader(message);
        var responseParams =
            reader.decodeStruct(ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams);
        resolve(responseParams);
      }).catch(function(result) {
        reject(Error("Connection error: " + result));
      });
    }.bind(this));
  };

  function ProcessInternalsHandlerStub(delegate) {
    this.delegate_ = delegate;
  }
  ProcessInternalsHandlerStub.prototype.getIsolationMode = function() {
    return this.delegate_ && this.delegate_.getIsolationMode && this.delegate_.getIsolationMode();
  }
  ProcessInternalsHandlerStub.prototype.getUserTriggeredIsolatedOrigins = function() {
    return this.delegate_ && this.delegate_.getUserTriggeredIsolatedOrigins && this.delegate_.getUserTriggeredIsolatedOrigins();
  }
  ProcessInternalsHandlerStub.prototype.getGloballyIsolatedOrigins = function() {
    return this.delegate_ && this.delegate_.getGloballyIsolatedOrigins && this.delegate_.getGloballyIsolatedOrigins();
  }
  ProcessInternalsHandlerStub.prototype.getAllWebContentsInfo = function() {
    return this.delegate_ && this.delegate_.getAllWebContentsInfo && this.delegate_.getAllWebContentsInfo();
  }

  ProcessInternalsHandlerStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    default:
      return false;
    }
  };

  ProcessInternalsHandlerStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kProcessInternalsHandler_GetIsolationMode_Name:
      var params = reader.decodeStruct(ProcessInternalsHandler_GetIsolationMode_Params);
      this.getIsolationMode().then(function(response) {
        var responseParams =
            new ProcessInternalsHandler_GetIsolationMode_ResponseParams();
        responseParams.mode = response.mode;
        var builder = new codec.MessageV1Builder(
            kProcessInternalsHandler_GetIsolationMode_Name,
            codec.align(ProcessInternalsHandler_GetIsolationMode_ResponseParams.encodedSize),
            codec.kMessageIsResponse, reader.requestID);
        builder.encodeStruct(ProcessInternalsHandler_GetIsolationMode_ResponseParams,
                             responseParams);
        var message = builder.finish();
        responder.accept(message);
      });
      return true;
    case kProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Name:
      var params = reader.decodeStruct(ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params);
      this.getUserTriggeredIsolatedOrigins().then(function(response) {
        var responseParams =
            new ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams();
        responseParams.isolatedOrigins = response.isolatedOrigins;
        var builder = new codec.MessageV1Builder(
            kProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Name,
            codec.align(ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams.encodedSize),
            codec.kMessageIsResponse, reader.requestID);
        builder.encodeStruct(ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams,
                             responseParams);
        var message = builder.finish();
        responder.accept(message);
      });
      return true;
    case kProcessInternalsHandler_GetGloballyIsolatedOrigins_Name:
      var params = reader.decodeStruct(ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params);
      this.getGloballyIsolatedOrigins().then(function(response) {
        var responseParams =
            new ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams();
        responseParams.isolatedOrigins = response.isolatedOrigins;
        var builder = new codec.MessageV1Builder(
            kProcessInternalsHandler_GetGloballyIsolatedOrigins_Name,
            codec.align(ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams.encodedSize),
            codec.kMessageIsResponse, reader.requestID);
        builder.encodeStruct(ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams,
                             responseParams);
        var message = builder.finish();
        responder.accept(message);
      });
      return true;
    case kProcessInternalsHandler_GetAllWebContentsInfo_Name:
      var params = reader.decodeStruct(ProcessInternalsHandler_GetAllWebContentsInfo_Params);
      this.getAllWebContentsInfo().then(function(response) {
        var responseParams =
            new ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams();
        responseParams.infos = response.infos;
        var builder = new codec.MessageV1Builder(
            kProcessInternalsHandler_GetAllWebContentsInfo_Name,
            codec.align(ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams.encodedSize),
            codec.kMessageIsResponse, reader.requestID);
        builder.encodeStruct(ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams,
                             responseParams);
        var message = builder.finish();
        responder.accept(message);
      });
      return true;
    default:
      return false;
    }
  };

  function validateProcessInternalsHandlerRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kProcessInternalsHandler_GetIsolationMode_Name:
        if (message.expectsResponse())
          paramsClass = ProcessInternalsHandler_GetIsolationMode_Params;
      break;
      case kProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Name:
        if (message.expectsResponse())
          paramsClass = ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params;
      break;
      case kProcessInternalsHandler_GetGloballyIsolatedOrigins_Name:
        if (message.expectsResponse())
          paramsClass = ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params;
      break;
      case kProcessInternalsHandler_GetAllWebContentsInfo_Name:
        if (message.expectsResponse())
          paramsClass = ProcessInternalsHandler_GetAllWebContentsInfo_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validateProcessInternalsHandlerResponse(messageValidator) {
   var message = messageValidator.message;
   var paramsClass = null;
   switch (message.getName()) {
      case kProcessInternalsHandler_GetIsolationMode_Name:
        if (message.isResponse())
          paramsClass = ProcessInternalsHandler_GetIsolationMode_ResponseParams;
        break;
      case kProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Name:
        if (message.isResponse())
          paramsClass = ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_ResponseParams;
        break;
      case kProcessInternalsHandler_GetGloballyIsolatedOrigins_Name:
        if (message.isResponse())
          paramsClass = ProcessInternalsHandler_GetGloballyIsolatedOrigins_ResponseParams;
        break;
      case kProcessInternalsHandler_GetAllWebContentsInfo_Name:
        if (message.isResponse())
          paramsClass = ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams;
        break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  var ProcessInternalsHandler = {
    name: 'mojom.ProcessInternalsHandler',
    kVersion: 0,
    ptrClass: ProcessInternalsHandlerPtr,
    proxyClass: ProcessInternalsHandlerProxy,
    stubClass: ProcessInternalsHandlerStub,
    validateRequest: validateProcessInternalsHandlerRequest,
    validateResponse: validateProcessInternalsHandlerResponse,
    mojomId: 'content/browser/process_internals/process_internals.mojom',
    fuzzMethods: {
      getIsolationMode: {
        params: ProcessInternalsHandler_GetIsolationMode_Params,
      },
      getUserTriggeredIsolatedOrigins: {
        params: ProcessInternalsHandler_GetUserTriggeredIsolatedOrigins_Params,
      },
      getGloballyIsolatedOrigins: {
        params: ProcessInternalsHandler_GetGloballyIsolatedOrigins_Params,
      },
      getAllWebContentsInfo: {
        params: ProcessInternalsHandler_GetAllWebContentsInfo_Params,
      },
    },
  };
  ProcessInternalsHandlerStub.prototype.validator = validateProcessInternalsHandlerRequest;
  ProcessInternalsHandlerProxy.prototype.validator = validateProcessInternalsHandlerResponse;
  exports.SiteInstanceInfo = SiteInstanceInfo;
  exports.FrameInfo = FrameInfo;
  exports.WebContentsInfo = WebContentsInfo;
  exports.IsolatedOriginInfo = IsolatedOriginInfo;
  exports.ProcessInternalsHandler = ProcessInternalsHandler;
  exports.ProcessInternalsHandlerPtr = ProcessInternalsHandlerPtr;
  exports.ProcessInternalsHandlerAssociatedPtr = ProcessInternalsHandlerAssociatedPtr;
})();