// content/common/download/mhtml_file_writer.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'content/common/download/mhtml_file_writer.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('content.mojom');
  var file$ =
      mojo.internal.exposeNamespace('mojoBase.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'mojo/public/mojom/base/file.mojom', '../../../mojo/public/mojom/base/file.mojom.js');
  }
  var time$ =
      mojo.internal.exposeNamespace('mojoBase.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'mojo/public/mojom/base/time.mojom', '../../../mojo/public/mojom/base/time.mojom.js');
  }


  var MhtmlSaveStatus = {};
  MhtmlSaveStatus.kSuccess = 0;
  MhtmlSaveStatus.kFileClosingError = MhtmlSaveStatus.kSuccess + 1;
  MhtmlSaveStatus.kFileCreationError = MhtmlSaveStatus.kFileClosingError + 1;
  MhtmlSaveStatus.kFileWritingError = MhtmlSaveStatus.kFileCreationError + 1;
  MhtmlSaveStatus.kFrameNoLongerExists = MhtmlSaveStatus.kFileWritingError + 1;
  MhtmlSaveStatus.kDeprecatedFrameSerializationForbidden = MhtmlSaveStatus.kFrameNoLongerExists + 1;
  MhtmlSaveStatus.kRenderProcessExited = MhtmlSaveStatus.kDeprecatedFrameSerializationForbidden + 1;
  MhtmlSaveStatus.kStreamingError = MhtmlSaveStatus.kRenderProcessExited + 1;
  MhtmlSaveStatus.MIN_VALUE = 0,
  MhtmlSaveStatus.MAX_VALUE = 7,

  MhtmlSaveStatus.isKnownEnumValue = function(value) {
    switch (value) {
    case 0:
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
      return true;
    }
    return false;
  };

  MhtmlSaveStatus.validate = function(enumValue) {
    var isExtensible = false;
    if (isExtensible || this.isKnownEnumValue(enumValue))
      return validator.validationError.NONE;

    return validator.validationError.UNKNOWN_ENUM_VALUE;
  };

  function SerializeAsMHTMLParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  SerializeAsMHTMLParams.prototype.initDefaults_ = function() {
    this.mhtmlBoundaryMarker = null;
    this.mhtmlBinaryEncoding = false;
    this.mhtmlPopupOverlayRemoval = false;
    this.mhtmlProblemDetection = false;
    this.digestsOfUrisToSkip = null;
    this.salt = null;
    this.outputHandle = null;
  };
  SerializeAsMHTMLParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  SerializeAsMHTMLParams.generate = function(generator_) {
    var generated = new SerializeAsMHTMLParams;
    generated.mhtmlBoundaryMarker = generator_.generateString(false);
    generated.mhtmlBinaryEncoding = generator_.generateBool();
    generated.mhtmlPopupOverlayRemoval = generator_.generateBool();
    generated.mhtmlProblemDetection = generator_.generateBool();
    generated.digestsOfUrisToSkip = generator_.generateArray(function() {
      return generator_.generateString(false);
    });
    generated.salt = generator_.generateString(false);
    generated.outputHandle = generator_.generateUnion(content.mojom.MhtmlOutputHandle, false);
    return generated;
  };

  SerializeAsMHTMLParams.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.mhtmlBoundaryMarker = mutator_.mutateString(this.mhtmlBoundaryMarker, false);
    }
    if (mutator_.chooseMutateField()) {
      this.mhtmlBinaryEncoding = mutator_.mutateBool(this.mhtmlBinaryEncoding);
    }
    if (mutator_.chooseMutateField()) {
      this.mhtmlPopupOverlayRemoval = mutator_.mutateBool(this.mhtmlPopupOverlayRemoval);
    }
    if (mutator_.chooseMutateField()) {
      this.mhtmlProblemDetection = mutator_.mutateBool(this.mhtmlProblemDetection);
    }
    if (mutator_.chooseMutateField()) {
      this.digestsOfUrisToSkip = mutator_.mutateArray(this.digestsOfUrisToSkip, function(val) {
        return mutator_.mutateString(val, false);
      });
    }
    if (mutator_.chooseMutateField()) {
      this.salt = mutator_.mutateString(this.salt, false);
    }
    if (mutator_.chooseMutateField()) {
      this.outputHandle = mutator_.mutateUnion(this.outputHandle, content.mojom.MhtmlOutputHandle, false);
    }
    return this;
  };
  SerializeAsMHTMLParams.prototype.getHandleDeps = function() {
    var handles = [];
    if (this.outputHandle !== null) {
      Array.prototype.push.apply(handles, this.outputHandle.getHandleDeps());
    }
    return handles;
  };

  SerializeAsMHTMLParams.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  SerializeAsMHTMLParams.prototype.setHandlesInternal_ = function(handles, idx) {
    idx = this.outputHandle.setHandlesInternal_(handles, idx);
    return idx;
  };

  SerializeAsMHTMLParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 56}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate SerializeAsMHTMLParams.mhtmlBoundaryMarker
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;





    // validate SerializeAsMHTMLParams.digestsOfUrisToSkip
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 16, 8, codec.String, false, [0, 0], 0);
    if (err !== validator.validationError.NONE)
        return err;


    // validate SerializeAsMHTMLParams.salt
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 24, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate SerializeAsMHTMLParams.outputHandle
    err = messageValidator.validateUnion(offset + codec.kStructHeaderSize + 32, MhtmlOutputHandle, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  SerializeAsMHTMLParams.encodedSize = codec.kStructHeaderSize + 48;

  SerializeAsMHTMLParams.decode = function(decoder) {
    var packed;
    var val = new SerializeAsMHTMLParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.mhtmlBoundaryMarker =
        decoder.decodeStruct(codec.String);
    packed = decoder.readUint8();
    val.mhtmlBinaryEncoding = (packed >> 0) & 1 ? true : false;
    val.mhtmlPopupOverlayRemoval = (packed >> 1) & 1 ? true : false;
    val.mhtmlProblemDetection = (packed >> 2) & 1 ? true : false;
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    val.digestsOfUrisToSkip =
        decoder.decodeArrayPointer(codec.String);
    val.salt =
        decoder.decodeStruct(codec.String);
    val.outputHandle =
        decoder.decodeStruct(MhtmlOutputHandle);
    return val;
  };

  SerializeAsMHTMLParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(SerializeAsMHTMLParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.mhtmlBoundaryMarker);
    packed = 0;
    packed |= (val.mhtmlBinaryEncoding & 1) << 0
    packed |= (val.mhtmlPopupOverlayRemoval & 1) << 1
    packed |= (val.mhtmlProblemDetection & 1) << 2
    encoder.writeUint8(packed);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.encodeArrayPointer(codec.String, val.digestsOfUrisToSkip);
    encoder.encodeStruct(codec.String, val.salt);
    encoder.encodeStruct(MhtmlOutputHandle, val.outputHandle);
  };
  function MhtmlFileWriter_SerializeAsMHTML_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  MhtmlFileWriter_SerializeAsMHTML_Params.prototype.initDefaults_ = function() {
    this.params = null;
  };
  MhtmlFileWriter_SerializeAsMHTML_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  MhtmlFileWriter_SerializeAsMHTML_Params.generate = function(generator_) {
    var generated = new MhtmlFileWriter_SerializeAsMHTML_Params;
    generated.params = generator_.generateStruct(content.mojom.SerializeAsMHTMLParams, false);
    return generated;
  };

  MhtmlFileWriter_SerializeAsMHTML_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.params = mutator_.mutateStruct(this.params, content.mojom.SerializeAsMHTMLParams, false);
    }
    return this;
  };
  MhtmlFileWriter_SerializeAsMHTML_Params.prototype.getHandleDeps = function() {
    var handles = [];
    if (this.params !== null) {
      Array.prototype.push.apply(handles, this.params.getHandleDeps());
    }
    return handles;
  };

  MhtmlFileWriter_SerializeAsMHTML_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  MhtmlFileWriter_SerializeAsMHTML_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    idx = this.params.setHandlesInternal_(handles, idx);
    return idx;
  };

  MhtmlFileWriter_SerializeAsMHTML_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate MhtmlFileWriter_SerializeAsMHTML_Params.params
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 0, SerializeAsMHTMLParams, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  MhtmlFileWriter_SerializeAsMHTML_Params.encodedSize = codec.kStructHeaderSize + 8;

  MhtmlFileWriter_SerializeAsMHTML_Params.decode = function(decoder) {
    var packed;
    var val = new MhtmlFileWriter_SerializeAsMHTML_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.params =
        decoder.decodeStructPointer(SerializeAsMHTMLParams);
    return val;
  };

  MhtmlFileWriter_SerializeAsMHTML_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(MhtmlFileWriter_SerializeAsMHTML_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStructPointer(SerializeAsMHTMLParams, val.params);
  };
  function MhtmlFileWriter_SerializeAsMHTML_ResponseParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  MhtmlFileWriter_SerializeAsMHTML_ResponseParams.prototype.initDefaults_ = function() {
    this.status = 0;
    this.digestsOfUrisToSkip = null;
    this.rendererMainThreadTime = null;
  };
  MhtmlFileWriter_SerializeAsMHTML_ResponseParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  MhtmlFileWriter_SerializeAsMHTML_ResponseParams.generate = function(generator_) {
    var generated = new MhtmlFileWriter_SerializeAsMHTML_ResponseParams;
    generated.status = generator_.generateEnum(0, 7);
    generated.digestsOfUrisToSkip = generator_.generateArray(function() {
      return generator_.generateString(false);
    });
    generated.rendererMainThreadTime = generator_.generateStruct(mojoBase.mojom.TimeDelta, false);
    return generated;
  };

  MhtmlFileWriter_SerializeAsMHTML_ResponseParams.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.status = mutator_.mutateEnum(this.status, 0, 7);
    }
    if (mutator_.chooseMutateField()) {
      this.digestsOfUrisToSkip = mutator_.mutateArray(this.digestsOfUrisToSkip, function(val) {
        return mutator_.mutateString(val, false);
      });
    }
    if (mutator_.chooseMutateField()) {
      this.rendererMainThreadTime = mutator_.mutateStruct(this.rendererMainThreadTime, mojoBase.mojom.TimeDelta, false);
    }
    return this;
  };
  MhtmlFileWriter_SerializeAsMHTML_ResponseParams.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  MhtmlFileWriter_SerializeAsMHTML_ResponseParams.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  MhtmlFileWriter_SerializeAsMHTML_ResponseParams.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  MhtmlFileWriter_SerializeAsMHTML_ResponseParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 32}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate MhtmlFileWriter_SerializeAsMHTML_ResponseParams.status
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 0, MhtmlSaveStatus);
    if (err !== validator.validationError.NONE)
        return err;


    // validate MhtmlFileWriter_SerializeAsMHTML_ResponseParams.digestsOfUrisToSkip
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 8, 8, codec.String, false, [0, 0], 0);
    if (err !== validator.validationError.NONE)
        return err;


    // validate MhtmlFileWriter_SerializeAsMHTML_ResponseParams.rendererMainThreadTime
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 16, time$.TimeDelta, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  MhtmlFileWriter_SerializeAsMHTML_ResponseParams.encodedSize = codec.kStructHeaderSize + 24;

  MhtmlFileWriter_SerializeAsMHTML_ResponseParams.decode = function(decoder) {
    var packed;
    var val = new MhtmlFileWriter_SerializeAsMHTML_ResponseParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.status =
        decoder.decodeStruct(codec.Int32);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    val.digestsOfUrisToSkip =
        decoder.decodeArrayPointer(codec.String);
    val.rendererMainThreadTime =
        decoder.decodeStructPointer(time$.TimeDelta);
    return val;
  };

  MhtmlFileWriter_SerializeAsMHTML_ResponseParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(MhtmlFileWriter_SerializeAsMHTML_ResponseParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.status);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.encodeArrayPointer(codec.String, val.digestsOfUrisToSkip);
    encoder.encodeStructPointer(time$.TimeDelta, val.rendererMainThreadTime);
  };

  function MhtmlOutputHandle(value) {
    this.initDefault_();
    this.initValue_(value);
  }


  MhtmlOutputHandle.Tags = {
    fileHandle: 0,
    producerHandle: 1,
  };

  MhtmlOutputHandle.prototype.initDefault_ = function() {
    this.$data = null;
    this.$tag = undefined;
  }

  MhtmlOutputHandle.prototype.initValue_ = function(value) {
    if (value == undefined) {
      return;
    }

    var keys = Object.keys(value);
    if (keys.length == 0) {
      return;
    }

    if (keys.length > 1) {
      throw new TypeError("You may set only one member on a union.");
    }

    var fields = [
        "fileHandle",
        "producerHandle",
    ];

    if (fields.indexOf(keys[0]) < 0) {
      throw new ReferenceError(keys[0] + " is not a MhtmlOutputHandle member.");

    }

    this[keys[0]] = value[keys[0]];
  }
  MhtmlOutputHandle.generate = function(generator_) {
    var generated = new MhtmlOutputHandle;
    var generators = [
      {
        field: "fileHandle",

        generator: function() { return generator_.generateStruct(mojoBase.mojom.File, false); },
      },
      {
        field: "producerHandle",

        generator: function() { return generator_.generateDataPipeProducer(false); },
      },
    ];

    var result = generator_.generateUnionField(generators);
    generated[result.field] = result.value;
    return generated;
  }

  MhtmlOutputHandle.prototype.mutate = function(mutator_) {
    var mutators = [
      {
        field: "fileHandle",

        mutator: function(val) { return mutator_.mutateStruct(val.fileHandle, mojoBase.mojom.File, false); },
      },
      {
        field: "producerHandle",

        mutator: function(val) { return mutator_.mutateDataPipeProducer(val.producerHandle, false); },
      },
    ];

    var result = mutator_.mutateUnionField(this, mutators);
    this[result.field] = result.value;
    return this;
  }
  MhtmlOutputHandle.prototype.getHandleDeps = function() {
    if (this.$tag == MhtmlOutputHandle.Tags.fileHandle) {
      return this.fileHandle.getHandleDeps();
    }
    if (this.$tag == MhtmlOutputHandle.Tags.producerHandle) {
      return ["handle<data_pipe_producer>"];
    }
    return [];
  }
  MhtmlOutputHandle.prototype.setHandles = function() {
    if (this.$tag == MhtmlOutputHandle.Tags.fileHandle) {
      return idx = this.fileHandle.setHandlesInternal_(handles, idx);
    }
    if (this.$tag == MhtmlOutputHandle.Tags.producerHandle) {
      return this.producerHandle = handles[idx++];;
    }
    return [];
  }
  Object.defineProperty(MhtmlOutputHandle.prototype, "fileHandle", {
    get: function() {
      if (this.$tag != MhtmlOutputHandle.Tags.fileHandle) {
        throw new ReferenceError(
            "MhtmlOutputHandle.fileHandle is not currently set.");
      }
      return this.$data;
    },

    set: function(value) {
      this.$tag = MhtmlOutputHandle.Tags.fileHandle;
      this.$data = value;
    }
  });
  Object.defineProperty(MhtmlOutputHandle.prototype, "producerHandle", {
    get: function() {
      if (this.$tag != MhtmlOutputHandle.Tags.producerHandle) {
        throw new ReferenceError(
            "MhtmlOutputHandle.producerHandle is not currently set.");
      }
      return this.$data;
    },

    set: function(value) {
      this.$tag = MhtmlOutputHandle.Tags.producerHandle;
      this.$data = value;
    }
  });


    MhtmlOutputHandle.encode = function(encoder, val) {
      if (val == null) {
        encoder.writeUint64(0);
        encoder.writeUint64(0);
        return;
      }
      if (val.$tag == undefined) {
        throw new TypeError("Cannot encode unions with an unknown member set.");
      }

      encoder.writeUint32(16);
      encoder.writeUint32(val.$tag);
      switch (val.$tag) {
        case MhtmlOutputHandle.Tags.fileHandle:
          encoder.encodeStructPointer(file$.File, val.fileHandle);
          break;
        case MhtmlOutputHandle.Tags.producerHandle:
          encoder.encodeStruct(codec.Handle, val.producerHandle);
          break;
      }
      encoder.align();
    };


    MhtmlOutputHandle.decode = function(decoder) {
      var size = decoder.readUint32();
      if (size == 0) {
        decoder.readUint32();
        decoder.readUint64();
        return null;
      }

      var result = new MhtmlOutputHandle();
      var tag = decoder.readUint32();
      switch (tag) {
        case MhtmlOutputHandle.Tags.fileHandle:
          result.fileHandle = decoder.decodeStructPointer(file$.File);
          break;
        case MhtmlOutputHandle.Tags.producerHandle:
          result.producerHandle = decoder.decodeStruct(codec.Handle);
          break;
      }
      decoder.align();

      return result;
    };


    MhtmlOutputHandle.validate = function(messageValidator, offset) {
      var size = messageValidator.decodeUnionSize(offset);
      if (size != 16) {
        return validator.validationError.INVALID_UNION_SIZE;
      }

      var tag = messageValidator.decodeUnionTag(offset);
      var data_offset = offset + 8;
      var err;
      switch (tag) {
        case MhtmlOutputHandle.Tags.fileHandle:
          

    // validate MhtmlOutputHandle.fileHandle
    err = messageValidator.validateStructPointer(data_offset, file$.File, false);
    if (err !== validator.validationError.NONE)
        return err;
          break;
        case MhtmlOutputHandle.Tags.producerHandle:
          

    // validate MhtmlOutputHandle.producerHandle
    err = messageValidator.validateHandle(data_offset, false)
    if (err !== validator.validationError.NONE)
        return err;
          break;
      }

      return validator.validationError.NONE;
    };

  MhtmlOutputHandle.encodedSize = 16;
  var kMhtmlFileWriter_SerializeAsMHTML_Name = 1423027241;

  function MhtmlFileWriterPtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(MhtmlFileWriter,
                                                   handleOrPtrInfo);
  }

  function MhtmlFileWriterAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        MhtmlFileWriter, associatedInterfacePtrInfo);
  }

  MhtmlFileWriterAssociatedPtr.prototype =
      Object.create(MhtmlFileWriterPtr.prototype);
  MhtmlFileWriterAssociatedPtr.prototype.constructor =
      MhtmlFileWriterAssociatedPtr;

  function MhtmlFileWriterProxy(receiver) {
    this.receiver_ = receiver;
  }
  MhtmlFileWriterPtr.prototype.serializeAsMHTML = function() {
    return MhtmlFileWriterProxy.prototype.serializeAsMHTML
        .apply(this.ptr.getProxy(), arguments);
  };

  MhtmlFileWriterProxy.prototype.serializeAsMHTML = function(params) {
    var params_ = new MhtmlFileWriter_SerializeAsMHTML_Params();
    params_.params = params;
    return new Promise(function(resolve, reject) {
      var builder = new codec.MessageV1Builder(
          kMhtmlFileWriter_SerializeAsMHTML_Name,
          codec.align(MhtmlFileWriter_SerializeAsMHTML_Params.encodedSize),
          codec.kMessageExpectsResponse, 0);
      builder.encodeStruct(MhtmlFileWriter_SerializeAsMHTML_Params, params_);
      var message = builder.finish();
      this.receiver_.acceptAndExpectResponse(message).then(function(message) {
        var reader = new codec.MessageReader(message);
        var responseParams =
            reader.decodeStruct(MhtmlFileWriter_SerializeAsMHTML_ResponseParams);
        resolve(responseParams);
      }).catch(function(result) {
        reject(Error("Connection error: " + result));
      });
    }.bind(this));
  };

  function MhtmlFileWriterStub(delegate) {
    this.delegate_ = delegate;
  }
  MhtmlFileWriterStub.prototype.serializeAsMHTML = function(params) {
    return this.delegate_ && this.delegate_.serializeAsMHTML && this.delegate_.serializeAsMHTML(params);
  }

  MhtmlFileWriterStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    default:
      return false;
    }
  };

  MhtmlFileWriterStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kMhtmlFileWriter_SerializeAsMHTML_Name:
      var params = reader.decodeStruct(MhtmlFileWriter_SerializeAsMHTML_Params);
      this.serializeAsMHTML(params.params).then(function(response) {
        var responseParams =
            new MhtmlFileWriter_SerializeAsMHTML_ResponseParams();
        responseParams.status = response.status;
        responseParams.digestsOfUrisToSkip = response.digestsOfUrisToSkip;
        responseParams.rendererMainThreadTime = response.rendererMainThreadTime;
        var builder = new codec.MessageV1Builder(
            kMhtmlFileWriter_SerializeAsMHTML_Name,
            codec.align(MhtmlFileWriter_SerializeAsMHTML_ResponseParams.encodedSize),
            codec.kMessageIsResponse, reader.requestID);
        builder.encodeStruct(MhtmlFileWriter_SerializeAsMHTML_ResponseParams,
                             responseParams);
        var message = builder.finish();
        responder.accept(message);
      });
      return true;
    default:
      return false;
    }
  };

  function validateMhtmlFileWriterRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kMhtmlFileWriter_SerializeAsMHTML_Name:
        if (message.expectsResponse())
          paramsClass = MhtmlFileWriter_SerializeAsMHTML_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validateMhtmlFileWriterResponse(messageValidator) {
   var message = messageValidator.message;
   var paramsClass = null;
   switch (message.getName()) {
      case kMhtmlFileWriter_SerializeAsMHTML_Name:
        if (message.isResponse())
          paramsClass = MhtmlFileWriter_SerializeAsMHTML_ResponseParams;
        break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  var MhtmlFileWriter = {
    name: 'content.mojom.MhtmlFileWriter',
    kVersion: 0,
    ptrClass: MhtmlFileWriterPtr,
    proxyClass: MhtmlFileWriterProxy,
    stubClass: MhtmlFileWriterStub,
    validateRequest: validateMhtmlFileWriterRequest,
    validateResponse: validateMhtmlFileWriterResponse,
    mojomId: 'content/common/download/mhtml_file_writer.mojom',
    fuzzMethods: {
      serializeAsMHTML: {
        params: MhtmlFileWriter_SerializeAsMHTML_Params,
      },
    },
  };
  MhtmlFileWriterStub.prototype.validator = validateMhtmlFileWriterRequest;
  MhtmlFileWriterProxy.prototype.validator = validateMhtmlFileWriterResponse;
  exports.MhtmlSaveStatus = MhtmlSaveStatus;
  exports.SerializeAsMHTMLParams = SerializeAsMHTMLParams;
  exports.MhtmlOutputHandle = MhtmlOutputHandle;
  exports.MhtmlFileWriter = MhtmlFileWriter;
  exports.MhtmlFileWriterPtr = MhtmlFileWriterPtr;
  exports.MhtmlFileWriterAssociatedPtr = MhtmlFileWriterAssociatedPtr;
})();