// services/network/public/mojom/isolation_info.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'services/network/public/mojom/isolation_info.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('network.mojom');
  var site_for_cookies$ =
      mojo.internal.exposeNamespace('network.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'services/network/public/mojom/site_for_cookies.mojom', 'site_for_cookies.mojom.js');
  }
  var origin$ =
      mojo.internal.exposeNamespace('url.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'url/mojom/origin.mojom', '../../../../url/mojom/origin.mojom.js');
  }


  var IsolationInfoRedirectMode = {};
  IsolationInfoRedirectMode.kUpdateTopFrame = 0;
  IsolationInfoRedirectMode.kUpdateFrameOnly = IsolationInfoRedirectMode.kUpdateTopFrame + 1;
  IsolationInfoRedirectMode.kUpdateNothing = IsolationInfoRedirectMode.kUpdateFrameOnly + 1;
  IsolationInfoRedirectMode.MIN_VALUE = 0,
  IsolationInfoRedirectMode.MAX_VALUE = 2,

  IsolationInfoRedirectMode.isKnownEnumValue = function(value) {
    switch (value) {
    case 0:
    case 1:
    case 2:
      return true;
    }
    return false;
  };

  IsolationInfoRedirectMode.validate = function(enumValue) {
    var isExtensible = false;
    if (isExtensible || this.isKnownEnumValue(enumValue))
      return validator.validationError.NONE;

    return validator.validationError.UNKNOWN_ENUM_VALUE;
  };

  function IsolationInfo(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  IsolationInfo.prototype.initDefaults_ = function() {
    this.redirectMode = 0;
    this.opaqueAndNonTransient = false;
    this.topFrameOrigin = null;
    this.frameOrigin = null;
    this.siteForCookies = null;
  };
  IsolationInfo.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  IsolationInfo.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 40}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate IsolationInfo.redirectMode
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 0, IsolationInfoRedirectMode);
    if (err !== validator.validationError.NONE)
        return err;


    // validate IsolationInfo.topFrameOrigin
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 8, origin$.Origin, true);
    if (err !== validator.validationError.NONE)
        return err;


    // validate IsolationInfo.frameOrigin
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 16, origin$.Origin, true);
    if (err !== validator.validationError.NONE)
        return err;



    // validate IsolationInfo.siteForCookies
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 24, site_for_cookies$.SiteForCookies, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  IsolationInfo.encodedSize = codec.kStructHeaderSize + 32;

  IsolationInfo.decode = function(decoder) {
    var packed;
    var val = new IsolationInfo();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.redirectMode =
        decoder.decodeStruct(codec.Int32);
    packed = decoder.readUint8();
    val.opaqueAndNonTransient = (packed >> 0) & 1 ? true : false;
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    val.topFrameOrigin =
        decoder.decodeStructPointer(origin$.Origin);
    val.frameOrigin =
        decoder.decodeStructPointer(origin$.Origin);
    val.siteForCookies =
        decoder.decodeStructPointer(site_for_cookies$.SiteForCookies);
    return val;
  };

  IsolationInfo.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(IsolationInfo.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.redirectMode);
    packed = 0;
    packed |= (val.opaqueAndNonTransient & 1) << 0
    encoder.writeUint8(packed);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.encodeStructPointer(origin$.Origin, val.topFrameOrigin);
    encoder.encodeStructPointer(origin$.Origin, val.frameOrigin);
    encoder.encodeStructPointer(site_for_cookies$.SiteForCookies, val.siteForCookies);
  };
  exports.IsolationInfoRedirectMode = IsolationInfoRedirectMode;
  exports.IsolationInfo = IsolationInfo;
})();