// services/network/public/mojom/trust_tokens.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'services/network/public/mojom/trust_tokens.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('network.mojom');
  var origin$ =
      mojo.internal.exposeNamespace('url.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'url/mojom/origin.mojom', '../../../../url/mojom/origin.mojom.js');
  }
  var time$ =
      mojo.internal.exposeNamespace('mojoBase.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'mojo/public/mojom/base/time.mojom', '../../../../mojo/public/mojom/base/time.mojom.js');
  }


  var TrustTokenOperationStatus = {};
  TrustTokenOperationStatus.kOk = 0;
  TrustTokenOperationStatus.kInvalidArgument = TrustTokenOperationStatus.kOk + 1;
  TrustTokenOperationStatus.kFailedPrecondition = TrustTokenOperationStatus.kInvalidArgument + 1;
  TrustTokenOperationStatus.kResourceExhausted = TrustTokenOperationStatus.kFailedPrecondition + 1;
  TrustTokenOperationStatus.kAlreadyExists = TrustTokenOperationStatus.kResourceExhausted + 1;
  TrustTokenOperationStatus.kUnavailable = TrustTokenOperationStatus.kAlreadyExists + 1;
  TrustTokenOperationStatus.kBadResponse = TrustTokenOperationStatus.kUnavailable + 1;
  TrustTokenOperationStatus.kInternalError = TrustTokenOperationStatus.kBadResponse + 1;
  TrustTokenOperationStatus.kUnknownError = TrustTokenOperationStatus.kInternalError + 1;
  TrustTokenOperationStatus.MIN_VALUE = 0,
  TrustTokenOperationStatus.MAX_VALUE = 8,

  TrustTokenOperationStatus.isKnownEnumValue = function(value) {
    switch (value) {
    case 0:
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
    case 8:
      return true;
    }
    return false;
  };

  TrustTokenOperationStatus.validate = function(enumValue) {
    var isExtensible = false;
    if (isExtensible || this.isKnownEnumValue(enumValue))
      return validator.validationError.NONE;

    return validator.validationError.UNKNOWN_ENUM_VALUE;
  };
  var TrustTokenOperationType = {};
  TrustTokenOperationType.kIssuance = 0;
  TrustTokenOperationType.kRedemption = TrustTokenOperationType.kIssuance + 1;
  TrustTokenOperationType.kSigning = TrustTokenOperationType.kRedemption + 1;
  TrustTokenOperationType.MIN_VALUE = 0,
  TrustTokenOperationType.MAX_VALUE = 2,

  TrustTokenOperationType.isKnownEnumValue = function(value) {
    switch (value) {
    case 0:
    case 1:
    case 2:
      return true;
    }
    return false;
  };

  TrustTokenOperationType.validate = function(enumValue) {
    var isExtensible = false;
    if (isExtensible || this.isKnownEnumValue(enumValue))
      return validator.validationError.NONE;

    return validator.validationError.UNKNOWN_ENUM_VALUE;
  };
  var TrustTokenRefreshPolicy = {};
  TrustTokenRefreshPolicy.kUseCached = 0;
  TrustTokenRefreshPolicy.kRefresh = TrustTokenRefreshPolicy.kUseCached + 1;
  TrustTokenRefreshPolicy.MIN_VALUE = 0,
  TrustTokenRefreshPolicy.MAX_VALUE = 1,

  TrustTokenRefreshPolicy.isKnownEnumValue = function(value) {
    switch (value) {
    case 0:
    case 1:
      return true;
    }
    return false;
  };

  TrustTokenRefreshPolicy.validate = function(enumValue) {
    var isExtensible = false;
    if (isExtensible || this.isKnownEnumValue(enumValue))
      return validator.validationError.NONE;

    return validator.validationError.UNKNOWN_ENUM_VALUE;
  };
  var TrustTokenSignRequestData = {};
  TrustTokenSignRequestData.kOmit = 0;
  TrustTokenSignRequestData.kHeadersOnly = TrustTokenSignRequestData.kOmit + 1;
  TrustTokenSignRequestData.kInclude = TrustTokenSignRequestData.kHeadersOnly + 1;
  TrustTokenSignRequestData.MIN_VALUE = 0,
  TrustTokenSignRequestData.MAX_VALUE = 2,

  TrustTokenSignRequestData.isKnownEnumValue = function(value) {
    switch (value) {
    case 0:
    case 1:
    case 2:
      return true;
    }
    return false;
  };

  TrustTokenSignRequestData.validate = function(enumValue) {
    var isExtensible = false;
    if (isExtensible || this.isKnownEnumValue(enumValue))
      return validator.validationError.NONE;

    return validator.validationError.UNKNOWN_ENUM_VALUE;
  };

  function TrustTokenParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  TrustTokenParams.prototype.initDefaults_ = function() {
    this.type = 0;
    this.refreshPolicy = TrustTokenRefreshPolicy.kUseCached;
    this.signRequestData = TrustTokenSignRequestData.kOmit;
    this.includeTimestampHeader = false;
    this.issuer = null;
    this.additionalSignedHeaders = null;
  };
  TrustTokenParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  TrustTokenParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 40}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TrustTokenParams.type
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 0, TrustTokenOperationType);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TrustTokenParams.refreshPolicy
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 4, TrustTokenRefreshPolicy);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TrustTokenParams.signRequestData
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 8, TrustTokenSignRequestData);
    if (err !== validator.validationError.NONE)
        return err;



    // validate TrustTokenParams.issuer
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 16, origin$.Origin, true);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TrustTokenParams.additionalSignedHeaders
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 24, 8, codec.String, false, [0, 0], 0);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  TrustTokenParams.encodedSize = codec.kStructHeaderSize + 32;

  TrustTokenParams.decode = function(decoder) {
    var packed;
    var val = new TrustTokenParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.type =
        decoder.decodeStruct(codec.Int32);
    val.refreshPolicy =
        decoder.decodeStruct(codec.Int32);
    val.signRequestData =
        decoder.decodeStruct(codec.Int32);
    packed = decoder.readUint8();
    val.includeTimestampHeader = (packed >> 0) & 1 ? true : false;
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    val.issuer =
        decoder.decodeStructPointer(origin$.Origin);
    val.additionalSignedHeaders =
        decoder.decodeArrayPointer(codec.String);
    return val;
  };

  TrustTokenParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(TrustTokenParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.type);
    encoder.encodeStruct(codec.Int32, val.refreshPolicy);
    encoder.encodeStruct(codec.Int32, val.signRequestData);
    packed = 0;
    packed |= (val.includeTimestampHeader & 1) << 0
    encoder.writeUint8(packed);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.encodeStructPointer(origin$.Origin, val.issuer);
    encoder.encodeArrayPointer(codec.String, val.additionalSignedHeaders);
  };
  function HasTrustTokensResult(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  HasTrustTokensResult.prototype.initDefaults_ = function() {
    this.status = 0;
    this.hasTrustTokens = false;
  };
  HasTrustTokensResult.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  HasTrustTokensResult.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate HasTrustTokensResult.status
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 0, TrustTokenOperationStatus);
    if (err !== validator.validationError.NONE)
        return err;


    return validator.validationError.NONE;
  };

  HasTrustTokensResult.encodedSize = codec.kStructHeaderSize + 8;

  HasTrustTokensResult.decode = function(decoder) {
    var packed;
    var val = new HasTrustTokensResult();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.status =
        decoder.decodeStruct(codec.Int32);
    packed = decoder.readUint8();
    val.hasTrustTokens = (packed >> 0) & 1 ? true : false;
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  HasTrustTokensResult.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(HasTrustTokensResult.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.status);
    packed = 0;
    packed |= (val.hasTrustTokens & 1) << 0
    encoder.writeUint8(packed);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  function TrustTokenVerificationKey(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  TrustTokenVerificationKey.prototype.initDefaults_ = function() {
    this.body = null;
    this.expiry = null;
  };
  TrustTokenVerificationKey.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  TrustTokenVerificationKey.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 24}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TrustTokenVerificationKey.body
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate TrustTokenVerificationKey.expiry
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 8, time$.Time, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  TrustTokenVerificationKey.encodedSize = codec.kStructHeaderSize + 16;

  TrustTokenVerificationKey.decode = function(decoder) {
    var packed;
    var val = new TrustTokenVerificationKey();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.body =
        decoder.decodeStruct(codec.String);
    val.expiry =
        decoder.decodeStructPointer(time$.Time);
    return val;
  };

  TrustTokenVerificationKey.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(TrustTokenVerificationKey.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.body);
    encoder.encodeStructPointer(time$.Time, val.expiry);
  };
  function TrustTokenKeyCommitmentResult(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  TrustTokenKeyCommitmentResult.prototype.initDefaults_ = function() {
    this.batchSize = 0;
    this.keys = null;
    this.signedRedemptionRecordVerificationKey = null;
  };
  TrustTokenKeyCommitmentResult.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  TrustTokenKeyCommitmentResult.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 32}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;



    // validate TrustTokenKeyCommitmentResult.keys
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 8, 8, new codec.PointerTo(TrustTokenVerificationKey), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TrustTokenKeyCommitmentResult.signedRedemptionRecordVerificationKey
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 16, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  TrustTokenKeyCommitmentResult.encodedSize = codec.kStructHeaderSize + 24;

  TrustTokenKeyCommitmentResult.decode = function(decoder) {
    var packed;
    var val = new TrustTokenKeyCommitmentResult();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.batchSize =
        decoder.decodeStruct(codec.Int32);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    val.keys =
        decoder.decodeArrayPointer(new codec.PointerTo(TrustTokenVerificationKey));
    val.signedRedemptionRecordVerificationKey =
        decoder.decodeStruct(codec.String);
    return val;
  };

  TrustTokenKeyCommitmentResult.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(TrustTokenKeyCommitmentResult.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.batchSize);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.encodeArrayPointer(new codec.PointerTo(TrustTokenVerificationKey), val.keys);
    encoder.encodeStruct(codec.String, val.signedRedemptionRecordVerificationKey);
  };
  function HasTrustTokensAnswerer_HasTrustTokens_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  HasTrustTokensAnswerer_HasTrustTokens_Params.prototype.initDefaults_ = function() {
    this.issuer = null;
  };
  HasTrustTokensAnswerer_HasTrustTokens_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  HasTrustTokensAnswerer_HasTrustTokens_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate HasTrustTokensAnswerer_HasTrustTokens_Params.issuer
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 0, origin$.Origin, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  HasTrustTokensAnswerer_HasTrustTokens_Params.encodedSize = codec.kStructHeaderSize + 8;

  HasTrustTokensAnswerer_HasTrustTokens_Params.decode = function(decoder) {
    var packed;
    var val = new HasTrustTokensAnswerer_HasTrustTokens_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.issuer =
        decoder.decodeStructPointer(origin$.Origin);
    return val;
  };

  HasTrustTokensAnswerer_HasTrustTokens_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(HasTrustTokensAnswerer_HasTrustTokens_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStructPointer(origin$.Origin, val.issuer);
  };
  function HasTrustTokensAnswerer_HasTrustTokens_ResponseParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  HasTrustTokensAnswerer_HasTrustTokens_ResponseParams.prototype.initDefaults_ = function() {
    this.result = null;
  };
  HasTrustTokensAnswerer_HasTrustTokens_ResponseParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  HasTrustTokensAnswerer_HasTrustTokens_ResponseParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate HasTrustTokensAnswerer_HasTrustTokens_ResponseParams.result
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 0, HasTrustTokensResult, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  HasTrustTokensAnswerer_HasTrustTokens_ResponseParams.encodedSize = codec.kStructHeaderSize + 8;

  HasTrustTokensAnswerer_HasTrustTokens_ResponseParams.decode = function(decoder) {
    var packed;
    var val = new HasTrustTokensAnswerer_HasTrustTokens_ResponseParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.result =
        decoder.decodeStructPointer(HasTrustTokensResult);
    return val;
  };

  HasTrustTokensAnswerer_HasTrustTokens_ResponseParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(HasTrustTokensAnswerer_HasTrustTokens_ResponseParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStructPointer(HasTrustTokensResult, val.result);
  };
  var kHasTrustTokensAnswerer_HasTrustTokens_Name = 1114787439;

  function HasTrustTokensAnswererPtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(HasTrustTokensAnswerer,
                                                   handleOrPtrInfo);
  }

  function HasTrustTokensAnswererAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        HasTrustTokensAnswerer, associatedInterfacePtrInfo);
  }

  HasTrustTokensAnswererAssociatedPtr.prototype =
      Object.create(HasTrustTokensAnswererPtr.prototype);
  HasTrustTokensAnswererAssociatedPtr.prototype.constructor =
      HasTrustTokensAnswererAssociatedPtr;

  function HasTrustTokensAnswererProxy(receiver) {
    this.receiver_ = receiver;
  }
  HasTrustTokensAnswererPtr.prototype.hasTrustTokens = function() {
    return HasTrustTokensAnswererProxy.prototype.hasTrustTokens
        .apply(this.ptr.getProxy(), arguments);
  };

  HasTrustTokensAnswererProxy.prototype.hasTrustTokens = function(issuer) {
    var params_ = new HasTrustTokensAnswerer_HasTrustTokens_Params();
    params_.issuer = issuer;
    return new Promise(function(resolve, reject) {
      var builder = new codec.MessageV1Builder(
          kHasTrustTokensAnswerer_HasTrustTokens_Name,
          codec.align(HasTrustTokensAnswerer_HasTrustTokens_Params.encodedSize),
          codec.kMessageExpectsResponse, 0);
      builder.encodeStruct(HasTrustTokensAnswerer_HasTrustTokens_Params, params_);
      var message = builder.finish();
      this.receiver_.acceptAndExpectResponse(message).then(function(message) {
        var reader = new codec.MessageReader(message);
        var responseParams =
            reader.decodeStruct(HasTrustTokensAnswerer_HasTrustTokens_ResponseParams);
        resolve(responseParams);
      }).catch(function(result) {
        reject(Error("Connection error: " + result));
      });
    }.bind(this));
  };

  function HasTrustTokensAnswererStub(delegate) {
    this.delegate_ = delegate;
  }
  HasTrustTokensAnswererStub.prototype.hasTrustTokens = function(issuer) {
    return this.delegate_ && this.delegate_.hasTrustTokens && this.delegate_.hasTrustTokens(issuer);
  }

  HasTrustTokensAnswererStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    default:
      return false;
    }
  };

  HasTrustTokensAnswererStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kHasTrustTokensAnswerer_HasTrustTokens_Name:
      var params = reader.decodeStruct(HasTrustTokensAnswerer_HasTrustTokens_Params);
      this.hasTrustTokens(params.issuer).then(function(response) {
        var responseParams =
            new HasTrustTokensAnswerer_HasTrustTokens_ResponseParams();
        responseParams.result = response.result;
        var builder = new codec.MessageV1Builder(
            kHasTrustTokensAnswerer_HasTrustTokens_Name,
            codec.align(HasTrustTokensAnswerer_HasTrustTokens_ResponseParams.encodedSize),
            codec.kMessageIsResponse, reader.requestID);
        builder.encodeStruct(HasTrustTokensAnswerer_HasTrustTokens_ResponseParams,
                             responseParams);
        var message = builder.finish();
        responder.accept(message);
      });
      return true;
    default:
      return false;
    }
  };

  function validateHasTrustTokensAnswererRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kHasTrustTokensAnswerer_HasTrustTokens_Name:
        if (message.expectsResponse())
          paramsClass = HasTrustTokensAnswerer_HasTrustTokens_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validateHasTrustTokensAnswererResponse(messageValidator) {
   var message = messageValidator.message;
   var paramsClass = null;
   switch (message.getName()) {
      case kHasTrustTokensAnswerer_HasTrustTokens_Name:
        if (message.isResponse())
          paramsClass = HasTrustTokensAnswerer_HasTrustTokens_ResponseParams;
        break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  var HasTrustTokensAnswerer = {
    name: 'network.mojom.HasTrustTokensAnswerer',
    kVersion: 0,
    ptrClass: HasTrustTokensAnswererPtr,
    proxyClass: HasTrustTokensAnswererProxy,
    stubClass: HasTrustTokensAnswererStub,
    validateRequest: validateHasTrustTokensAnswererRequest,
    validateResponse: validateHasTrustTokensAnswererResponse,
  };
  HasTrustTokensAnswererStub.prototype.validator = validateHasTrustTokensAnswererRequest;
  HasTrustTokensAnswererProxy.prototype.validator = validateHasTrustTokensAnswererResponse;
  exports.TrustTokenOperationStatus = TrustTokenOperationStatus;
  exports.TrustTokenOperationType = TrustTokenOperationType;
  exports.TrustTokenRefreshPolicy = TrustTokenRefreshPolicy;
  exports.TrustTokenSignRequestData = TrustTokenSignRequestData;
  exports.TrustTokenParams = TrustTokenParams;
  exports.HasTrustTokensResult = HasTrustTokensResult;
  exports.TrustTokenVerificationKey = TrustTokenVerificationKey;
  exports.TrustTokenKeyCommitmentResult = TrustTokenKeyCommitmentResult;
  exports.HasTrustTokensAnswerer = HasTrustTokensAnswerer;
  exports.HasTrustTokensAnswererPtr = HasTrustTokensAnswererPtr;
  exports.HasTrustTokensAnswererAssociatedPtr = HasTrustTokensAnswererAssociatedPtr;
})();