// services/video_capture/public/mojom/video_frame_handler.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'services/video_capture/public/mojom/video_frame_handler.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('videoCapture.mojom');
  var video_capture_types$ =
      mojo.internal.exposeNamespace('media.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'media/capture/mojom/video_capture_types.mojom', '../../../../media/capture/mojom/video_capture_types.mojom.js');
  }
  var scoped_access_permission$ =
      mojo.internal.exposeNamespace('videoCapture.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'services/video_capture/public/mojom/scoped_access_permission.mojom', 'scoped_access_permission.mojom.js');
  }



  function VideoFrameHandler_OnNewBuffer_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  VideoFrameHandler_OnNewBuffer_Params.prototype.initDefaults_ = function() {
    this.bufferId = 0;
    this.bufferHandle = null;
  };
  VideoFrameHandler_OnNewBuffer_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  VideoFrameHandler_OnNewBuffer_Params.generate = function(generator_) {
    var generated = new VideoFrameHandler_OnNewBuffer_Params;
    generated.bufferId = generator_.generateInt32();
    generated.bufferHandle = generator_.generateUnion(media.mojom.VideoBufferHandle, false);
    return generated;
  };

  VideoFrameHandler_OnNewBuffer_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.bufferId = mutator_.mutateInt32(this.bufferId);
    }
    if (mutator_.chooseMutateField()) {
      this.bufferHandle = mutator_.mutateUnion(this.bufferHandle, media.mojom.VideoBufferHandle, false);
    }
    return this;
  };
  VideoFrameHandler_OnNewBuffer_Params.prototype.getHandleDeps = function() {
    var handles = [];
    if (this.bufferHandle !== null) {
      Array.prototype.push.apply(handles, this.bufferHandle.getHandleDeps());
    }
    return handles;
  };

  VideoFrameHandler_OnNewBuffer_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  VideoFrameHandler_OnNewBuffer_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    idx = this.bufferHandle.setHandlesInternal_(handles, idx);
    return idx;
  };

  VideoFrameHandler_OnNewBuffer_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 32}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;



    // validate VideoFrameHandler_OnNewBuffer_Params.bufferHandle
    err = messageValidator.validateUnion(offset + codec.kStructHeaderSize + 8, video_capture_types$.VideoBufferHandle, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  VideoFrameHandler_OnNewBuffer_Params.encodedSize = codec.kStructHeaderSize + 24;

  VideoFrameHandler_OnNewBuffer_Params.decode = function(decoder) {
    var packed;
    var val = new VideoFrameHandler_OnNewBuffer_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.bufferId =
        decoder.decodeStruct(codec.Int32);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    val.bufferHandle =
        decoder.decodeStruct(video_capture_types$.VideoBufferHandle);
    return val;
  };

  VideoFrameHandler_OnNewBuffer_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(VideoFrameHandler_OnNewBuffer_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.bufferId);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.encodeStruct(video_capture_types$.VideoBufferHandle, val.bufferHandle);
  };
  function VideoFrameHandler_OnFrameReadyInBuffer_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  VideoFrameHandler_OnFrameReadyInBuffer_Params.prototype.initDefaults_ = function() {
    this.bufferId = 0;
    this.frameFeedbackId = 0;
    this.accessPermission = new scoped_access_permission$.ScopedAccessPermissionPtr();
    this.frameInfo = null;
  };
  VideoFrameHandler_OnFrameReadyInBuffer_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  VideoFrameHandler_OnFrameReadyInBuffer_Params.generate = function(generator_) {
    var generated = new VideoFrameHandler_OnFrameReadyInBuffer_Params;
    generated.bufferId = generator_.generateInt32();
    generated.frameFeedbackId = generator_.generateInt32();
    generated.accessPermission = generator_.generateInterface("videoCapture.mojom.ScopedAccessPermission", false);
    generated.frameInfo = generator_.generateStruct(media.mojom.VideoFrameInfo, false);
    return generated;
  };

  VideoFrameHandler_OnFrameReadyInBuffer_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.bufferId = mutator_.mutateInt32(this.bufferId);
    }
    if (mutator_.chooseMutateField()) {
      this.frameFeedbackId = mutator_.mutateInt32(this.frameFeedbackId);
    }
    if (mutator_.chooseMutateField()) {
      this.accessPermission = mutator_.mutateInterface(this.accessPermission, "videoCapture.mojom.ScopedAccessPermission", false);
    }
    if (mutator_.chooseMutateField()) {
      this.frameInfo = mutator_.mutateStruct(this.frameInfo, media.mojom.VideoFrameInfo, false);
    }
    return this;
  };
  VideoFrameHandler_OnFrameReadyInBuffer_Params.prototype.getHandleDeps = function() {
    var handles = [];
    if (this.accessPermission !== null) {
      Array.prototype.push.apply(handles, ["videoCapture.mojom.ScopedAccessPermissionPtr"]);
    }
    return handles;
  };

  VideoFrameHandler_OnFrameReadyInBuffer_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  VideoFrameHandler_OnFrameReadyInBuffer_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    this.accessPermission = handles[idx++];;
    return idx;
  };

  VideoFrameHandler_OnFrameReadyInBuffer_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 32}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;




    // validate VideoFrameHandler_OnFrameReadyInBuffer_Params.accessPermission
    err = messageValidator.validateInterface(offset + codec.kStructHeaderSize + 8, false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate VideoFrameHandler_OnFrameReadyInBuffer_Params.frameInfo
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 16, video_capture_types$.VideoFrameInfo, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  VideoFrameHandler_OnFrameReadyInBuffer_Params.encodedSize = codec.kStructHeaderSize + 24;

  VideoFrameHandler_OnFrameReadyInBuffer_Params.decode = function(decoder) {
    var packed;
    var val = new VideoFrameHandler_OnFrameReadyInBuffer_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.bufferId =
        decoder.decodeStruct(codec.Int32);
    val.frameFeedbackId =
        decoder.decodeStruct(codec.Int32);
    val.accessPermission =
        decoder.decodeStruct(new codec.Interface(scoped_access_permission$.ScopedAccessPermissionPtr));
    val.frameInfo =
        decoder.decodeStructPointer(video_capture_types$.VideoFrameInfo);
    return val;
  };

  VideoFrameHandler_OnFrameReadyInBuffer_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(VideoFrameHandler_OnFrameReadyInBuffer_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.bufferId);
    encoder.encodeStruct(codec.Int32, val.frameFeedbackId);
    encoder.encodeStruct(new codec.Interface(scoped_access_permission$.ScopedAccessPermissionPtr), val.accessPermission);
    encoder.encodeStructPointer(video_capture_types$.VideoFrameInfo, val.frameInfo);
  };
  function VideoFrameHandler_OnBufferRetired_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  VideoFrameHandler_OnBufferRetired_Params.prototype.initDefaults_ = function() {
    this.bufferId = 0;
  };
  VideoFrameHandler_OnBufferRetired_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  VideoFrameHandler_OnBufferRetired_Params.generate = function(generator_) {
    var generated = new VideoFrameHandler_OnBufferRetired_Params;
    generated.bufferId = generator_.generateInt32();
    return generated;
  };

  VideoFrameHandler_OnBufferRetired_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.bufferId = mutator_.mutateInt32(this.bufferId);
    }
    return this;
  };
  VideoFrameHandler_OnBufferRetired_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  VideoFrameHandler_OnBufferRetired_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  VideoFrameHandler_OnBufferRetired_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  VideoFrameHandler_OnBufferRetired_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    return validator.validationError.NONE;
  };

  VideoFrameHandler_OnBufferRetired_Params.encodedSize = codec.kStructHeaderSize + 8;

  VideoFrameHandler_OnBufferRetired_Params.decode = function(decoder) {
    var packed;
    var val = new VideoFrameHandler_OnBufferRetired_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.bufferId =
        decoder.decodeStruct(codec.Int32);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  VideoFrameHandler_OnBufferRetired_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(VideoFrameHandler_OnBufferRetired_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.bufferId);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  function VideoFrameHandler_OnError_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  VideoFrameHandler_OnError_Params.prototype.initDefaults_ = function() {
    this.error = 0;
  };
  VideoFrameHandler_OnError_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  VideoFrameHandler_OnError_Params.generate = function(generator_) {
    var generated = new VideoFrameHandler_OnError_Params;
    generated.error = generator_.generateEnum(0, 114);
    return generated;
  };

  VideoFrameHandler_OnError_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.error = mutator_.mutateEnum(this.error, 0, 114);
    }
    return this;
  };
  VideoFrameHandler_OnError_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  VideoFrameHandler_OnError_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  VideoFrameHandler_OnError_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  VideoFrameHandler_OnError_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate VideoFrameHandler_OnError_Params.error
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 0, video_capture_types$.VideoCaptureError);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  VideoFrameHandler_OnError_Params.encodedSize = codec.kStructHeaderSize + 8;

  VideoFrameHandler_OnError_Params.decode = function(decoder) {
    var packed;
    var val = new VideoFrameHandler_OnError_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.error =
        decoder.decodeStruct(codec.Int32);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  VideoFrameHandler_OnError_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(VideoFrameHandler_OnError_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.error);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  function VideoFrameHandler_OnFrameDropped_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  VideoFrameHandler_OnFrameDropped_Params.prototype.initDefaults_ = function() {
    this.reason = 0;
  };
  VideoFrameHandler_OnFrameDropped_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  VideoFrameHandler_OnFrameDropped_Params.generate = function(generator_) {
    var generated = new VideoFrameHandler_OnFrameDropped_Params;
    generated.reason = generator_.generateEnum(0, 25);
    return generated;
  };

  VideoFrameHandler_OnFrameDropped_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.reason = mutator_.mutateEnum(this.reason, 0, 25);
    }
    return this;
  };
  VideoFrameHandler_OnFrameDropped_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  VideoFrameHandler_OnFrameDropped_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  VideoFrameHandler_OnFrameDropped_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  VideoFrameHandler_OnFrameDropped_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate VideoFrameHandler_OnFrameDropped_Params.reason
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 0, video_capture_types$.VideoCaptureFrameDropReason);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  VideoFrameHandler_OnFrameDropped_Params.encodedSize = codec.kStructHeaderSize + 8;

  VideoFrameHandler_OnFrameDropped_Params.decode = function(decoder) {
    var packed;
    var val = new VideoFrameHandler_OnFrameDropped_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.reason =
        decoder.decodeStruct(codec.Int32);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  VideoFrameHandler_OnFrameDropped_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(VideoFrameHandler_OnFrameDropped_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.reason);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  function VideoFrameHandler_OnLog_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  VideoFrameHandler_OnLog_Params.prototype.initDefaults_ = function() {
    this.message = null;
  };
  VideoFrameHandler_OnLog_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  VideoFrameHandler_OnLog_Params.generate = function(generator_) {
    var generated = new VideoFrameHandler_OnLog_Params;
    generated.message = generator_.generateString(false);
    return generated;
  };

  VideoFrameHandler_OnLog_Params.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.message = mutator_.mutateString(this.message, false);
    }
    return this;
  };
  VideoFrameHandler_OnLog_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  VideoFrameHandler_OnLog_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  VideoFrameHandler_OnLog_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  VideoFrameHandler_OnLog_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate VideoFrameHandler_OnLog_Params.message
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  VideoFrameHandler_OnLog_Params.encodedSize = codec.kStructHeaderSize + 8;

  VideoFrameHandler_OnLog_Params.decode = function(decoder) {
    var packed;
    var val = new VideoFrameHandler_OnLog_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.message =
        decoder.decodeStruct(codec.String);
    return val;
  };

  VideoFrameHandler_OnLog_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(VideoFrameHandler_OnLog_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.message);
  };
  function VideoFrameHandler_OnStarted_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  VideoFrameHandler_OnStarted_Params.prototype.initDefaults_ = function() {
  };
  VideoFrameHandler_OnStarted_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  VideoFrameHandler_OnStarted_Params.generate = function(generator_) {
    var generated = new VideoFrameHandler_OnStarted_Params;
    return generated;
  };

  VideoFrameHandler_OnStarted_Params.prototype.mutate = function(mutator_) {
    return this;
  };
  VideoFrameHandler_OnStarted_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  VideoFrameHandler_OnStarted_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  VideoFrameHandler_OnStarted_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  VideoFrameHandler_OnStarted_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 8}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  VideoFrameHandler_OnStarted_Params.encodedSize = codec.kStructHeaderSize + 0;

  VideoFrameHandler_OnStarted_Params.decode = function(decoder) {
    var packed;
    var val = new VideoFrameHandler_OnStarted_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    return val;
  };

  VideoFrameHandler_OnStarted_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(VideoFrameHandler_OnStarted_Params.encodedSize);
    encoder.writeUint32(0);
  };
  function VideoFrameHandler_OnStartedUsingGpuDecode_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  VideoFrameHandler_OnStartedUsingGpuDecode_Params.prototype.initDefaults_ = function() {
  };
  VideoFrameHandler_OnStartedUsingGpuDecode_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  VideoFrameHandler_OnStartedUsingGpuDecode_Params.generate = function(generator_) {
    var generated = new VideoFrameHandler_OnStartedUsingGpuDecode_Params;
    return generated;
  };

  VideoFrameHandler_OnStartedUsingGpuDecode_Params.prototype.mutate = function(mutator_) {
    return this;
  };
  VideoFrameHandler_OnStartedUsingGpuDecode_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  VideoFrameHandler_OnStartedUsingGpuDecode_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  VideoFrameHandler_OnStartedUsingGpuDecode_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  VideoFrameHandler_OnStartedUsingGpuDecode_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 8}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  VideoFrameHandler_OnStartedUsingGpuDecode_Params.encodedSize = codec.kStructHeaderSize + 0;

  VideoFrameHandler_OnStartedUsingGpuDecode_Params.decode = function(decoder) {
    var packed;
    var val = new VideoFrameHandler_OnStartedUsingGpuDecode_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    return val;
  };

  VideoFrameHandler_OnStartedUsingGpuDecode_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(VideoFrameHandler_OnStartedUsingGpuDecode_Params.encodedSize);
    encoder.writeUint32(0);
  };
  function VideoFrameHandler_OnStopped_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  VideoFrameHandler_OnStopped_Params.prototype.initDefaults_ = function() {
  };
  VideoFrameHandler_OnStopped_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  VideoFrameHandler_OnStopped_Params.generate = function(generator_) {
    var generated = new VideoFrameHandler_OnStopped_Params;
    return generated;
  };

  VideoFrameHandler_OnStopped_Params.prototype.mutate = function(mutator_) {
    return this;
  };
  VideoFrameHandler_OnStopped_Params.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  VideoFrameHandler_OnStopped_Params.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  VideoFrameHandler_OnStopped_Params.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  VideoFrameHandler_OnStopped_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 8}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  VideoFrameHandler_OnStopped_Params.encodedSize = codec.kStructHeaderSize + 0;

  VideoFrameHandler_OnStopped_Params.decode = function(decoder) {
    var packed;
    var val = new VideoFrameHandler_OnStopped_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    return val;
  };

  VideoFrameHandler_OnStopped_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(VideoFrameHandler_OnStopped_Params.encodedSize);
    encoder.writeUint32(0);
  };
  var kVideoFrameHandler_OnNewBuffer_Name = 546472086;
  var kVideoFrameHandler_OnFrameReadyInBuffer_Name = 769584150;
  var kVideoFrameHandler_OnBufferRetired_Name = 1791707452;
  var kVideoFrameHandler_OnError_Name = 183701123;
  var kVideoFrameHandler_OnFrameDropped_Name = 662827378;
  var kVideoFrameHandler_OnLog_Name = 545355730;
  var kVideoFrameHandler_OnStarted_Name = 1115482927;
  var kVideoFrameHandler_OnStartedUsingGpuDecode_Name = 1593968211;
  var kVideoFrameHandler_OnStopped_Name = 1492949907;

  function VideoFrameHandlerPtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(VideoFrameHandler,
                                                   handleOrPtrInfo);
  }

  function VideoFrameHandlerAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        VideoFrameHandler, associatedInterfacePtrInfo);
  }

  VideoFrameHandlerAssociatedPtr.prototype =
      Object.create(VideoFrameHandlerPtr.prototype);
  VideoFrameHandlerAssociatedPtr.prototype.constructor =
      VideoFrameHandlerAssociatedPtr;

  function VideoFrameHandlerProxy(receiver) {
    this.receiver_ = receiver;
  }
  VideoFrameHandlerPtr.prototype.onNewBuffer = function() {
    return VideoFrameHandlerProxy.prototype.onNewBuffer
        .apply(this.ptr.getProxy(), arguments);
  };

  VideoFrameHandlerProxy.prototype.onNewBuffer = function(bufferId, bufferHandle) {
    var params_ = new VideoFrameHandler_OnNewBuffer_Params();
    params_.bufferId = bufferId;
    params_.bufferHandle = bufferHandle;
    var builder = new codec.MessageV0Builder(
        kVideoFrameHandler_OnNewBuffer_Name,
        codec.align(VideoFrameHandler_OnNewBuffer_Params.encodedSize));
    builder.encodeStruct(VideoFrameHandler_OnNewBuffer_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  VideoFrameHandlerPtr.prototype.onFrameReadyInBuffer = function() {
    return VideoFrameHandlerProxy.prototype.onFrameReadyInBuffer
        .apply(this.ptr.getProxy(), arguments);
  };

  VideoFrameHandlerProxy.prototype.onFrameReadyInBuffer = function(bufferId, frameFeedbackId, accessPermission, frameInfo) {
    var params_ = new VideoFrameHandler_OnFrameReadyInBuffer_Params();
    params_.bufferId = bufferId;
    params_.frameFeedbackId = frameFeedbackId;
    params_.accessPermission = accessPermission;
    params_.frameInfo = frameInfo;
    var builder = new codec.MessageV0Builder(
        kVideoFrameHandler_OnFrameReadyInBuffer_Name,
        codec.align(VideoFrameHandler_OnFrameReadyInBuffer_Params.encodedSize));
    builder.encodeStruct(VideoFrameHandler_OnFrameReadyInBuffer_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  VideoFrameHandlerPtr.prototype.onBufferRetired = function() {
    return VideoFrameHandlerProxy.prototype.onBufferRetired
        .apply(this.ptr.getProxy(), arguments);
  };

  VideoFrameHandlerProxy.prototype.onBufferRetired = function(bufferId) {
    var params_ = new VideoFrameHandler_OnBufferRetired_Params();
    params_.bufferId = bufferId;
    var builder = new codec.MessageV0Builder(
        kVideoFrameHandler_OnBufferRetired_Name,
        codec.align(VideoFrameHandler_OnBufferRetired_Params.encodedSize));
    builder.encodeStruct(VideoFrameHandler_OnBufferRetired_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  VideoFrameHandlerPtr.prototype.onError = function() {
    return VideoFrameHandlerProxy.prototype.onError
        .apply(this.ptr.getProxy(), arguments);
  };

  VideoFrameHandlerProxy.prototype.onError = function(error) {
    var params_ = new VideoFrameHandler_OnError_Params();
    params_.error = error;
    var builder = new codec.MessageV0Builder(
        kVideoFrameHandler_OnError_Name,
        codec.align(VideoFrameHandler_OnError_Params.encodedSize));
    builder.encodeStruct(VideoFrameHandler_OnError_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  VideoFrameHandlerPtr.prototype.onFrameDropped = function() {
    return VideoFrameHandlerProxy.prototype.onFrameDropped
        .apply(this.ptr.getProxy(), arguments);
  };

  VideoFrameHandlerProxy.prototype.onFrameDropped = function(reason) {
    var params_ = new VideoFrameHandler_OnFrameDropped_Params();
    params_.reason = reason;
    var builder = new codec.MessageV0Builder(
        kVideoFrameHandler_OnFrameDropped_Name,
        codec.align(VideoFrameHandler_OnFrameDropped_Params.encodedSize));
    builder.encodeStruct(VideoFrameHandler_OnFrameDropped_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  VideoFrameHandlerPtr.prototype.onLog = function() {
    return VideoFrameHandlerProxy.prototype.onLog
        .apply(this.ptr.getProxy(), arguments);
  };

  VideoFrameHandlerProxy.prototype.onLog = function(message) {
    var params_ = new VideoFrameHandler_OnLog_Params();
    params_.message = message;
    var builder = new codec.MessageV0Builder(
        kVideoFrameHandler_OnLog_Name,
        codec.align(VideoFrameHandler_OnLog_Params.encodedSize));
    builder.encodeStruct(VideoFrameHandler_OnLog_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  VideoFrameHandlerPtr.prototype.onStarted = function() {
    return VideoFrameHandlerProxy.prototype.onStarted
        .apply(this.ptr.getProxy(), arguments);
  };

  VideoFrameHandlerProxy.prototype.onStarted = function() {
    var params_ = new VideoFrameHandler_OnStarted_Params();
    var builder = new codec.MessageV0Builder(
        kVideoFrameHandler_OnStarted_Name,
        codec.align(VideoFrameHandler_OnStarted_Params.encodedSize));
    builder.encodeStruct(VideoFrameHandler_OnStarted_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  VideoFrameHandlerPtr.prototype.onStartedUsingGpuDecode = function() {
    return VideoFrameHandlerProxy.prototype.onStartedUsingGpuDecode
        .apply(this.ptr.getProxy(), arguments);
  };

  VideoFrameHandlerProxy.prototype.onStartedUsingGpuDecode = function() {
    var params_ = new VideoFrameHandler_OnStartedUsingGpuDecode_Params();
    var builder = new codec.MessageV0Builder(
        kVideoFrameHandler_OnStartedUsingGpuDecode_Name,
        codec.align(VideoFrameHandler_OnStartedUsingGpuDecode_Params.encodedSize));
    builder.encodeStruct(VideoFrameHandler_OnStartedUsingGpuDecode_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };
  VideoFrameHandlerPtr.prototype.onStopped = function() {
    return VideoFrameHandlerProxy.prototype.onStopped
        .apply(this.ptr.getProxy(), arguments);
  };

  VideoFrameHandlerProxy.prototype.onStopped = function() {
    var params_ = new VideoFrameHandler_OnStopped_Params();
    var builder = new codec.MessageV0Builder(
        kVideoFrameHandler_OnStopped_Name,
        codec.align(VideoFrameHandler_OnStopped_Params.encodedSize));
    builder.encodeStruct(VideoFrameHandler_OnStopped_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };

  function VideoFrameHandlerStub(delegate) {
    this.delegate_ = delegate;
  }
  VideoFrameHandlerStub.prototype.onNewBuffer = function(bufferId, bufferHandle) {
    return this.delegate_ && this.delegate_.onNewBuffer && this.delegate_.onNewBuffer(bufferId, bufferHandle);
  }
  VideoFrameHandlerStub.prototype.onFrameReadyInBuffer = function(bufferId, frameFeedbackId, accessPermission, frameInfo) {
    return this.delegate_ && this.delegate_.onFrameReadyInBuffer && this.delegate_.onFrameReadyInBuffer(bufferId, frameFeedbackId, accessPermission, frameInfo);
  }
  VideoFrameHandlerStub.prototype.onBufferRetired = function(bufferId) {
    return this.delegate_ && this.delegate_.onBufferRetired && this.delegate_.onBufferRetired(bufferId);
  }
  VideoFrameHandlerStub.prototype.onError = function(error) {
    return this.delegate_ && this.delegate_.onError && this.delegate_.onError(error);
  }
  VideoFrameHandlerStub.prototype.onFrameDropped = function(reason) {
    return this.delegate_ && this.delegate_.onFrameDropped && this.delegate_.onFrameDropped(reason);
  }
  VideoFrameHandlerStub.prototype.onLog = function(message) {
    return this.delegate_ && this.delegate_.onLog && this.delegate_.onLog(message);
  }
  VideoFrameHandlerStub.prototype.onStarted = function() {
    return this.delegate_ && this.delegate_.onStarted && this.delegate_.onStarted();
  }
  VideoFrameHandlerStub.prototype.onStartedUsingGpuDecode = function() {
    return this.delegate_ && this.delegate_.onStartedUsingGpuDecode && this.delegate_.onStartedUsingGpuDecode();
  }
  VideoFrameHandlerStub.prototype.onStopped = function() {
    return this.delegate_ && this.delegate_.onStopped && this.delegate_.onStopped();
  }

  VideoFrameHandlerStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kVideoFrameHandler_OnNewBuffer_Name:
      var params = reader.decodeStruct(VideoFrameHandler_OnNewBuffer_Params);
      this.onNewBuffer(params.bufferId, params.bufferHandle);
      return true;
    case kVideoFrameHandler_OnFrameReadyInBuffer_Name:
      var params = reader.decodeStruct(VideoFrameHandler_OnFrameReadyInBuffer_Params);
      this.onFrameReadyInBuffer(params.bufferId, params.frameFeedbackId, params.accessPermission, params.frameInfo);
      return true;
    case kVideoFrameHandler_OnBufferRetired_Name:
      var params = reader.decodeStruct(VideoFrameHandler_OnBufferRetired_Params);
      this.onBufferRetired(params.bufferId);
      return true;
    case kVideoFrameHandler_OnError_Name:
      var params = reader.decodeStruct(VideoFrameHandler_OnError_Params);
      this.onError(params.error);
      return true;
    case kVideoFrameHandler_OnFrameDropped_Name:
      var params = reader.decodeStruct(VideoFrameHandler_OnFrameDropped_Params);
      this.onFrameDropped(params.reason);
      return true;
    case kVideoFrameHandler_OnLog_Name:
      var params = reader.decodeStruct(VideoFrameHandler_OnLog_Params);
      this.onLog(params.message);
      return true;
    case kVideoFrameHandler_OnStarted_Name:
      var params = reader.decodeStruct(VideoFrameHandler_OnStarted_Params);
      this.onStarted();
      return true;
    case kVideoFrameHandler_OnStartedUsingGpuDecode_Name:
      var params = reader.decodeStruct(VideoFrameHandler_OnStartedUsingGpuDecode_Params);
      this.onStartedUsingGpuDecode();
      return true;
    case kVideoFrameHandler_OnStopped_Name:
      var params = reader.decodeStruct(VideoFrameHandler_OnStopped_Params);
      this.onStopped();
      return true;
    default:
      return false;
    }
  };

  VideoFrameHandlerStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    default:
      return false;
    }
  };

  function validateVideoFrameHandlerRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kVideoFrameHandler_OnNewBuffer_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = VideoFrameHandler_OnNewBuffer_Params;
      break;
      case kVideoFrameHandler_OnFrameReadyInBuffer_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = VideoFrameHandler_OnFrameReadyInBuffer_Params;
      break;
      case kVideoFrameHandler_OnBufferRetired_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = VideoFrameHandler_OnBufferRetired_Params;
      break;
      case kVideoFrameHandler_OnError_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = VideoFrameHandler_OnError_Params;
      break;
      case kVideoFrameHandler_OnFrameDropped_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = VideoFrameHandler_OnFrameDropped_Params;
      break;
      case kVideoFrameHandler_OnLog_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = VideoFrameHandler_OnLog_Params;
      break;
      case kVideoFrameHandler_OnStarted_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = VideoFrameHandler_OnStarted_Params;
      break;
      case kVideoFrameHandler_OnStartedUsingGpuDecode_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = VideoFrameHandler_OnStartedUsingGpuDecode_Params;
      break;
      case kVideoFrameHandler_OnStopped_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = VideoFrameHandler_OnStopped_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validateVideoFrameHandlerResponse(messageValidator) {
    return validator.validationError.NONE;
  }

  var VideoFrameHandler = {
    name: 'video_capture.mojom.VideoFrameHandler',
    kVersion: 0,
    ptrClass: VideoFrameHandlerPtr,
    proxyClass: VideoFrameHandlerProxy,
    stubClass: VideoFrameHandlerStub,
    validateRequest: validateVideoFrameHandlerRequest,
    validateResponse: null,
    mojomId: 'services/video_capture/public/mojom/video_frame_handler.mojom',
    fuzzMethods: {
      onNewBuffer: {
        params: VideoFrameHandler_OnNewBuffer_Params,
      },
      onFrameReadyInBuffer: {
        params: VideoFrameHandler_OnFrameReadyInBuffer_Params,
      },
      onBufferRetired: {
        params: VideoFrameHandler_OnBufferRetired_Params,
      },
      onError: {
        params: VideoFrameHandler_OnError_Params,
      },
      onFrameDropped: {
        params: VideoFrameHandler_OnFrameDropped_Params,
      },
      onLog: {
        params: VideoFrameHandler_OnLog_Params,
      },
      onStarted: {
        params: VideoFrameHandler_OnStarted_Params,
      },
      onStartedUsingGpuDecode: {
        params: VideoFrameHandler_OnStartedUsingGpuDecode_Params,
      },
      onStopped: {
        params: VideoFrameHandler_OnStopped_Params,
      },
    },
  };
  VideoFrameHandlerStub.prototype.validator = validateVideoFrameHandlerRequest;
  VideoFrameHandlerProxy.prototype.validator = null;
  exports.VideoFrameHandler = VideoFrameHandler;
  exports.VideoFrameHandlerPtr = VideoFrameHandlerPtr;
  exports.VideoFrameHandlerAssociatedPtr = VideoFrameHandlerAssociatedPtr;
})();