// third_party/blink/public/mojom/conversions/conversions.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'third_party/blink/public/mojom/conversions/conversions.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('blink.mojom');
  var origin$ =
      mojo.internal.exposeNamespace('url.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'url/mojom/origin.mojom', '../../../../../url/mojom/origin.mojom.js');
  }



  function Conversion(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  Conversion.prototype.initDefaults_ = function() {
    this.reportingOrigin = null;
    this.conversionData = 0;
  };
  Conversion.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  Conversion.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 24}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate Conversion.reportingOrigin
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 0, origin$.Origin, false);
    if (err !== validator.validationError.NONE)
        return err;


    return validator.validationError.NONE;
  };

  Conversion.encodedSize = codec.kStructHeaderSize + 16;

  Conversion.decode = function(decoder) {
    var packed;
    var val = new Conversion();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.reportingOrigin =
        decoder.decodeStructPointer(origin$.Origin);
    val.conversionData =
        decoder.decodeStruct(codec.Uint64);
    return val;
  };

  Conversion.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(Conversion.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStructPointer(origin$.Origin, val.reportingOrigin);
    encoder.encodeStruct(codec.Uint64, val.conversionData);
  };
  function ConversionHost_RegisterConversion_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  ConversionHost_RegisterConversion_Params.prototype.initDefaults_ = function() {
    this.conversion = null;
  };
  ConversionHost_RegisterConversion_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  ConversionHost_RegisterConversion_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate ConversionHost_RegisterConversion_Params.conversion
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 0, Conversion, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  ConversionHost_RegisterConversion_Params.encodedSize = codec.kStructHeaderSize + 8;

  ConversionHost_RegisterConversion_Params.decode = function(decoder) {
    var packed;
    var val = new ConversionHost_RegisterConversion_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.conversion =
        decoder.decodeStructPointer(Conversion);
    return val;
  };

  ConversionHost_RegisterConversion_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(ConversionHost_RegisterConversion_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStructPointer(Conversion, val.conversion);
  };
  var kConversionHost_RegisterConversion_Name = 0;

  function ConversionHostPtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(ConversionHost,
                                                   handleOrPtrInfo);
  }

  function ConversionHostAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        ConversionHost, associatedInterfacePtrInfo);
  }

  ConversionHostAssociatedPtr.prototype =
      Object.create(ConversionHostPtr.prototype);
  ConversionHostAssociatedPtr.prototype.constructor =
      ConversionHostAssociatedPtr;

  function ConversionHostProxy(receiver) {
    this.receiver_ = receiver;
  }
  ConversionHostPtr.prototype.registerConversion = function() {
    return ConversionHostProxy.prototype.registerConversion
        .apply(this.ptr.getProxy(), arguments);
  };

  ConversionHostProxy.prototype.registerConversion = function(conversion) {
    var params_ = new ConversionHost_RegisterConversion_Params();
    params_.conversion = conversion;
    var builder = new codec.MessageV0Builder(
        kConversionHost_RegisterConversion_Name,
        codec.align(ConversionHost_RegisterConversion_Params.encodedSize));
    builder.encodeStruct(ConversionHost_RegisterConversion_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };

  function ConversionHostStub(delegate) {
    this.delegate_ = delegate;
  }
  ConversionHostStub.prototype.registerConversion = function(conversion) {
    return this.delegate_ && this.delegate_.registerConversion && this.delegate_.registerConversion(conversion);
  }

  ConversionHostStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kConversionHost_RegisterConversion_Name:
      var params = reader.decodeStruct(ConversionHost_RegisterConversion_Params);
      this.registerConversion(params.conversion);
      return true;
    default:
      return false;
    }
  };

  ConversionHostStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    default:
      return false;
    }
  };

  function validateConversionHostRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kConversionHost_RegisterConversion_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = ConversionHost_RegisterConversion_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validateConversionHostResponse(messageValidator) {
    return validator.validationError.NONE;
  }

  var ConversionHost = {
    name: 'blink.mojom.ConversionHost',
    kVersion: 0,
    ptrClass: ConversionHostPtr,
    proxyClass: ConversionHostProxy,
    stubClass: ConversionHostStub,
    validateRequest: validateConversionHostRequest,
    validateResponse: null,
  };
  ConversionHostStub.prototype.validator = validateConversionHostRequest;
  ConversionHostProxy.prototype.validator = null;
  exports.Conversion = Conversion;
  exports.ConversionHost = ConversionHost;
  exports.ConversionHostPtr = ConversionHostPtr;
  exports.ConversionHostAssociatedPtr = ConversionHostAssociatedPtr;
})();