// third_party/blink/public/mojom/feature_policy/policy_value.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'third_party/blink/public/mojom/feature_policy/policy_value.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('blink.mojom');


  var PolicyValueType = {};
  PolicyValueType.kNull = 0;
  PolicyValueType.kBool = PolicyValueType.kNull + 1;
  PolicyValueType.kDecDouble = PolicyValueType.kBool + 1;
  PolicyValueType.MIN_VALUE = 0,
  PolicyValueType.MAX_VALUE = 2,

  PolicyValueType.isKnownEnumValue = function(value) {
    switch (value) {
    case 0:
    case 1:
    case 2:
      return true;
    }
    return false;
  };

  PolicyValueType.validate = function(enumValue) {
    var isExtensible = false;
    if (isExtensible || this.isKnownEnumValue(enumValue))
      return validator.validationError.NONE;

    return validator.validationError.UNKNOWN_ENUM_VALUE;
  };

  function PolicyValue(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  PolicyValue.prototype.initDefaults_ = function() {
    this.data = null;
  };
  PolicyValue.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  PolicyValue.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 24}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate PolicyValue.data
    err = messageValidator.validateUnion(offset + codec.kStructHeaderSize + 0, PolicyValueData, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  PolicyValue.encodedSize = codec.kStructHeaderSize + 16;

  PolicyValue.decode = function(decoder) {
    var packed;
    var val = new PolicyValue();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.data =
        decoder.decodeStruct(PolicyValueData);
    return val;
  };

  PolicyValue.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(PolicyValue.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(PolicyValueData, val.data);
  };

  function PolicyValueData(value) {
    this.initDefault_();
    this.initValue_(value);
  }


  PolicyValueData.Tags = {
    nullValue: 0,
    boolValue: 1,
    decDoubleValue: 2,
  };

  PolicyValueData.prototype.initDefault_ = function() {
    this.$data = null;
    this.$tag = undefined;
  }

  PolicyValueData.prototype.initValue_ = function(value) {
    if (value == undefined) {
      return;
    }

    var keys = Object.keys(value);
    if (keys.length == 0) {
      return;
    }

    if (keys.length > 1) {
      throw new TypeError("You may set only one member on a union.");
    }

    var fields = [
        "nullValue",
        "boolValue",
        "decDoubleValue",
    ];

    if (fields.indexOf(keys[0]) < 0) {
      throw new ReferenceError(keys[0] + " is not a PolicyValueData member.");

    }

    this[keys[0]] = value[keys[0]];
  }
  Object.defineProperty(PolicyValueData.prototype, "nullValue", {
    get: function() {
      if (this.$tag != PolicyValueData.Tags.nullValue) {
        throw new ReferenceError(
            "PolicyValueData.nullValue is not currently set.");
      }
      return this.$data;
    },

    set: function(value) {
      this.$tag = PolicyValueData.Tags.nullValue;
      this.$data = value;
    }
  });
  Object.defineProperty(PolicyValueData.prototype, "boolValue", {
    get: function() {
      if (this.$tag != PolicyValueData.Tags.boolValue) {
        throw new ReferenceError(
            "PolicyValueData.boolValue is not currently set.");
      }
      return this.$data;
    },

    set: function(value) {
      this.$tag = PolicyValueData.Tags.boolValue;
      this.$data = value;
    }
  });
  Object.defineProperty(PolicyValueData.prototype, "decDoubleValue", {
    get: function() {
      if (this.$tag != PolicyValueData.Tags.decDoubleValue) {
        throw new ReferenceError(
            "PolicyValueData.decDoubleValue is not currently set.");
      }
      return this.$data;
    },

    set: function(value) {
      this.$tag = PolicyValueData.Tags.decDoubleValue;
      this.$data = value;
    }
  });


    PolicyValueData.encode = function(encoder, val) {
      if (val == null) {
        encoder.writeUint64(0);
        encoder.writeUint64(0);
        return;
      }
      if (val.$tag == undefined) {
        throw new TypeError("Cannot encode unions with an unknown member set.");
      }

      encoder.writeUint32(16);
      encoder.writeUint32(val.$tag);
      switch (val.$tag) {
        case PolicyValueData.Tags.nullValue:
          encoder.writeUint8(val.nullValue ? 1 : 0);
          break;
        case PolicyValueData.Tags.boolValue:
          encoder.writeUint8(val.boolValue ? 1 : 0);
          break;
        case PolicyValueData.Tags.decDoubleValue:
          encoder.encodeStruct(codec.Double, val.decDoubleValue);
          break;
      }
      encoder.align();
    };


    PolicyValueData.decode = function(decoder) {
      var size = decoder.readUint32();
      if (size == 0) {
        decoder.readUint32();
        decoder.readUint64();
        return null;
      }

      var result = new PolicyValueData();
      var tag = decoder.readUint32();
      switch (tag) {
        case PolicyValueData.Tags.nullValue:
          result.nullValue = decoder.readUint8() ? true : false;
          break;
        case PolicyValueData.Tags.boolValue:
          result.boolValue = decoder.readUint8() ? true : false;
          break;
        case PolicyValueData.Tags.decDoubleValue:
          result.decDoubleValue = decoder.decodeStruct(codec.Double);
          break;
      }
      decoder.align();

      return result;
    };


    PolicyValueData.validate = function(messageValidator, offset) {
      var size = messageValidator.decodeUnionSize(offset);
      if (size != 16) {
        return validator.validationError.INVALID_UNION_SIZE;
      }

      var tag = messageValidator.decodeUnionTag(offset);
      var data_offset = offset + 8;
      var err;
      switch (tag) {
        case PolicyValueData.Tags.nullValue:
          

          break;
        case PolicyValueData.Tags.boolValue:
          

          break;
        case PolicyValueData.Tags.decDoubleValue:
          

          break;
      }

      return validator.validationError.NONE;
    };

  PolicyValueData.encodedSize = 16;
  exports.PolicyValueType = PolicyValueType;
  exports.PolicyValue = PolicyValue;
  exports.PolicyValueData = PolicyValueData;
})();