// third_party/blink/public/mojom/frame/navigation_initiator.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'third_party/blink/public/mojom/frame/navigation_initiator.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('blink.mojom');
  var content_security_policy$ =
      mojo.internal.exposeNamespace('network.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'services/network/public/mojom/content_security_policy.mojom', '../../../../../services/network/public/mojom/content_security_policy.mojom.js');
  }



  function NavigationInitiator_SendViolationReport_Params(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  NavigationInitiator_SendViolationReport_Params.prototype.initDefaults_ = function() {
    this.violation = null;
  };
  NavigationInitiator_SendViolationReport_Params.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  NavigationInitiator_SendViolationReport_Params.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate NavigationInitiator_SendViolationReport_Params.violation
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 0, content_security_policy$.CSPViolation, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  NavigationInitiator_SendViolationReport_Params.encodedSize = codec.kStructHeaderSize + 8;

  NavigationInitiator_SendViolationReport_Params.decode = function(decoder) {
    var packed;
    var val = new NavigationInitiator_SendViolationReport_Params();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.violation =
        decoder.decodeStructPointer(content_security_policy$.CSPViolation);
    return val;
  };

  NavigationInitiator_SendViolationReport_Params.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(NavigationInitiator_SendViolationReport_Params.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStructPointer(content_security_policy$.CSPViolation, val.violation);
  };
  var kNavigationInitiator_SendViolationReport_Name = 1687917587;

  function NavigationInitiatorPtr(handleOrPtrInfo) {
    this.ptr = new bindings.InterfacePtrController(NavigationInitiator,
                                                   handleOrPtrInfo);
  }

  function NavigationInitiatorAssociatedPtr(associatedInterfacePtrInfo) {
    this.ptr = new associatedBindings.AssociatedInterfacePtrController(
        NavigationInitiator, associatedInterfacePtrInfo);
  }

  NavigationInitiatorAssociatedPtr.prototype =
      Object.create(NavigationInitiatorPtr.prototype);
  NavigationInitiatorAssociatedPtr.prototype.constructor =
      NavigationInitiatorAssociatedPtr;

  function NavigationInitiatorProxy(receiver) {
    this.receiver_ = receiver;
  }
  NavigationInitiatorPtr.prototype.sendViolationReport = function() {
    return NavigationInitiatorProxy.prototype.sendViolationReport
        .apply(this.ptr.getProxy(), arguments);
  };

  NavigationInitiatorProxy.prototype.sendViolationReport = function(violation) {
    var params_ = new NavigationInitiator_SendViolationReport_Params();
    params_.violation = violation;
    var builder = new codec.MessageV0Builder(
        kNavigationInitiator_SendViolationReport_Name,
        codec.align(NavigationInitiator_SendViolationReport_Params.encodedSize));
    builder.encodeStruct(NavigationInitiator_SendViolationReport_Params, params_);
    var message = builder.finish();
    this.receiver_.accept(message);
  };

  function NavigationInitiatorStub(delegate) {
    this.delegate_ = delegate;
  }
  NavigationInitiatorStub.prototype.sendViolationReport = function(violation) {
    return this.delegate_ && this.delegate_.sendViolationReport && this.delegate_.sendViolationReport(violation);
  }

  NavigationInitiatorStub.prototype.accept = function(message) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    case kNavigationInitiator_SendViolationReport_Name:
      var params = reader.decodeStruct(NavigationInitiator_SendViolationReport_Params);
      this.sendViolationReport(params.violation);
      return true;
    default:
      return false;
    }
  };

  NavigationInitiatorStub.prototype.acceptWithResponder =
      function(message, responder) {
    var reader = new codec.MessageReader(message);
    switch (reader.messageName) {
    default:
      return false;
    }
  };

  function validateNavigationInitiatorRequest(messageValidator) {
    var message = messageValidator.message;
    var paramsClass = null;
    switch (message.getName()) {
      case kNavigationInitiator_SendViolationReport_Name:
        if (!message.expectsResponse() && !message.isResponse())
          paramsClass = NavigationInitiator_SendViolationReport_Params;
      break;
    }
    if (paramsClass === null)
      return validator.validationError.NONE;
    return paramsClass.validate(messageValidator, messageValidator.message.getHeaderNumBytes());
  }

  function validateNavigationInitiatorResponse(messageValidator) {
    return validator.validationError.NONE;
  }

  var NavigationInitiator = {
    name: 'blink.mojom.NavigationInitiator',
    kVersion: 0,
    ptrClass: NavigationInitiatorPtr,
    proxyClass: NavigationInitiatorProxy,
    stubClass: NavigationInitiatorStub,
    validateRequest: validateNavigationInitiatorRequest,
    validateResponse: null,
  };
  NavigationInitiatorStub.prototype.validator = validateNavigationInitiatorRequest;
  NavigationInitiatorProxy.prototype.validator = null;
  exports.NavigationInitiator = NavigationInitiator;
  exports.NavigationInitiatorPtr = NavigationInitiatorPtr;
  exports.NavigationInitiatorAssociatedPtr = NavigationInitiatorAssociatedPtr;
})();