// third_party/blink/public/mojom/input/input_handler.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'third_party/blink/public/mojom/input/input_handler.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('blink.mojom');
  var overscroll_behavior$ =
      mojo.internal.exposeNamespace('cc.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'cc/mojom/overscroll_behavior.mojom', '../../../../../cc/mojom/overscroll_behavior.mojom.js');
  }
  var touch_action$ =
      mojo.internal.exposeNamespace('cc.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'cc/mojom/touch_action.mojom', '../../../../../cc/mojom/touch_action.mojom.js');
  }
  var geometry$ =
      mojo.internal.exposeNamespace('gfx.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'ui/gfx/geometry/mojom/geometry.mojom', '../../../../../ui/gfx/geometry/mojom/geometry.mojom.js');
  }



  function DidOverscrollParams(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  DidOverscrollParams.prototype.initDefaults_ = function() {
    this.accumulatedOverscroll = null;
    this.latestOverscrollDelta = null;
    this.currentFlingVelocity = null;
    this.causalEventViewportPoint = null;
    this.overscrollBehavior = null;
  };
  DidOverscrollParams.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  DidOverscrollParams.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 48}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate DidOverscrollParams.accumulatedOverscroll
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 0, geometry$.Vector2dF, false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate DidOverscrollParams.latestOverscrollDelta
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 8, geometry$.Vector2dF, false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate DidOverscrollParams.currentFlingVelocity
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 16, geometry$.Vector2dF, false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate DidOverscrollParams.causalEventViewportPoint
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 24, geometry$.PointF, false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate DidOverscrollParams.overscrollBehavior
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 32, overscroll_behavior$.OverscrollBehavior, false);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  DidOverscrollParams.encodedSize = codec.kStructHeaderSize + 40;

  DidOverscrollParams.decode = function(decoder) {
    var packed;
    var val = new DidOverscrollParams();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.accumulatedOverscroll =
        decoder.decodeStructPointer(geometry$.Vector2dF);
    val.latestOverscrollDelta =
        decoder.decodeStructPointer(geometry$.Vector2dF);
    val.currentFlingVelocity =
        decoder.decodeStructPointer(geometry$.Vector2dF);
    val.causalEventViewportPoint =
        decoder.decodeStructPointer(geometry$.PointF);
    val.overscrollBehavior =
        decoder.decodeStructPointer(overscroll_behavior$.OverscrollBehavior);
    return val;
  };

  DidOverscrollParams.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(DidOverscrollParams.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStructPointer(geometry$.Vector2dF, val.accumulatedOverscroll);
    encoder.encodeStructPointer(geometry$.Vector2dF, val.latestOverscrollDelta);
    encoder.encodeStructPointer(geometry$.Vector2dF, val.currentFlingVelocity);
    encoder.encodeStructPointer(geometry$.PointF, val.causalEventViewportPoint);
    encoder.encodeStructPointer(overscroll_behavior$.OverscrollBehavior, val.overscrollBehavior);
  };
  function TouchActionOptional(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  TouchActionOptional.prototype.initDefaults_ = function() {
    this.touchAction = 0;
  };
  TouchActionOptional.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  TouchActionOptional.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 16}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TouchActionOptional.touchAction
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 0, touch_action$.TouchAction);
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  TouchActionOptional.encodedSize = codec.kStructHeaderSize + 8;

  TouchActionOptional.decode = function(decoder) {
    var packed;
    var val = new TouchActionOptional();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.touchAction =
        decoder.decodeStruct(codec.Int32);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  TouchActionOptional.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(TouchActionOptional.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.Int32, val.touchAction);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  function EditCommand(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  EditCommand.prototype.initDefaults_ = function() {
    this.name = null;
    this.value = null;
  };
  EditCommand.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  EditCommand.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 24}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate EditCommand.name
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 0, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate EditCommand.value
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 8, false)
    if (err !== validator.validationError.NONE)
        return err;

    return validator.validationError.NONE;
  };

  EditCommand.encodedSize = codec.kStructHeaderSize + 16;

  EditCommand.decode = function(decoder) {
    var packed;
    var val = new EditCommand();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.name =
        decoder.decodeStruct(codec.String);
    val.value =
        decoder.decodeStruct(codec.String);
    return val;
  };

  EditCommand.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(EditCommand.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(codec.String, val.name);
    encoder.encodeStruct(codec.String, val.value);
  };
  exports.DidOverscrollParams = DidOverscrollParams;
  exports.TouchActionOptional = TouchActionOptional;
  exports.EditCommand = EditCommand;
})();