// third_party/blink/public/mojom/messaging/transferable_message.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'third_party/blink/public/mojom/messaging/transferable_message.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('blink.mojom');
  var bitmap$ =
      mojo.internal.exposeNamespace('skia.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'skia/public/mojom/bitmap.mojom', '../../../../../skia/public/mojom/bitmap.mojom.js');
  }
  var array_buffer_contents$ =
      mojo.internal.exposeNamespace('blink.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'third_party/blink/public/mojom/array_buffer/array_buffer_contents.mojom', '../array_buffer/array_buffer_contents.mojom.js');
  }
  var serialized_blob$ =
      mojo.internal.exposeNamespace('blink.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'third_party/blink/public/mojom/blob/serialized_blob.mojom', '../blob/serialized_blob.mojom.js');
  }
  var cloneable_message$ =
      mojo.internal.exposeNamespace('blink.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'third_party/blink/public/mojom/messaging/cloneable_message.mojom', 'cloneable_message.mojom.js');
  }
  var message_port_descriptor$ =
      mojo.internal.exposeNamespace('blink.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'third_party/blink/public/mojom/messaging/message_port_descriptor.mojom', 'message_port_descriptor.mojom.js');
  }
  var user_activation_snapshot$ =
      mojo.internal.exposeNamespace('blink.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'third_party/blink/public/mojom/messaging/user_activation_snapshot.mojom', 'user_activation_snapshot.mojom.js');
  }



  function TransferableMessage(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  TransferableMessage.prototype.initDefaults_ = function() {
    this.message = null;
    this.ports = null;
    this.streamChannels = null;
    this.arrayBufferContentsArray = null;
    this.imageBitmapContentsArray = null;
    this.userActivation = null;
    this.transferUserActivation = false;
    this.allowAutoplay = false;
  };
  TransferableMessage.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };

  TransferableMessage.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 64}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TransferableMessage.message
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 0, cloneable_message$.CloneableMessage, false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TransferableMessage.ports
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 8, 8, new codec.PointerTo(message_port_descriptor$.MessagePortDescriptor), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TransferableMessage.streamChannels
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 16, 8, new codec.PointerTo(message_port_descriptor$.MessagePortDescriptor), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TransferableMessage.arrayBufferContentsArray
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 24, 8, new codec.PointerTo(array_buffer_contents$.SerializedArrayBufferContents), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TransferableMessage.imageBitmapContentsArray
    err = messageValidator.validateArrayPointer(offset + codec.kStructHeaderSize + 32, 8, new codec.PointerTo(bitmap$.Bitmap), false, [0], 0);
    if (err !== validator.validationError.NONE)
        return err;


    // validate TransferableMessage.userActivation
    err = messageValidator.validateStructPointer(offset + codec.kStructHeaderSize + 40, user_activation_snapshot$.UserActivationSnapshot, true);
    if (err !== validator.validationError.NONE)
        return err;



    return validator.validationError.NONE;
  };

  TransferableMessage.encodedSize = codec.kStructHeaderSize + 56;

  TransferableMessage.decode = function(decoder) {
    var packed;
    var val = new TransferableMessage();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.message =
        decoder.decodeStructPointer(cloneable_message$.CloneableMessage);
    val.ports =
        decoder.decodeArrayPointer(new codec.PointerTo(message_port_descriptor$.MessagePortDescriptor));
    val.streamChannels =
        decoder.decodeArrayPointer(new codec.PointerTo(message_port_descriptor$.MessagePortDescriptor));
    val.arrayBufferContentsArray =
        decoder.decodeArrayPointer(new codec.PointerTo(array_buffer_contents$.SerializedArrayBufferContents));
    val.imageBitmapContentsArray =
        decoder.decodeArrayPointer(new codec.PointerTo(bitmap$.Bitmap));
    val.userActivation =
        decoder.decodeStructPointer(user_activation_snapshot$.UserActivationSnapshot);
    packed = decoder.readUint8();
    val.transferUserActivation = (packed >> 0) & 1 ? true : false;
    val.allowAutoplay = (packed >> 1) & 1 ? true : false;
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    return val;
  };

  TransferableMessage.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(TransferableMessage.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStructPointer(cloneable_message$.CloneableMessage, val.message);
    encoder.encodeArrayPointer(new codec.PointerTo(message_port_descriptor$.MessagePortDescriptor), val.ports);
    encoder.encodeArrayPointer(new codec.PointerTo(message_port_descriptor$.MessagePortDescriptor), val.streamChannels);
    encoder.encodeArrayPointer(new codec.PointerTo(array_buffer_contents$.SerializedArrayBufferContents), val.arrayBufferContentsArray);
    encoder.encodeArrayPointer(new codec.PointerTo(bitmap$.Bitmap), val.imageBitmapContentsArray);
    encoder.encodeStructPointer(user_activation_snapshot$.UserActivationSnapshot, val.userActivation);
    packed = 0;
    packed |= (val.transferUserActivation & 1) << 0
    packed |= (val.allowAutoplay & 1) << 1
    encoder.writeUint8(packed);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
  };
  exports.TransferableMessage = TransferableMessage;
})();