// ui/accessibility/mojom/ax_tree_data.mojom.js is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

'use strict';

(function() {
  var mojomId = 'ui/accessibility/mojom/ax_tree_data.mojom';
  if (mojo.internal.isMojomLoaded(mojomId)) {
    console.warn('The following mojom is loaded multiple times: ' + mojomId);
    return;
  }
  mojo.internal.markMojomLoaded(mojomId);
  var bindings = mojo;
  var associatedBindings = mojo;
  var codec = mojo.internal;
  var validator = mojo.internal;

  var exports = mojo.internal.exposeNamespace('ax.mojom');
  var ax_enums$ =
      mojo.internal.exposeNamespace('ax.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'ui/accessibility/ax_enums.mojom', '../ax_enums.mojom.js');
  }
  var ax_tree_id$ =
      mojo.internal.exposeNamespace('ax.mojom');
  if (mojo.config.autoLoadMojomDeps) {
    mojo.internal.loadMojomIfNecessary(
        'ui/accessibility/mojom/ax_tree_id.mojom', 'ax_tree_id.mojom.js');
  }



  function AXTreeData(values) {
    this.initDefaults_();
    this.initFields_(values);
  }


  AXTreeData.prototype.initDefaults_ = function() {
    this.treeId = null;
    this.parentTreeId = null;
    this.focusedTreeId = null;
    this.doctype = null;
    this.loaded = false;
    this.selIsBackward = false;
    this.loadingProgress = 0;
    this.mimetype = null;
    this.title = null;
    this.url = null;
    this.focusId = 0;
    this.selAnchorObjectId = 0;
    this.selAnchorOffset = 0;
    this.selAnchorAffinity = 0;
    this.selFocusObjectId = 0;
    this.selFocusOffset = 0;
    this.selFocusAffinity = 0;
    this.rootScrollerId = 0;
  };
  AXTreeData.prototype.initFields_ = function(fields) {
    for(var field in fields) {
        if (this.hasOwnProperty(field))
          this[field] = fields[field];
    }
  };
  AXTreeData.generate = function(generator_) {
    var generated = new AXTreeData;
    generated.treeId = generator_.generateUnion(ax.mojom.AXTreeID, false);
    generated.parentTreeId = generator_.generateUnion(ax.mojom.AXTreeID, false);
    generated.focusedTreeId = generator_.generateUnion(ax.mojom.AXTreeID, false);
    generated.doctype = generator_.generateString(false);
    generated.loaded = generator_.generateBool();
    generated.loadingProgress = generator_.generateFloat();
    generated.mimetype = generator_.generateString(false);
    generated.title = generator_.generateString(false);
    generated.url = generator_.generateString(false);
    generated.focusId = generator_.generateInt32();
    generated.selIsBackward = generator_.generateBool();
    generated.selAnchorObjectId = generator_.generateInt32();
    generated.selAnchorOffset = generator_.generateInt32();
    generated.selAnchorAffinity = generator_.generateEnum(0, 2);
    generated.selFocusObjectId = generator_.generateInt32();
    generated.selFocusOffset = generator_.generateInt32();
    generated.selFocusAffinity = generator_.generateEnum(0, 2);
    generated.rootScrollerId = generator_.generateInt32();
    return generated;
  };

  AXTreeData.prototype.mutate = function(mutator_) {
    if (mutator_.chooseMutateField()) {
      this.treeId = mutator_.mutateUnion(this.treeId, ax.mojom.AXTreeID, false);
    }
    if (mutator_.chooseMutateField()) {
      this.parentTreeId = mutator_.mutateUnion(this.parentTreeId, ax.mojom.AXTreeID, false);
    }
    if (mutator_.chooseMutateField()) {
      this.focusedTreeId = mutator_.mutateUnion(this.focusedTreeId, ax.mojom.AXTreeID, false);
    }
    if (mutator_.chooseMutateField()) {
      this.doctype = mutator_.mutateString(this.doctype, false);
    }
    if (mutator_.chooseMutateField()) {
      this.loaded = mutator_.mutateBool(this.loaded);
    }
    if (mutator_.chooseMutateField()) {
      this.loadingProgress = mutator_.mutateFloat(this.loadingProgress);
    }
    if (mutator_.chooseMutateField()) {
      this.mimetype = mutator_.mutateString(this.mimetype, false);
    }
    if (mutator_.chooseMutateField()) {
      this.title = mutator_.mutateString(this.title, false);
    }
    if (mutator_.chooseMutateField()) {
      this.url = mutator_.mutateString(this.url, false);
    }
    if (mutator_.chooseMutateField()) {
      this.focusId = mutator_.mutateInt32(this.focusId);
    }
    if (mutator_.chooseMutateField()) {
      this.selIsBackward = mutator_.mutateBool(this.selIsBackward);
    }
    if (mutator_.chooseMutateField()) {
      this.selAnchorObjectId = mutator_.mutateInt32(this.selAnchorObjectId);
    }
    if (mutator_.chooseMutateField()) {
      this.selAnchorOffset = mutator_.mutateInt32(this.selAnchorOffset);
    }
    if (mutator_.chooseMutateField()) {
      this.selAnchorAffinity = mutator_.mutateEnum(this.selAnchorAffinity, 0, 2);
    }
    if (mutator_.chooseMutateField()) {
      this.selFocusObjectId = mutator_.mutateInt32(this.selFocusObjectId);
    }
    if (mutator_.chooseMutateField()) {
      this.selFocusOffset = mutator_.mutateInt32(this.selFocusOffset);
    }
    if (mutator_.chooseMutateField()) {
      this.selFocusAffinity = mutator_.mutateEnum(this.selFocusAffinity, 0, 2);
    }
    if (mutator_.chooseMutateField()) {
      this.rootScrollerId = mutator_.mutateInt32(this.rootScrollerId);
    }
    return this;
  };
  AXTreeData.prototype.getHandleDeps = function() {
    var handles = [];
    return handles;
  };

  AXTreeData.prototype.setHandles = function() {
    this.setHandlesInternal_(arguments, 0);
  };
  AXTreeData.prototype.setHandlesInternal_ = function(handles, idx) {
    return idx;
  };

  AXTreeData.validate = function(messageValidator, offset) {
    var err;
    err = messageValidator.validateStructHeader(offset, codec.kStructHeaderSize);
    if (err !== validator.validationError.NONE)
        return err;

    var kVersionSizes = [
      {version: 0, numBytes: 128}
    ];
    err = messageValidator.validateStructVersion(offset, kVersionSizes);
    if (err !== validator.validationError.NONE)
        return err;


    // validate AXTreeData.treeId
    err = messageValidator.validateUnion(offset + codec.kStructHeaderSize + 0, ax_tree_id$.AXTreeID, false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate AXTreeData.parentTreeId
    err = messageValidator.validateUnion(offset + codec.kStructHeaderSize + 16, ax_tree_id$.AXTreeID, false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate AXTreeData.focusedTreeId
    err = messageValidator.validateUnion(offset + codec.kStructHeaderSize + 32, ax_tree_id$.AXTreeID, false);
    if (err !== validator.validationError.NONE)
        return err;


    // validate AXTreeData.doctype
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 48, false)
    if (err !== validator.validationError.NONE)
        return err;




    // validate AXTreeData.mimetype
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 64, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate AXTreeData.title
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 72, false)
    if (err !== validator.validationError.NONE)
        return err;


    // validate AXTreeData.url
    err = messageValidator.validateStringPointer(offset + codec.kStructHeaderSize + 80, false)
    if (err !== validator.validationError.NONE)
        return err;






    // validate AXTreeData.selAnchorAffinity
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 100, ax_enums$.TextAffinity);
    if (err !== validator.validationError.NONE)
        return err;




    // validate AXTreeData.selFocusAffinity
    err = messageValidator.validateEnum(offset + codec.kStructHeaderSize + 112, ax_enums$.TextAffinity);
    if (err !== validator.validationError.NONE)
        return err;


    return validator.validationError.NONE;
  };

  AXTreeData.encodedSize = codec.kStructHeaderSize + 120;

  AXTreeData.decode = function(decoder) {
    var packed;
    var val = new AXTreeData();
    var numberOfBytes = decoder.readUint32();
    var version = decoder.readUint32();
    val.treeId =
        decoder.decodeStruct(ax_tree_id$.AXTreeID);
    val.parentTreeId =
        decoder.decodeStruct(ax_tree_id$.AXTreeID);
    val.focusedTreeId =
        decoder.decodeStruct(ax_tree_id$.AXTreeID);
    val.doctype =
        decoder.decodeStruct(codec.String);
    packed = decoder.readUint8();
    val.loaded = (packed >> 0) & 1 ? true : false;
    val.selIsBackward = (packed >> 1) & 1 ? true : false;
    decoder.skip(1);
    decoder.skip(1);
    decoder.skip(1);
    val.loadingProgress =
        decoder.decodeStruct(codec.Float);
    val.mimetype =
        decoder.decodeStruct(codec.String);
    val.title =
        decoder.decodeStruct(codec.String);
    val.url =
        decoder.decodeStruct(codec.String);
    val.focusId =
        decoder.decodeStruct(codec.Int32);
    val.selAnchorObjectId =
        decoder.decodeStruct(codec.Int32);
    val.selAnchorOffset =
        decoder.decodeStruct(codec.Int32);
    val.selAnchorAffinity =
        decoder.decodeStruct(codec.Int32);
    val.selFocusObjectId =
        decoder.decodeStruct(codec.Int32);
    val.selFocusOffset =
        decoder.decodeStruct(codec.Int32);
    val.selFocusAffinity =
        decoder.decodeStruct(codec.Int32);
    val.rootScrollerId =
        decoder.decodeStruct(codec.Int32);
    return val;
  };

  AXTreeData.encode = function(encoder, val) {
    var packed;
    encoder.writeUint32(AXTreeData.encodedSize);
    encoder.writeUint32(0);
    encoder.encodeStruct(ax_tree_id$.AXTreeID, val.treeId);
    encoder.encodeStruct(ax_tree_id$.AXTreeID, val.parentTreeId);
    encoder.encodeStruct(ax_tree_id$.AXTreeID, val.focusedTreeId);
    encoder.encodeStruct(codec.String, val.doctype);
    packed = 0;
    packed |= (val.loaded & 1) << 0
    packed |= (val.selIsBackward & 1) << 1
    encoder.writeUint8(packed);
    encoder.skip(1);
    encoder.skip(1);
    encoder.skip(1);
    encoder.encodeStruct(codec.Float, val.loadingProgress);
    encoder.encodeStruct(codec.String, val.mimetype);
    encoder.encodeStruct(codec.String, val.title);
    encoder.encodeStruct(codec.String, val.url);
    encoder.encodeStruct(codec.Int32, val.focusId);
    encoder.encodeStruct(codec.Int32, val.selAnchorObjectId);
    encoder.encodeStruct(codec.Int32, val.selAnchorOffset);
    encoder.encodeStruct(codec.Int32, val.selAnchorAffinity);
    encoder.encodeStruct(codec.Int32, val.selFocusObjectId);
    encoder.encodeStruct(codec.Int32, val.selFocusOffset);
    encoder.encodeStruct(codec.Int32, val.selFocusAffinity);
    encoder.encodeStruct(codec.Int32, val.rootScrollerId);
  };
  exports.AXTreeData = AXTreeData;
})();